2016-12-18  Thomas Schwinge  <thomas@codesourcery.com>

	GNU Hurd 0.9
	* configure.ac (AC_INIT): Set version to 0.9.
	* NEWS: Finalize for 0.9.

2016-12-17  Thomas Schwinge  <thomas@codesourcery.com>

	Fix "random" ChangeLog handling
	..., so that the correct things get done for "make dist".

	* ChangeLog: Elaborate on "random".
	* Makefile (gitlog-to-changelog_rev, ChangeLog_specs): Add entries
	for "random".
	(gen-ChangeLog): Handle that.

2016-12-17  Thomas Schwinge  <thomas@codesourcery.com>

	Fix "procfs" ChangeLog handling
	..., so that the correct things get done for "make dist".

	* procfs/ChangeLog: Merge file into...
	* ChangeLog: ... this one, and elaborate some more.
	* Makefile (gen_start_commit, ChangeLog_files): Merge into...
	(ChangeLog_specs): ... this new variable.
	(ChangeLog_files): Rewrite in terms of that one.
	(gitlog-to-changelog_rev, ChangeLog_specs): Add entries for
	"procfs".
	(gen-ChangeLog): Handle that.

2016-12-17  Thomas Schwinge  <thomas@codesourcery.com>

	* Makefile (gen-ChangeLog): Remove ChangeLog files first.

	* Makefile (gen-ChangeLog): Remove incomplete "distdir" support.

2016-12-10  Justus Winter  <justus@gnupg.org>

	Update NEWS file

	Remove support for the deprecated external memory interface.
	* libpager/stubs.c (_pager_S_memory_object_data_write): Drop stub.
	* mach-defpager/default_pager.c (seqnos_memory_object_data_write):
	Drop function.

2016-11-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libports: fix using ports.h in C++
	class is a reserved keyword, event when imported inside extern "C" { }

	* libports/ports.h (port_info) [__cplusplus]: Rename `class' field to
	`port_class'.
	(ports_create_port, ports_create_port_noinstall, ports_import_port,
	ports_lookup_port, ports_lookup_payload, ports_count_class,
	ports_enable_class, ports_class_iterate, _ports_bucket_class_iterate,
	ports_inhibit_class_rpcs, ports_resume_class_rpcs): Rename `class'
	parameter to `port_class'.
	[!__cplusplus] (ports_lookup_payload, ports_payload_get_name): Do not
	define extern inlines.

2016-11-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	refcount: Fix usage in c++
	g++ still doens't support non-trivial named initializers (sigh)

	* libshouldbeinlibc/refcount.h (REFCOUNT_REFERENCES): New macro.
	(refcounts_init, refcounts_unsafe_ref, refcounts_deref,
	refcounts_promote, refcounts_demote, refcounts_unsafe_ref_weak,
	refcounts_deref_weak): Use REFCOUNT_REFERENCES instead of explicit
	initializer.

2016-11-20  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix boot startup
	* boot/boot.c (S_processor_set_tasks): Do not always return 0.

	Fix build
	* libpager/pager-memcpy.c (pager_memcpy): Pass 1 as second parameter to
	sigsetjmp.
	* libstore/memobj.c (memobj_memcpy): Likewise.

	boot: fix crash when S_processor_set_tasks is called early
	* boot/boot.c (S_processor_set_tasks): Return empty array when
	task_ihash.nr_items is still 0.

	ext2fs: Use more POSIXish error code
	* ext2fs/dir.c (diskfs_direnter_hard): On missing room to extend
	directory, return ENOSPC.

	ext2fs: Do not talk about crashing on ENOSPC
	* ext2fs/pager.c (pager_unlock_page): Do not say that ext2fs will crash
	because of ENOSPC.

2016-11-20  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libpager, libstore: Fix crash on ENOSPC while writing data
	We need to save blocked signals, otherwise longjmp will not unblock
	SIGSEGV/SIGBUS, and thus next exception will kill us. Also, we need to
	make sure that the preemptor is set at the right window in main memory
	before letting a handler see it.

	* libpager/pager-memcpy.c (do_memcpy): Call __sync_synchronize()
	between aligning the fault preemptor and actually accessing data.
	(fault): Use siglongjmp instead of longjmp.
	(pager_memcpy): Use sigsetjmp instead of setjmp.
	* libstore/memobj.c (copy, fault, memobj_memcpy): Likewise.

2016-11-20  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	ext2fs: Fix crash on ENOSPC while extending a directory
	* ext2fs/dir.c (diskfs_direnter_hard): Call hurd_safe_memset on
	directory extension before using it, to actually reserve room.

2016-11-14  Brent W. Baccala  <cosine@freesoft.org>

	libpager: fix returning error on data_unlock
	The _pager_lock_object call needs to be asynchronous because libpager is
	single threaded, at least in the sense that individual memory objects
	only process one request at a time.  In this case, we're processing a
	data_unlock request, and would have to handle a lock_completed message
	before lock_object would return (synchronously).

	* libpager/data-unlock.c (_pager_S_memory_object_data_unlock): Pass 0 to
	sync parameter of _pager_lock_object() call.

2016-11-06  Justus Winter  <justus@gnupg.org>

	mach-defpager: Fix daemonization.
	* mach-defpager/main.c (main): Do not hang if the child dies.

2016-11-05  Justus Winter  <justus@gnupg.org>

	boot: Improve device pass-through.
	Previously, the device file was opened once at startup time.  This is
	fragile, as the remote server might die.  Open it at device open time
	instead.

	* boot/boot.c (options): Improve documentation.
	(struct dev_map): Rename fields, document, store the name of the
	device file instead of a port.
	(add_dev_map): Update accordingly.
	(lookup_dev): Likewise.
	(ds_device_open): Open the device file here instead.

2016-11-05  Justus Winter  <justus@gnupg.org>

	eth-multiplexer: Generate stable ethernet addresses.
	Previously, the ethernet multiplexer generated ethernet addresses for
	the virtual interfaces using a pseudo-random number generator.  This
	has the downside of generating a new address every time.  Generate
	stable pseudo-random addresses instead.

	* eth-multiplexer/Makefile (HURDLIBS): Link to libihash.
	* eth-multiplexer/ethernet.c (ether_address): New variable.
	(get_ethernet_address): New function.
	(ethernet_open): Get the ethernet address of the real interface.
	* eth-multiplexer/ethernet.h (ether_address): New declaration.
	* eth-multiplexer/vdev.c (add_vdev): Compute the ethernet address by
	hashing the address of the real interface with the name of the virtual
	interface.

2016-11-05  Justus Winter  <justus@gnupg.org>

	eth-multiplexer: Avoid local definitions.
	* eth-multiplexer/util.h: Include 'net/if_ether.h'.
	(ETH_ALEN): Drop.
	(struct ethhdr): Likewise.
	* eth-multiplexer/vdev.c: Include 'net/if_ether.h'.
	(ETH_HLEN): Drop.

2016-11-05  Justus Winter  <justus@gnupg.org>

	eth-multiplexer: Fix retrieving status of virtual interfaces.
	Previously, the ethernet multiplexer returned the status of the real
	network device if one was configured.  This had the unfortunate
	consequence that all virtual devices shared the same ethernet address.

	* eth-multiplexer/device_impl.c (ds_device_get_status): Always return
	the information for the virtual device.
	* eth-multiplexer/vdev.h (dev_getstat): Add prototype.

2016-11-05  Justus Winter  <justus@gnupg.org>

	eth-multiplexer: Fix packet delivery.
	* eth-multiplexer/vdev.c (deliver_msg): Do not return an error if
	delivering a message fails.  Doing so prevents all other filters from
	being executed, and more importantly aborts the iteration over all
	virtual devices.

2016-11-04  Zheng Da  <zhengda1936@gmail.com>

	eth-multiplexer: Merge the eth-multiplexer.
	* Makefile (prog-subdirs): Add the new program.
	* NEWS: Update.
	* eth-multiplexer/ChangeLog: New file.
	* eth-multiplexer/Makefile: Likewise.
	* eth-multiplexer/README: Likewise.
	* eth-multiplexer/demuxer.c: Likewise.
	* eth-multiplexer/dev_stat.c: Likewise.
	* eth-multiplexer/device_impl.c: Likewise.
	* eth-multiplexer/ethernet.c: Likewise.
	* eth-multiplexer/ethernet.h: Likewise.
	* eth-multiplexer/mig-decls.h: Likewise.
	* eth-multiplexer/mig-mutate.h: Likewise.
	* eth-multiplexer/multiplexer.c: Likewise.
	* eth-multiplexer/netfs_impl.c: Likewise.
	* eth-multiplexer/netfs_impl.h: Likewise.
	* eth-multiplexer/notify_impl.c: Likewise.
	* eth-multiplexer/test.c: Likewise.
	* eth-multiplexer/util.h: Likewise.
	* eth-multiplexer/vdev.c: Likewise.
	* eth-multiplexer/vdev.h: Likewise.

	The eth-multiplexer has been written by Zheng Da.  This merges his
	work into the main repository.

2016-11-04  Zheng Da  <zhengda1936@gmail.com>

	libbpf: Merge the Berkeley Packet Filter library.
	* Makefile (lib-subdirs): Add new library.
	* NEWS: Update.
	* libbpf/Makefile: New file.
	* libbpf/bpf_impl.c: Likewise.
	* libbpf/bpf_impl.h: Likewise.
	* libbpf/queue.c: Likewise.
	* libbpf/queue.h: Likewise.
	* libbpf/util.h: Likewise.

	The Berkeley Packet Filter implementation has been extracted from the
	Mach kernel by Zheng Da.  This merges his work into the main
	repository.

2016-11-01  Justus Winter  <justus@gnupg.org>

	Adjust to the fixed new task notifications.
	* boot/boot.c (S_mach_notify_new_task): The send rights are now indeed
	moved to the target task, adjust accordingly.
	* proc/mgt.c (S_mach_notify_new_task): Likewise.

	boot: Tidy up the argument parser.
	* boot/boot.c (options): Group options together.  Do not end help
	texts with a colon.
	(args_doc): Remove variable.
	(main): Group the store options together.

	boot: Add a default boot script.
	* boot/boot.c (OPT_BOOT_SCRIPT): New macro.
	(options): Add flag '--boot-script'.
	(args_doc): Do not expect the script as positional argument.
	(parse_opt): Handle new flag, do not expect the script as positional
	argument.
	(read_boot_script): New function.
	(default_boot_script): New variable containing a boot script capable
	of booting contemporary Hurd systems.
	(main): Use the new function to read the boot script, or fall back to
	using the builtin one.

2016-11-01  Justus Winter  <justus@gnupg.org>

	boot: Allow unprivileged users to boot Subhurds.
	Previously, boot handed privileged kernel ports to Subhurds.  This
	made boot unusable for unprivileged users, and allowed Subhurds to
	wreak havoc on the whole system.  Fix this by handing out pseudo ports
	instead of the privileged ports.

	* NEWS: Update.
	* boot/Makefile (MIGSTUBS): Build stubs for the new kernel interfaces.
	(MIGSFLAGS): Include mutation file.
	(HURDLIBS): Link against libihash.
	* boot/boot.c (privileged, want_privileged): New variables.
	(pseudo_privileged_host_port): New variable.
	(pseudo_pset, pseudo_kernel): Likewise.
	(task_notification_port): Likewise.
	(dead_task_notification_port): Likewise.
	(boot_demuxer): Handle new protocols.
	(OPT_PRIVILEGED): New macro.
	(options): Add flag '--privileged' to enable the old mode.
	(parse_opt): Handle new flag.
	(allocate_pseudo_ports): New function.
	(main): Handle new flag.  If not running privileged, allocate more
	pseudo ports to hand out in place of privileged kernel ports, create a
	task namespace, and a task that the Subhurd can frob instead of the
	real kernel task.
	(do_mach_notify_dead_name): Handle dying tasks.
	(S_vm_set_default_memory_manager): New function.
	(S_host_reboot): Likewise.
	(S_host_processor_set_priv): Likewise.
	(S_register_new_task_notification): Likewise.
	(task_ihash_cleanup): Likewise.
	(task_ihash): New variable.
	(task_died): New function.
	(S_mach_notify_new_task): Likewise.
	(S_processor_set_tasks): Likewise.
	* boot/mig-decls.h: New file.
	* boot/mig-mutate.h: Likewise.

2016-11-01  Justus Winter  <4winter@informatik.uni-hamburg.de>

	boot: restore terminal state on exit
	* boot/boot.c (host_exit): Make it a function and restore the terminal state.

2016-11-01  Justus Winter  <justus@gnupg.org>

	boot: Move bootscript callbacks.
	* boot/boot.c (useropen, load_image, boot_script_exec_cmd): Move...
	* boot/userland-boot.c: ... here.

	boot: Quote arguments containing spaces.
	* boot/boot.c (boot_script_exec_cmd): Quote arguments containing
	spaces.

	boot: Use the smallest possible name when inserting rights.
	* boot/userland-boot.c (boot_script_insert_right): Use the smallest
	possible name instead of the local name.

	startup: Dump processes if we cannot find the kernel.
	* startup/startup.c (dump_processes): New function.
	(frob_kerne_process): Use the new function.

2016-11-01  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add missing spinlock initializers
	Thanks Agustina Arzille for the report

	* ext2fs/ext2fs.h (global_lock, modified_global_blocks_lock): Declare
	extern
	* ext2fs/ext2fs.c (global_lock, modified_global_blocks_lock): Define and
	initialize to PTHREAD_SPINLOCK_INITIALIZER.
	* libtreefs/xinl.c (treefs_node_refcnt_lock): Likewise.

2016-11-01  Justus Winter  <justus@gnupg.org>

	boot: Remove hacks for running boot on UX.
	* boot/Makefile (COMMON-OBJS): Do not build server stubs for the
	bootstrap protocol.
	Remove all UX-related variables and targets.
	* boot/boot.c: Remove all UX-related definitions and includes.
	* boot/frank1.ld: Delete file.
	* boot/frankemul.ld: Likewise.
	* boot/mach-crt0.c: Likewise.
	* boot/sigvec.S: Likewise.
	* boot/syscall.S: Likewise.
	* boot/ux.c: Likewise.
	* boot/ux.h: Likewise.

	proc: Fix new task notifications.
	* proc/mgt.c (S_mach_notify_new_task): Fix receiver handling, fix port
	leak.
	* proc/mig-mutate.h: Mutate the task notification protocol.

2016-10-31  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libdiskfs: Factorize code for last hard reference being released
	* libdiskfs/node-lastref.c: New file
	* libdiskfs/Makefile (OTHERSRCS): Add node-lastref.c
	* libdiskfs/libdiskfs/node-nput.c (diskfs_nput): Replace last hard reference
	code with a call to _diskfs_lastref.
	* libdiskfs/node-nrele.c (diskfs_nrele): Likewise.

2016-10-31  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libdiskfs: fix removal of socket nodes
	Follow-up on 5ab5d98fa515cd19a64e8d5868fcbae85eec9dc5 ('libdiskfs: fix
	removal of socket nodes'), for diskfs_nrele.

	* libdiskfs/node-nrele.c (diskfs_nrele): Deallocate right to socket
	address when cleaning light references.

2016-10-30  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Mark library stubs as weak
	So that static linking of e.g. console.static can work.

	* libdiskfs/io-stubs.c (diskfs_S_io_readsleep, diskfs_S_io_eofnotify,
	diskfs_S_io_postnotify, diskfs_S_io_readnotify): Mark weak.
	* libnetfs/fsstubs.c (netfs_S_file_notice_changes, netfs_S_file_getfh,
	netfs_S_ifsock_getsockaddr): Likewise.
	* libnetfs/fsysstubs.c (netfs_S_fsys_getfile: netfs_S_fsys_getpriv,
	netfs_S_fsys_init, netfs_S_fsys_forward, netfs_S_fsys_startup):
	Likewise.
	* libpager/stubs.c (_pager_S_memory_object_copy,
	_pager_S_memory_object_data_write,
	_pager_S_memory_object_supply_completed): Likewise.
	* libtrivfs/fsys-stubs.c (trivfs_S_fsys_startup, trivfs_S_fsys_getpriv,
	trivfs_S_fsys_init, trivfs_S_fsys_getfile): Likewise.
	* libtrivfs/io-stubs.c (trivfs_S_io_map_cntl, trivfs_S_io_get_conch,
	trivfs_S_io_release_conch, trivfs_S_io_eofnotify, trivfs_S_io_prenotify,
	trivfs_S_io_postnotify, trivfs_S_io_readsleep, trivfs_S_io_sigio,
	trivfs_S_io_readnotify): Likewise.

2016-10-30  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	wire console display pages
	to work around improper handling of getting paged out.

	* console/display.c (user_create): Call vm_wire() on the created user data.

2016-10-29  Brent W. Baccala  <cosine@freesoft.org>

	Fix typo
	* utils/rpctrace.c: Fix typo.

2016-10-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libdiskfs: Make utimes RPC flush pending timestamp updates
	Thanks Kalle Olavi Niemitalo for the notice.

	* libdiskfs/file-utimes.c (diskfs_S_file_utimes): Call diskfs_set_node_times
	before setting node timestamps.

2016-10-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libdiskfs: Fix timestamp update on file close
	* libdiskfs/node-nrele.c (diskfs_nrele): Call diskfs_set_node_times when
	there are no hard refs any more, like diskfs_nput does.

2016-10-15  Justus Winter  <justus@gnupg.org>

	boot: Ignore EINTR.
	* boot/boot.c (main): Ignore EINTR in the loop processing stdin.

	Avoid warnings if increasing a threads priority fails.
	* libports/manage-multithread.c (adjust_priorities): Avoid displaying
	error messages if we do not have the privileged processor set port by
	treating this error condition like EPERM.
	* proc/main.c (increase_priority, main): Likewise.

	procfs: Gracefully degrade meminfo.
	* procfs/rootdir.c (rootdir_gc_meminfo): Just omit the swap
	information if the default pager is unreachable.

2016-10-10  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix some RPC request headers #ifdef guards
	by fixing the subsystem name into containing _request.

	* hurd/auth_request.defs: Set subsystem name to auth_request.
	* hurd/io_request.defs: Set subsystem name to io_request.
	* hurd/process_request.defs: Set subsystem name to process_request.

2016-10-09  Justus Winter  <justus@gnupg.org>

	fshelp: Fix fetching the control port.
	* libfshelp/fetch-control.c (fshelp_fetch_control): Check if the
	control port is still alive, or deallocate the dead name, record the
	fact in the transbox, and return MACH_PORT_NULL.

	console-client: Remove unused variable.
	* console-client/trans.c (console_setup_node): Remove 'bootstrap'.

	ext2fs: Poison pointers into dereferenced cache pages.
	* ext2fs/ext2fs.h (disk_cache_block_deref): Replace with a macro that
	NULLs the given pointer.
	(dino_deref): Likewise.
	* ext2fs/pager.c (disk_cache_block_deref): Rename.
	* ext2fs/pokel.c (pokel_add): Adapt.
	(pokel_exec): Likewise.

2016-10-08  Justus Winter  <justus@gnupg.org>

	ext2fs: Rename parameter.
	* ext2fs/ext2fs.h (sync_global_pointer): Rename 'bptr' so that it
	doesn't collide with the macro 'bptr'.

2016-10-05  Justus Winter  <justus@gnupg.org>

	trans/crash: Fix setting core file template at runtime.
	* trans/crash.c (corefile_template_lock): New variable.
	(S_crash_dump_task): Serialize access to 'corefile_template'.
	(parse_opt): Likewise.  Also strdup the template.
	(trivfs_append_args): Serialize access to 'corefile_template'.

	trans/crash: Use empty core file templates to disable the feature.
	* trans/crash.c (parse_opt): Use empty core file templates to disable
	the feature.

	Avoid fatal error handling in option parsers.
	* trans/crash.c (parse_opt): Avoid 'error' in favor of the appropriate
	argp error reporting mechanism.
	* trans/remap.c (parse_opt): Likewise.
	* utils/msgids.c (parse_opt): Likewise.

2016-10-03  Justus Winter  <justus@gnupg.org>

	ext2fs: Disable option to specify alternate superblock.
	* ext2fs/ext2fs.c (options): Disable '--sblock', this has never been
	implemented.
	(parse_opt): Likewise.

2016-10-03  Justus Winter  <justus@gnupg.org>

	libdiskfs: Fix short-circuiting translators.
	* libdiskfs/file-set-trans.c (diskfs_S_file_set_translator): When
	setting a short-circuited translator, clear the translator record
	first.  Improve error handling.

	This notably fixes a crash in ext2fs when setting a symlink on a node
	with an existing translator record.

2016-09-17  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	fakeroot: set FAKED_MODE
	* utils/fakeroot.sh (FAKED_MODE): Set to unknown-is-root.

2016-09-06  Justus Winter  <justus@gnupg.org>

	random: Hash continuous areas in the csprng pool.
	* random/gnupg-random.c (mix_pool): Store the first hash at the end of
	the pool.

	--

	This fixes a long standing bug (since 1998) in Libgcrypt and GnuPG.
	An attacker who obtains 580 bytes of the random number from the
	standard RNG can trivially predict the next 20 bytes of output.

	The bug was found and reported by Felix Dörre and Vladimir Klebanov,
	Karlsruhe Institute of Technology.  A paper describing the problem in
	detail will shortly be published.

	This is a port of c6dbfe89 from the GnuPG classic branch.

	CVE-id: CVE-2016-6313

2016-09-04  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix patch to runsystem.hurd
	* init/init.c (main): Run /libexec/runsystem.hurd instead of
	/etc/hurd/runsystem.hurd.

	Fix installing runsystem.hurd
	* daemons/runsystem.hurd: Rename to daemons/runsystem.hurd.sh
	* daemons/Makefile (targets): Add runsystem.hurd
	(special-targets): Likewise.
	(runsystem.hurd): New rule, simply depends on runsystem.hurd.sh

2016-09-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libfshelp: acquire references to control ports
	* libfshelp/translator-list.c (translator_ihash_cleanup): Release reference.
	(fshelp_set_active_translator): Acquire reference

2016-09-01  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix looping over runsystem possibilities
	* startup/startup.c (launch_something): Always increment TRY even on
	success, so that if runsystem unexpectedly returns, we get to try a shell
	instead.

2016-09-01  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	startup: Fix looping over runsystem
	Thanks Brent W. Baccala for the report.

	* starpu/startup.c (launch_something): Always increment TRY while looping
	over runsystem possibilities.

2016-08-31  Brent W. Baccala  <cosine@freesoft.org>

	exec: Fix loading binaries without a memory manager object
	Falling back from the io_map method needs to handle the "anywhere" flag too
	by updating MAPSTART.

	* exec/exec.c (write_to_task): Turn MAPSTART parameter into a reference to
	the address.  Fix usage accordingly.
	(load_section): Pass address of MAPSTART to write_to_task so it can update
	it.

2016-08-30  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix message about not being able to request shutdown notification
	It is just a warning, not a fatal error.

	* libdiskfs/init-startup.c (_diskfs_init_completed): Prefix warning about
	requesting shutdown nofication with "warning:".
	* random/random.c (main): Likewise.

2016-08-28  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix exec crash when setexecdata has never been called
	or called with a small array.

	This notably happens when using a sub-exec, see BZ #48919.

	* exec/hashexec.c (check_hashbang): Check std_nports before accessing
	std_ports.

2016-08-28  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	typo

	remap: Refuse non-absolute paths
	* trans/remap.c (parse_opt): Error out if some path is not absolute.

2016-08-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix loading small pic programs
	It happens that the link script for ld.so contains a hole, which might thus
	leave an empty page between the text and the data.  When loading a small pic
	program, its text would then fit in there, and loading the data right after
	it would fail.  We here rather force all pic loads to be mapped
	contiguously, starting from the place that was allocated for the first pic
	load.

	* exec/exec.c (load_section): Return the address of the end of the section.
	(load): Take the address to be used for loading pic objects as parameter,
	force pic objects there if it is not zero, and compute and return the
	address to be used for the next pic object.
	(do_exec): Pass addresses for pic loads between calls to load().

2016-08-23  Kalle Olavi Niemitalo  <kon@iki.fi>

	rpctrace: Print beyond '\0' in MACH_MSG_TYPE_CHAR.
	This will now display the 'argv: data_t' argument of file_exec
	as e.g. "who\0am\0i\0" rather than just "who".  In contrast,
	the 'file_name: string_t' argument of dir_lookup will still be
	truncated at the first null character.

	The previous implementation might crash if an out-of-line
	char array exactly fills a page and does not contain any
	null characters.

	* utils/rpctrace.c (print_data): On MACH_MSG_TYPE_STRING and
	MACH_MSG_TYPE_CHAR, check for end of buffer before checking for a null
	character.  On MACH_MSG_TYPE_CHAR only, continue printing past null
	characters.

2016-08-20  Brent W. Baccala  <cosine@freesoft.org>

	mach-defpager: Add missing unlock
	* mach-defpager/default_pager.c (destroy_paging_partition): Add missing
	unlock when destroying partition fails.

	mach-defpager: Fix debugging prints formats
	* mach-defpager/default_pager.c (pager_dealloc_page, pager_read_offset,
	pager_write_offset, default_read, default_write, destroy_paging_partition,
	seqnos_memory_object_terminate, seqnos_memory_object_data_request,
	seqnos_memory_object_data_initialize): Fix debugging prints formats.

2016-08-16  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Drop OTILDE support
	It was used long ago, poses problems to readline, and currently conflicts
	with TAB1

	Thanks Kalle Olavi Niemitalo for the report and rationale

	* term/munge.c (output_character): Do not handle OTILDE.
	(output_width): Likewise.
	* term/term.h (OTILDE): Drop macro definition.
	* term/users.c (open_hook): Do not check OTILDE flag.

2016-08-09  Justus Winter  <justus@gnupg.org>

	trans/crash: core file name templates
	Add an option to specify a template used to construct core file names.
	This way core files can be collected at a predictable central
	location.

	* hurd/crash.defs (crash_dump_task): Return EEXIST if the core file
	has been written elsewhere.
	* trans/crash.c (corefile_template): New variable.
	(template_valid): New function.
	(template_make_file_name): Likewise.
	(S_crash_dump_task): Use the template to construct a name, open the
	file, and write the core dump there instead of the handle provided by
	the caller.
	(argp_option): New option.
	(doc): Document the format.
	(parse_opt): Handle new option
	(trivfs_append_args): Likewise.

2016-08-09  Christian Seiler  <christian@iwakd.de>

	Support MSG_DONTWAIT in pflocal send/recv
	* pflocal/socket.c (S_socket_send): Also test for MSG_DONTWAIT in `flags'
	for the `noblock' parameter of pipe_send call.
	(S_socket_recv): Likewise for pipe_recv call.

2016-08-09  Justus Winter  <justus@gnupg.org>

	sutils: New utility 'bless'.
	* sutils/Makefile (progs): Add 'bless'.
	* sutils/bless.c: New file.

2016-08-08  Justus Winter  <justus@gnupg.org>

	proc: Fix permission check.
	* proc/mgt.c (S_proc_mark_important): Fix checking whether the
	receiver is a child of startup.

	startup: Make the kernel a child of startup.
	* startup/startup.c (frob_kernel_process): Make the kernel a child of
	startup, improve error reporting.

2016-08-07  Justus Winter  <justus@gnupg.org>

	libpager: provide 'pager_create_alloc'
	Add a variant to 'pager_create' that allocates memory for the user
	hook next to the pager data increasing locality.

	* console/pager.c (pager_clear_user_data): Fix type of 'idx', do not
	free 'upi'.
	(user_pager_create): Use the new function.
	* doc/hurd.texi: Document new function.
	* ext2fs/pager.c (pager_clear_user_data): Don't free 'upi'.
	(diskfs_get_filemap): Use the new function.
	* fatfs/pager.c (pager_clear_user_data): Don't free 'upi'.
	(diskfs_get_filemap): Use the new function.
	* isofs/pager.c (pager_clear_user_data): Don't free 'upi'.
	(diskfs_get_filemap): Use the new function.
	* libpager/pager-create.c (_pager_create): New generic allocation
	function.
	(pager_create): Use the new generic function.
	(pager_create_alloc): New function.
	* libpager/pager.h (pager_create_alloc): New prototype.

2016-08-07  Justus Winter  <justus@gnupg.org>

	proc: Fix references to the startup server.
	* proc/main.c: Fix references to the startup server in code and
	comments.
	* proc/mgt.c: Likewise.
	* proc/msg.c: Likewise.
	* proc/proc.h: Likewise.

2016-06-14  Richard Braun  <rbraun@sceen.net>

	pfinet: fix memory leak
	* pfinet/socket-ops.c (S_socket_recv): Unmap data on error.

2016-06-07  Justus Winter  <justus@gnupg.org>

	trans/crash: fix blunder
	* trans/crash.c (S_crash_dump_task): Fix error handling.

2016-06-04  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Do not make io_select return errors on unsupported READ/WRITE mode
	The descriptor is valid, it is just the mode which is not available.

	* console-client/kbd-repeat.c (repeater_select): Drop SELECT_URG flag from
	`type'.  Return 0 instead of EINVAL if `type' contains SELECT_WRITE.
	* console-client/pc-mouse (repeater_select): Likewise.
	* trans/mtab.c (trivfs_S_io_select): Return 0 instead of EBADF when the
	openmodes do not match the requested modes in `type'.
	* trans/new-fifo.c (io_select_common): Likewise.
	* trans/fifo.c (io_select_common): Likewise.
	* trans/null.c (trivfs_S_io_select): Likewise.
	* trans/streamio.c (io_select_common): Likewise.

2016-06-04  Justus Winter  <justus@gnupg.org>

	trans/crash: fix resource leaks
	Previously, 'task', 'core_file', and 'ctty_id' were not deallocated if
	crash was configured to write core files, and 'ctty_id' was leaked if
	the crashing task was suspended.  This lead to resources not being
	released in the kernel, the filesystem, and the terminal subsystem,
	and could very well be responsible for making the Debian/Hurd shutdown
	hang.

	* trans/crash.c (S_crash_dump_task): Properly deallocate 'task',
	'core_file', and 'ctty_id'.

2016-06-03  Justus Winter  <justus@gnupg.org>

	nfs: appease the stricter reference counting mechanism
	* nfs/cache.c (netfs_node_norefs): Do not re-acquire a reference to
	np.  This worked previously, but the new reference counting primitives
	consider this a use after free.  A reference is really not necessary
	here, we are about to deallocate np anyway.

	Amends 5eef605e.

2016-06-01  Richard Braun  <rbraun@sceen.net>

	Fix pipe_send() with no data
	* libpipe/pipe.c (pipe_send): Set value pointed to by amount to 0 if
	if nothing is written.

2016-05-30  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Complete allocation hooks
	* mach-defpager/kalloc.c (realloc_hook, memalign_hook): New functions.
	(init_hook): Set __realloc_hook to realloc_hook and __memalign_hook to
	memalign_hook.

2016-05-30  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Revert "drop the deprecated malloc/free hooks in hurd/mach-defpager"
	This reverts commit 8c49801c8f7e3f800cabedf8fca8ccec3cf35a22.

	The malloc hook is needed for calloc.

2016-05-23  Thomas Schwinge  <thomas@codesourcery.com>

	Revert part of "fix compiler warnings in hurd/exec"
	This reverts part of commit 05c3ffac543052c8d0b171a5f77bb977d5316a61.  These
	type casts are no longer needed after the commit
	e914bfc3d6e5ddf6f8c5e93a4334873a48a24ddf changes.

	* exec/elfcore.c: Revert type casts added in commit
	05c3ffac543052c8d0b171a5f77bb977d5316a61.

2016-05-23  Thomas Schwinge  <thomas@codesourcery.com>

	Make <sys/procfs.h> self-contained again
	Commit e914bfc3d6e5ddf6f8c5e93a4334873a48a24ddf made <sys/procfs.h>
	Autoconf/configure tests change as follows:

	    checking sys/procfs.h usability... [-yes-]{+no+}
	    checking sys/procfs.h presence... yes
	    {+configure: WARNING: sys/procfs.h: present but cannot be compiled+}
	    {+configure: WARNING: sys/procfs.h:     check for missing prerequisite headers?+}
	    {+configure: WARNING: sys/procfs.h: see the Autoconf documentation+}
	    {+configure: WARNING: sys/procfs.h:     section "Present But Cannot Be Compiled"+}
	    {+configure: WARNING: sys/procfs.h: proceeding with the compiler's result+}
	    checking for sys/procfs.h...[-yes-]{+no+}
	    [-checking for prstatus_t in sys/procfs.h... no-]
	    [-checking for prstatus32_t in sys/procfs.h... no-]
	    [-checking for prstatus_t.pr_who in sys/procfs.h... no-]
	    [-checking for prstatus32_t.pr_who in sys/procfs.h... no-]
	    [-checking for pstatus_t in sys/procfs.h... yes-]
	    [-checking for pxstatus_t in sys/procfs.h... no-]
	    [-checking for pstatus32_t in sys/procfs.h... no-]
	    [-checking for prpsinfo_t in sys/procfs.h... no-]
	    [-checking for prpsinfo_t.pr_pid in sys/procfs.h... no-]
	    [-checking for prpsinfo32_t in sys/procfs.h... no-]
	    [-checking for prpsinfo32_t.pr_pid in sys/procfs.h... no-]
	    [-checking for psinfo_t in sys/procfs.h... yes-]
	    [-checking for psinfo_t.pr_pid in sys/procfs.h... yes-]
	    [-checking for psinfo32_t in sys/procfs.h... no-]
	    [-checking for psinfo32_t.pr_pid in sys/procfs.h... no-]
	    [-checking for lwpstatus_t in sys/procfs.h... yes-]
	    [-checking for lwpxstatus_t in sys/procfs.h... no-]
	    [-checking for lwpstatus_t.pr_context in sys/procfs.h... no-]
	    [-checking for lwpstatus_t.pr_reg in sys/procfs.h... yes-]
	    [-checking for lwpstatus_t.pr_fpreg in sys/procfs.h... yes-]
	    [-checking for win32_pstatus_t in sys/procfs.h... no-]

	That is because of:

	    $ echo '#include <sys/procfs.h>' | gcc -x c - -o /dev/null -S
	    In file included from <stdin>:1:0:
	    /usr/include/sys/procfs.h:66:3: error: unknown type name ‘vm_address_t’
	       vm_address_t pr_argv;  /* Original argument vector address.  */
	       ^
	    /usr/include/sys/procfs.h:67:3: error: unknown type name ‘vm_address_t’
	       vm_address_t pr_envp;  /* Original environment vector address.  */
	       ^

	* include/sys/procfs.h: Include <mach/std_types.h> to make file self-contained
	again.

2016-05-22  Justus Winter  <justus@gnupg.org>

	ext2fs: fix pager use-after-free
	Previously, pagers had no reference for being part of a node, only for
	having a send right made for them.  Hence we sometimes saw
	use-after-free errors if the kernel did give up that send right,
	typically while deleting files.  Keep a weak reference as long as the
	pager is referenced by a node.

	* ext2fs/pager.c (pager_clear_user_data): Assert that 'pager' has been
	NULLed.
	(pager_dropweak): Drop the weak reference and NULL 'pager'.
	(diskfs_get_filemap): Simplify.  Acquire a weak reference.

2016-05-22  Justus Winter  <justus@gnupg.org>

	libdiskfs: fix error handling
	* libdiskfs/dir-rmdir.c (diskfs_S_dir_rmdir): Initialize 'np'.

2016-05-19  Justus Winter  <justus@gnupg.org>

	Avoid superfluous locking of node
	* libdiskfs/io-restrict-auth.c (diskfs_S_io_restrict_auth): Do not
	lock the associated node.  No operation here needs synchronization.
	* libnetfs/io-restrict-auth.c (netfs_S_io_restrict_auth): Likewise.

	utils/settrans: implement active translator stacking
	* utils/settrans.c (OPT_STACK): New macro.
	(options): New option.
	(main): Handle new option.
	(open_node): Use different flags for the lookup of the underlying
	node.

2016-05-19  Justus Winter  <justus@gnupg.org>

	libnetfs: treat disconnected shadow roots as virtual roots
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Treat a shadow_root with
	null shadow_root_parent as a "virtual root".

	Analog to 6875a586.

2016-05-19  Justus Winter  <justus@gnupg.org>

	Unify the short-circuit translator logic
	* libdiskfs/dir-lookup.c (short_circuited_callback1): Move function to
	libfshelp.
	(diskfs_S_dir_lookup): Use the function from libfshelp instead.
	* libdiskfs/fsys-getroot.c (diskfs_S_fsys_getroot): Adapt accordingly.
	* libdiskfs/trans-callback.c (_diskfs_translator_callback2_fn): Likewise.
	* libfshelp/fetch-root.c (fshelp_short_circuited_callback1): New function.
	* libfshelp/fshelp.h (struct fshelp_stat_cookie): New definition.
	(fshelp_short_circuited_callback1): New prototype.
	* libnetfs/dir-lookup.c (short_circuited_callback1): Drop function.
	(netfs_S_dir_lookup): Use the function from libfshelp instead.
	* libnetfs/fsys-getroot.c (netfs_S_fsys_getroot): Adapt accordingly.
	* libnetfs/trans-callback.c (_netfs_translator_callback2_fn): Likewise.

	libdiskfs: cosmetic changes
	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): Rename identifiers to
	be more idiomatic and closer to libnetfs and the interface
	specification.  Massage the code so that it aligns closer with the
	dir_lookup server function in libnetfs.  It should not change the
	behavior.

	libnetfs: rename 'diruser' to 'dircred'
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Rename 'diruser' to
	'dircred'.

	libnetfs: rename 'error' to 'err'
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Rename 'error' to 'err'.

	mach-defpager: fix panic invocation
	* mach-defpager/default_pager.c (default_pager_thread): Fix panic
	invocation.

2016-05-18  Thomas Schwinge  <thomas@codesourcery.com>

	GNU Hurd 0.8
	* configure.ac (AC_INIT): Set version to 0.8.
	* NEWS: Finalize for 0.8.

2016-05-16  Thomas Schwinge  <thomas@codesourcery.com>

	Complete changes to use -L instead of -Wl,-rpath-link
	Changes missing from commit c9c29eb890527fe68900e4a0af7c2df9a9fa5b40.

	* console-client/Makefile (%.so.$(hurd-version)): Use $(lpath) instead of
	$(rpath)
	* libstore/Makefile (libstore_%.so.$(hurd-version)): Likewise.

2016-05-09  Justus Winter  <justus@gnupg.org>

	startup: fix blunder
	Fixes b04364bc.  Thanks to Esa Peuha for spotting this.

	* startup/startup.c (run): Fix blunder.

2016-05-03  Justus Winter  <justus@gnupg.org>

	libihash: enable fast insertions replacing tombstones
	* libihash/ihash.c (hurd_ihash_locp_add): Also replace tombstones.

	libihash: fix corner case
	* libihash/ihash.c (hurd_ihash_locp_find): Set SLOT to NULL if the
	hash table has not been allocated.

2016-05-03  Justus Winter  <justus@gnupg.org>

	Fix privileged operations on trivfs-translated nodes
	Amends d18ea50e.

	* libtrivfs/fsys-getroot.c: When the user is privileged, make a
	verbatim copy of the real node instead of making an auth-restricted
	copy.

2016-05-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix build
	* trans/crash.c: Include <assert.h>.

2016-04-29  Justus Winter  <justus@gnupg.org>

	libihash: rehash if effective load exceeds the threshold
	Previously, if a hash table was not growing anymore but entries were
	regularly replaced, the tombstones would accumulate slowing down
	lookups and insertions.  A possible solution is to rehash the table if
	the effective load exceeds the configured threshold.  The effective
	load also takes tombstones into account.

	* libihash/ihash.c (hurd_ihash_locp_add): Use the effective load.
	(hurd_ihash_add): Likewise.  Use the load to decide whether we want to
	enlarge the table, otherwise we merely rehash.

2016-04-29  Justus Winter  <justus@gnupg.org>

	libihash: keep track of free slots
	* libihash/ihash.c (hurd_ihash_init): Init new field 'nr_free'.
	(add_one): Decrement counter if a free slot is used.
	(hurd_ihash_locp_add): Likewise.
	(hurd_ihash_add): Reset counter on reallocation.
	* libihash/ihash.h (struct hurd_ihash): New field 'nr_free'.
	(hurd_ihash_get_effective_load): New function.

2016-04-29  Justus Winter  <justus@gnupg.org>

	libihash: fix index computation
	Previously, find_index would return a suboptimal slot if a tombstone
	was in the optimal slot.

	* libihash/ihash.c (find_index): Fix index computation.

2016-04-29  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix root operations on trivfs-translated nodes
	* libtrivfs/fsys-getroot.c: When `uids` contain 0, make a verbatim copy of
	the real node instead of making an auth-restricted copy.

2016-04-28  Justus Winter  <justus@gnupg.org>

	startup: write all messages to stderr
	This avoids the need to flush the buffer and works around a weird
	problem with 'puts' not printing a newline.

	* startup/startup.c: Write all messages to stderr.

2016-04-28  Justus Winter  <justus@gnupg.org>

	startup: use the generated default server implementations
	* startup/Makefile: Set appropriate flags.
	* startup/startup.c: Drop most stub functions.

	startup: add verbose parameter
	* startup/startup.c: Add verbose parameter and inform about progress
	through the bootstrap procedure if it is given.

	startup: implement bits of the fs and io protocols
	* startup/Makefile: Build fs and io server with default
	implementations.
	(mung_msg_S.h): Tune regexp only to match the include guard.
	* startup/startup.c (mig_reply_setup): New function.
	(demuxer): Add new protocols.  Nicer implementation.
	(S_file_check_access): New function.
	(S_io_restrict_auth): Likewise.

	Unify and document the way fsids are handled in trivfs translators
	* doc/hurd.texi: Clarify what happens if 'trivfs_fsid' is zero.
	* login/utmp.c: Leave 'trivfs_fsid' at zero.
	* pfinet/main.c: Likewise.
	* trans/ifsock.c: Likewise.
	* trans/proxy-defpager.c: Likewise.

2016-04-27  Justus Winter  <justus@gnupg.org>

	libshouldbeinlibc: use the new assert in the refcount primitives
	* libshouldbeinlibc/refcount.h: Use 'assert_backtrace'.

2016-04-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: add assert(3) variant that prints backtraces
	* libshouldbeinlibc/Makefile: Add new files
	* libshouldbeinlibc/assert-backtrace.{c,h}: New files.

2016-04-27  Justus Winter  <justus@gnupg.org>

	libpager: add missing include
	* libpager/demuxer.c: Include <assert.h>.

2016-04-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	libdiskfs: Reject LFS seeks and read/writes
	vm_offset_t (used by pager_memcpy) is not 64bit-ready yet. Reject requests
	which go further than this.

	* libdiskfs/io-seek.c (diskfs_S_io_seek): Return EFBIG when requested offset
	is beyond limits of vm_offset_t.
	* libdiskfs/rdwr-internal.c (_diskfs_rdwr_internal): Return EFBIG when
	request goes beyond limits of vm_offset_t.

2016-04-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix supporting >4GiB files in ext2fs
	* ext2fs/inode.c (diskfs_user_read_node): When sizeof(off_t) >= 8, add
	di->i_size_high as high-64bit part to st->st_size. Drop setting
	unused info->i_high_size.
	(write_node): When sizeof(off_t) >= 8, write high-64bit part of st->st_size
	to di->i_size_high.
	* ext2fs/ext2_fs_i.h (ext2_inode_info): Remove i_high_size field.
	* pfinet/linux-src/include/linux/ext2_fs_i.h (ext2_inode_info): Likewise.

2016-04-26  Justus Winter  <justus@gnupg.org>

	libtrivfs: fix notion of privileged user
	Set 'is_root' if the node has been opened by the root user (this was
	the old behavior) or if it has been opened by the user the translator
	is executing under.

	This fixes the irritating bug that an unprivileged user cannot control
	her own trivfs-based translators.  It does not change how privileged
	trivfs translators work.

	* libtrivfs/io-reauthenticate.c (trivfs_S_io_reauthenticate): Use the
	new function to compute 'isroot'.
	* libtrivfs/io-restrict-auth.c (trivfs_S_io_restrict_auth): Likewise.
	* libtrivfs/open.c (trivfs_open): Likewise.
	* libtrivfs/priv.h (_is_privileged): New function.
	* libtrivfs/trivfs.h (struct peropen): Clarify what 'isroot' means.

2016-04-26  Justus Winter  <justus@gnupg.org>

	libtrivfs: fix error handling
	* libtrivfs/times.c (trivfs_set_{a,m}time): Fix error handling.

	libdiskfs: improve error handling
	* libdiskfs/boot-start.c (diskfs_start_bootstrap): Improve error
	handling.

2016-04-24  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

	Fix access mode of temporary files
	* libnetfs/dir-mkfile.c (netfs_S_dir_mkfile): Keep flags out of
	OPENONLY_STATE_MODES, instead of flags of OPENONLY_STATE_MODES, for the
	peropen's openstat.

2016-04-20  Justus Winter  <justus@gnupg.org>

	libfshelp: pass cookie to the callback function
	Previously, NULL was passed as cookie.  That notably caused some
	'peropen' objects to be created without context.

	Fixes 0bb14d0b.

	* libfshelp/fetch-root.c (fshelp_fetch_root): Pass cookie to the
	callback function.

2016-04-19  Justus Winter  <justus@gnupg.org>

	mach-defpager: fix error handling
	* mach-defpager/default_pager.c (S_default_pager_storage_info): Fix
	error handling.

2016-04-18  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make make install idempotent
	* sutils/Makefile ($(prefix)/dev/MAKEDEV): Add -f to ln command.

2016-04-17  Justus Winter  <justus@gnupg.org>

	utils/settrans: add option to specify the underlying node
	* utils/settrans.c (options): Add '--underlying'.
	(main): Handle new option.
	(open_node): Open the node if given.

	utils/settrans: get an authenticated root node in chroot mode
	* utils/settrans.c (get_credentials): New function.
	(main): Get an authenticated root node for the process we are
	chrooting.

	isofs: make superblock detection more robust
	* isofs/isofs.h (disk_image_len): New variable.
	* isofs/main.c (read_sblock): Avoid out of bounds access.
	* isofs/pager.c (disk_image_len): New variable.
	(create_disk_pager): Initialize 'disk_image_len'.

2016-04-15  Justus Winter  <justus@gnupg.org>

	Update NEWS file

2016-04-04  Flavio Cruz  <flaviocruz@gmail.com>

	Use posix types for mig definitions.
	* hurd/hurd_types.defs: Use posix types.
	* libfshelp/start-translator-long.c: Use uint32_t instead of
	unsigned32_t.

2016-03-24  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Use swapon path as pager partition path
	When /dev/hd* entries are parted-partition storeio, the store name is only
	the disk name, thus not unique.  We should just use the path being used
	instead.

	* sutils/swapon.c (swaponoff): Use `file' instead of `store->name' to
	default_pager_paging_file.
	(main): Drop hardcoded "/dev/".
	* procfs/rootdir.c (rootdir_gc_swaps): Drop hardcoded "/dev/".

2016-03-24  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix swap information numbers
	* procfs/rootdir.c (rootdir_gc_swaps): Fix default_pager_storage_info call
	parameter order.
	* sutils/swapon.c (main): Likewise.

2016-03-21  Flavio Cruz  <flaviocruz@gmail.com>

	netfs: Remove global reference count lock.
	* libnetfs/drop-node.c: Remove use of netfs_node_refcnt_lock.
	* libnetfs/init-init.c: Remove netfs_node_refcnt_lock.
	* libnetfs/make-node.c: Initialize refcounts in refcounts_init.
	* libnetfs/netfs.h: Use refcounts_t for tracking node references. Remove
	netfs_node_refcnt_lock. Add netfs_nref_light, netfs_nrele_light and
	handler netfs_try_dropping_softrefs. Adjust comments.
	* libnetfs/nput.c: Use refcounts_t. Call netfs_try_dropping_softrefs to
	remove any soft reference that the translator might have acquired
	during the lifetime of the node. Implement empty
	netfs_try_dropping_softrefs.
	* libnetfs/nref.c: Implement netfs_nref_light.
	* libnetfs/nrele.c: Use refcounts_t and netfs_try_dropping_softrefs.
	Implement netfs_nrele_light.
	* ftpfs/dir.c: Use netfs_nref without locking the old
	netfs_node_refcnt_lock.
	* ftpfs/node.c: Likewise.
	* usermux/mux.c: Use netfs_nref to increase hard references of the node.
	* hostmux/mux.c: Use netfs_nref to increase hard references of the node.
	* trans/fakeroot.c (new_node): Use a light reference when storing a node in the
	hash table.
	* trans/fakeroot.c (netfs_try_dropping_softrefs): Implement
	netfs_try_dropping_softrefs to remove the node from the hash table.
	* trans/fakeroot.c (netfs_node_norefs): Remove code to remove the node
	from the hash table.
	* trans/fakeroot.c (netfs_S_dir_lookup): Simplify lookup code since we
	don't need to lock netfs_node_refcnt_lock anymore.
	* procfs/netfs.c: Remove use of netfs_node_refcnt_lock.
	* nfs/cache.c: Add mutex to handle exclusive access to nodehash. This
	replaces the use of netfs_node_refcnt_lock.
	* nfs/cache.c (lookup_handle): Use nodehash_ihash_lock when accessing
	nodehash. Use netfs_nref_light to add one soft reference to the node
	just added to nodehash.
	* nfs/cache.c (netfs_node_norefs): Use netfs_nref. Don't use
	netfs_node_refcnt_lock and don't remove the node from nodehash here.
	* nfs/cache.c (netfs_try_dropping_softrefs): Drop the light reference
	when the node has no more hard references.
	* nfs/cache.c (recache_handle): Use nodehash_ihash_lock instead.
	* nfs/ops.c (netds_attempt_unlink): Use refcounts_references.
	* console/console.c (netfs_node_norefs): Use a soft reference to store
	a node in dir_node, cons_node, disp_node, inp_node.
	* console/console.c (netfs_try_dropping_softrefs): When dropping all
	soft references remove node pointer from the fields above.

2016-03-20  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	pflocal: Add support for access() on pipes
	bash's '<(' helper creates a pipe and gives /dev/fd/63 to the program, and
	gcc would then run access() on it. So we actually need to support at least
	some FS operations on pipes.

	* pflocal/fs.c: New file.
	* pflocal/mig-mutate.h (FILE_INTRAN, FILE_INTRAN_PAYLOAD, FILE_DESTRUCTOR,
	FILE_IMPORTS): New macros.
	* pflocal/sserver.c: Include "fs_S.h".
	(sock_demuxer): Call fs_server_routine.
	* pflocal/Makefile (SRCS): Add fs.c.
	(MIGSTUBS): Add fsServer.o.

2016-03-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix spurious port deallocation
	* libfshelp/fetch-root.c (fshelp_fetch_root): When translator has died, do
	not deallocate its control port twice.

2016-03-18  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	ext2fs: Fix off-by-one
	* ext2fs/pager.c (disk_cache_init): Do not add
	disk_cache_info[disk_cache_blocks] to disk_cache_info_free.

2016-03-16  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add getting swap information from swapon and procfs
	* hurd/default_pager.defs (default_pager_storage_info): New RPC.
	* hurd/default_pager_reply.defs: Skip default_pager_storage_info RPC.
	* hurd/default_pager_types.h: Include <mach/machine/vm_types.h>.
	(vm_size_array_t): New type.
	* mach-defpager/priv.h (part): Add `name' field.
	* mach-defpager/default_pager.c (new_partition): Allocate and fill
	`part->name' field. Free it on error.
	(destroy_paging_partition): Free `part->name' field.
	(S_default_pager_storage_info): New function.
	* procfs/Makefile (SRCS): Add default_pagerUser.c.
	* procfs/rootdir.c: Include "default_pager_U.h".
	(rootdir_gc_swaps): New function.
	(rootdir_entries): Add "swaps" entry.
	* sutils/swapon.c: Include <argz.h>
	(show): New variable.
	(options): Add --show/-S option.
	(def_pager, dev_master): New variables
	(swaponoff): Move getting `def_pager' to...
	(get_def_pager): ... new function.
	(main): Support 'S' option.
	* trans/proxy-defpager.c (S_default_pager_storage_info): New function.

2016-03-15  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Show firmlink mounts to mount points
	* trans/mtab.c (mtab_populate): Always open the underlying node, and pass
	it to mtab_mark_as_seen instead of the translated node.

	Add get_source support to firmlink
	* trans/firmlink.c (trivfs_get_source): New function.

	ext2fs: Fix adding blocks to free blocks cache
	* ext2fs/pager.c (disk_cache_info_free_push): Add prototype.
	(disk_pager_notify_evict): When dropping DC_INCORE flag, if the
	block becomes free (no reference and no DC_DONT_REUSE flags), call
	disk_cache_info_free_push.
	(disk_cache_block_deref): Only call disk_cache_info_free_push if the flags
	of the block do not contain DC_DONT_REUSE flags.

2016-03-13  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add missing RPC definitions
	* hurd/process_request.defs (proc_make_task_namespace_request): New
	definition.
	* hurd/process_reply.defs (proc_make_task_namespace_reply): Skip definition.

2016-03-07  Justus Winter  <justus@gnupg.org>

	utils/fakeauth: fix invocation of programs from PATH
	* utils/fakeauth.c (main): Replace the right element of the argument
	vector.  This fixes running scripts from PATH using fakeroot.

2016-02-29  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix parallel build
	* console-client/Makefile (parser.tab.h): Redefine the standard yacc rule to
	make it build the header too, to avoid concurrency between the standard yacc
	rule and the rule that builds the header.
	* sutils/Makefile (OBJS): Append .o suffix to $(progs) instead of .c.

2016-02-28  Esa Peuha  <esa.peuha@gmail.com>

	Fix use-after-free in libps.
	* libps/fmt.c (_fmt_create): Free new_fmt->src before new_fmt
	if reallocating fields fails.

2016-02-28  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix mustbedir mechanism for symlinks
	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): When following a symlink,
	if mustbedir is true, always append a slash to the symlink target, not only
	when the target is absolute.  Reset mustbedir to 0 before continuing the
	lookup loop.
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): When following a symlink,
	if mustbedir is true, append a slash to the symlink target. Reset mustbedir
	to 0 before continuing the lookup loop.
	* libtreefs/dir-lookup.c (_treefs_s_dir_lookup): Likewise.

2016-02-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix parallel install
	* sutils/Makefile (install): Do not depend on $(prefix)/dev.
	($(prefix)/dev/MAKEDEV): Depend on $(prefix)/dev²

2016-02-23  Justus Winter  <justus@gnupg.org>

	libports: preserve the complex message flag
	* libports/manage-multithread.c (internal_demuxer): Preserve all
	message flags when we store the objects address as payload in the
	message.
	* libports/manage-one-thread.c (internal_demuxer): Likewise.

2016-02-23  Justus Winter  <justus@gnupg.org>

	procfs: adapt to kernel interface change
	procfs makes use of the debug interface which is subject to change.

	* procfs/rootdir.c (rootdir_gc_slabinfo): The flag
	CACHE_FLAGS_NO_RECLAIM is no longer used.

2016-02-22  Bartlomiej Puget  <larhard@gmail.com>

	fix Xioctl-proto.defs creation
	* hurd/Makefile (%.h): Remove heading spaces.
	(%ioctl-requests.list): Protect asterisk.
	* hurd/gensym.awk: Do not print newline in __asm statement.

2016-02-22  Justus Winter  <justus@gnupg.org>

	utils/mount: start translators with stderr closed
	Apparently some users of 'mount' do not cope with any output being
	generated from the spawned translator.

	* utils/mount.c (do_mount): Start translators with stderr closed.

2016-02-21  Justus Winter  <justus@gnupg.org>

	trans/crash: fix suspending task
	* trans/crash.c (S_crash_dump_task): Fix looking up 'user_proc'.

2016-02-16  Flavio Cruz  <flaviocruz@gmail.com>

	nfs: fix deallocation of struct node.
	* nfs/cache.c: Do not free np->nn since np and np->nn are being
	allocated contiguously.

2016-02-15  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make fakeroot forward send errors instead of crashing
	* trans/fakeroot.c (netfs_demuxer): When forwarding an unknown request fail,
	forward the error instead of crashing.

2016-02-15  Flavio Cruz  <flaviocruz@gmail.com>

	libnetfs: remove unused fields.
	* libnetfs/netfs.h: Remove prevp and next fields from struct node.

	libdiskfs: fix and improve locking in nrefs/nput.
	* libnetfs/node-nput.c: Do not unlock the node since it will be unlocked
	later.
	* libnetfs/node-nrele.c: Do not lock the node twice if not needed.

	nfs: Use libihash for the node cache.
	* nfs/cache.c: Remove old node cache and use libihash. Use a pointer to
	the node handle as the key and the node itself as the value. Use
	netfs_make_node_alloc to allow libihash to set 'slot'.
	* nfs/nfs.c: Pass in a struct handle instead.
	* nfs/nfs.h: Add a hurd_ihash_locp_t field and remove hnext and hprevp.

2016-02-14  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix function name
	* procfs/main.c (set_default_options): Rename to set_compatibility_options.
	(argp_parser): Update call accordingly.

2016-02-14  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix hang on reauthentication
	One needs to keep the port being reauthenticated alive until we are sure the
	server has complete authentication.

	* libfshelp/fetch-root.c (fshelp_fetch_root): Deallocate `port' after
	auth_user_authenticate has completed.
	* trans/fakeroot.c (netfs_S_dir_lookup): Likewise with `file'.

2016-02-14  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make sure to complete auth_server_authenticate
	* boot/boot.c (S_io_reauthenticate): Keep calling auth_server_authenticate
	while it returns EINTR.
	* proc/mgt.c (S_proc_reauthenticate): Likewise.

2016-02-13  Flavio Cruz  <flaviocruz@gmail.com>

	Use libihash to store directory entries in ftpfs.
	* ftpfs/ftpfs.h: Add dir_locp for each directory entry and replace the
	table with a libihash table.
	* ftpfs/dir.c: Modify the code to use libihash. Remove several functions
	such as rehash and insert.

2016-02-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/vmallocate: new utility
	* utils/Makefile (targets): Add 'vmallocate'.
	* utils/vmallocate.c: New file.

2016-02-08  James Clarke  <jrtc27@jrtc27.com>

	Fixed leaks in _netfs_translator_callback2_fn
	* libnetfs/trans-callback.c (_netfs_translator_callback2_fn): Fixed leaking
	iouser and peropen structs on error.

2016-02-07  Flavio Cruz  <flaviocruz@gmail.com>

	Check for a return value in netfs_make_peropen before using it in netfs_make_protid.
	* libnetfs/trans-callback.c: Add check for netfs_make_peropen.

2016-02-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	devnode: fix falling back to the kernel driver
	* devnode/devnode.c (ds_device_open): Do not exit if opening the
	master device fails.
	(parse_opt): Likewise.

	mach-defpager: link dynamically
	* mach-defpager/Makefile (LDFLAGS): Drop.

2016-02-07  Flavio Cruz  <flaviocruz@gmail.com>

	Remove libfshelp/trans.h and libfshelp/locks.h.
	* libfshelp/locks.h: Remove.
	* libfshelp/trans.h: Remove. struct transboot is not used anywhere.
	* libfshelp/fetch-root.c: Adjust includes.
	* libfshelp/lock-acquire.c: Likewise.
	* libfshelp/lock-init.c: Likewise.

	Use refcount_t for peropen reference counting in libnetfs.
	* libnetfs/netfs.h: Use refcount_t.
	* libnetfs/make-peropen.c: Initialize to 1 with refcount_init just like in libdiskfs.
	* libnetfs/make-protid.c: Don't increment the count here. Do it like libdiskfs.
	* libnetfs/io-duplicate.c: Add refcount_ref since netfs_make_protid no longer increments the refcount.
	* libnetfs/io-reauthenticate.c: Likewise.
	* libnetfs/io-restrict-auth.c: Likewise.
	* libnetfs/release-peropen.c: Dereference without locking.

2016-02-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/settrans: improve --chroot functionality
	Add an option '--chroot-chdir' to settrans and make it chdir to this
	directory before executing the target program.  Also, look up the
	executable in PATH.

	With these changes we no longer need to use the shell inside the
	chroot in the convenience scripts, and hence do not require it to be
	installed inside the chroot.

	* utils/fakeroot.sh: Simplify using the new option.
	* utils/remap.sh: Likewise.
	* utils/settrans.c (OPT_CHROOT_CHDIR): New constant.
	(options): New option 'chroot-chdir'.
	(main): Handle new option. Search for target executable in PATH.
	* utils/fakeauth.c (main): Likewise.

2016-02-04  Esa Peuha  <esa.peuha@gmail.com>

	exec: remove duplicate function call
	* exec/main.c (main) Remove second call to trivfs_startup
	from commit a5d384c.

2016-01-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	procfs: Move setting default parameters to a separate function
	* procfs/main.c (set_default_options): New function
	(argp_parser): Call `set_default_options'.

	Fix typo
	* exec/Makefile (targets): Rename to target.

2016-01-17  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Also build exec.static
	Which can be more convenient than using ld.so to boot the Hurd

	* exec/Makefile (targets): Add exec.static

2016-01-14  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix gcc signedness warnings
	* pfinet/linux-src/include/linux/skbuff.h (__skb_pull): Return unsigned
	char * instead of char *.

2016-01-13  Flavio Cruz  <flaviocruz@gmail.com>

	Fix O_DIRECTORY lookup on trivial translators
	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): If mustbedir, make sure
	entry is a directory by retrying "/", or starting the translator and
	retrying "/".
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Likewise.

2016-01-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix pfinet crash
	During rsyslog testsuite, it does happen that threads running
	schedule_timeout get woken up by something else than the timer.  The (local)
	timer needs to be removed in that case.  Let's just always remove it, like
	Linux does.

	* pfinet/glue-include/linux/sched.h (schedule_timeout): Remove local timer
	before returning.

2016-01-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make private variables static
	* pfinet/timer-emul.c (timers, timer_thread): Make variables static.

	pflocal: Do not abort on too small getopt parameter
	* pflocal/socket.c (S_socket_getopt): When *value_len is too small, return
	EINVAL instead of aborting.

2016-01-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add dumb SO_ERROR support to pflocal
	pflocal does not currently have asynchronous operations, so we can make
	SO_ERROR just report 0.

	* pflocal/socket.c (S_socket_getopt): For `level' SOL_SOCKET and `opt'
	SO_ERROR, report 0.

2016-01-02  Flavio Cruz  <flaviocruz@gmail.com>

	allow pfinet to link using -O0
	This fixes a long list of undefined references when compiling with -O0
	by using static instead of extern in header files.

2016-01-01  Flavio Cruz  <flaviocruz@gmail.com>

	fix mach-defpager static linking
	* mach-defpager/Makefile: Allow multiple definitions for mach-defpager.

2015-12-31  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warning in hurd/fstests
	* fstests/fstests.c (main): Only declare 'root' when HURDISH_TESTS is
	defined.

2015-12-31  Flavio Cruz  <flaviocruz@gmail.com>

	Drop OTHERLIBS and use LDLIBS exclusively
	When cross-compiling, OTHERLIBS magically turns -lpthread into the path
	to the host libpthread.so file, resulting in build issues. LDLIBS does
	not suffer from this problem and it seems that is already being used in
	other Makefiles. This patch removes OTHERLIBS entirely from the build
	system.

	* Makeconf: Remove references to OTHERLIBS
	* auth/Makefile: Replace OTHERLIBS with LDLIBS.
	* boot/Makefile: Likewise.
	* console/Makefile: Likewise.
	* exec/Makefile: Likewise.
	* ext2fs/Makefile: Likewise.
	* fatfs/Makefile: Likewise.
	* ftpfs/Makefile: Likewise.
	* hostmux/Makefile: Likewise.
	* isofs/Makefile: Likewise.
	* libhurd-slab/Makefile: Likewise.
	* nfs/Makefile: Likewise.
	* nfsd/Makefile: Likewise.
	* pfinet/Makefile: Likewise.
	* proc/Makefile: Likewise.
	* procfs/Makefile: Likewise.
	* random/Makefile: Likewise.
	* storeio/Makefile: Likewise.
	* term/Makefile: Likewise.
	* tmpfs/Makefile: Likewise.
	* usermux/Makefile: Likewise.

2015-12-31  Flavio Cruz  <flaviocruz@gmail.com>

	Use DEVICE_IMPORTS to include libports/ports.h
	On Thu, Dec 31, 2015 at 04:28:14PM +0100, Justus Winter wrote:
	> Quoting Samuel Thibault (2015-12-31 16:11:30)
	> > Flavio Cruz, on Thu 31 Dec 2015 15:56:31 +0100, wrote:
	> > > This fixes three compiler warnings about ports_payload_get_name.
	> > >
	> > > * devnode/Makefile: Define DEVICE_IMPORTS.
	> > > * term/Makefile: Likewise.
	> > > * trans/Makefile: Likewise.
	> >
	> > Why not adding them to the corresponding mig-mutate.h?
	>
	> Sometimes we don't have a mig-mutate.h, e.g. for most (all?)
	> translators in trans/.  I prefer stuffing that in a .h as well, but I
	> wouldn't be opposed to just applying the patch, as we use both ways of
	> mutating the mig types.

	Agreed. I think only devnode should include it in mig-mutate.h. For
	term, only some stubs are including mig-mutate.h. For trans, there's no
	mig-mutate.h at all.  Here's the modified patch.

2015-12-31  Flavio Cruz  <flaviocruz@gmail.com>

	Define IO_OUTTRAN so that term_on_pty returns a mach_port_t
	* libtrivfs/mig-decls.h: Implement trivfs_convert_to_port.
	* term/mig-mutate.h: Define IO_OUTTRAN.

2015-12-30  Flavio Cruz  <flaviocruz@gmail.com>

	Add missing libraries to fix link errors
	This fixes several linking problems I had in my recent cross-compilation
	of the Hurd. I added missing static libraries and also organized some of
	the targets for more concise rules.

	* console-client/Makefile: Add libiohelp.a and libihash.a.
	* daemons/Makefile: Add libihash.a and libshouldbeinlibc.a.
	* devnode/Makefile: Add iohelp and ihash to HURDLIBS.
	* random/Makefile: Likewise.
	* trans/Makefile: Reorder targets alphabetically and add libiohelp.a and
	libihash.a.
	* utils/Makefile: Add libihash.a.

2015-12-30  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/nfs and hurd/nfsd
	* nfsd/fsys.c (init_filesystems): Use 'm' qualifier instead of 'a' for
	allocating the name in fscanf call.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/utils
	utils: Fix compiler warnings.

	* utils/rpcscan.c (setup_extract_target): Remove name variable.
	* utils/rpcscan.c (setup_extract_target): Fix bad initializer.
	* utils/rpctrace.c (new_send_wrapper, wrap_all_threads, wrap_new_thread,
	wrap_new_task, traced_spawn): Fix format strings.
	* utils/rpctrace.c (trace_and_forward): Cast to unsigned int.
	* utils/rpctrace.c (trace_and_forward): Use memcmp instead of pointer
	dereferencing to compare structures.
	* utils/rpctrace.c (wrap_all_threads): Cast to vm_address_t.
	* utils/rpctrace.c (main): Fix bad initializer.
	* utils/shd.c (run): Initialize save0.
	* utils/vminfo.c: Fix format strings.
	* utils/vmstat.c: Remove PSEP macro and expand the code.
	* utils/w.c (add_utmp_procs): Remove unused pos variable.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/trans
	trans: Fix compiler warnings.

	* trans/mtab.c (mtab_mark_as_seen): Cast idport to hurd_ihash_value_t.
	* trans/streamio.c (dev_open): Cast name to char *.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/startup
	startup: Fix compiler warning.

	* startup/startup.c (do_mach_notify_dead_name): Fix format string.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/random
	random: Fix compiler warnings.

	* random/gnupg-random.c: Use byte instead of char.
	* random/gnupg-rmd.h (rmd160_mixblock): Use byte instead of char.
	* random/gnupg-rmd.c (rmd160_mixblock): Likewise.
	* random/gnupg-rmd.c: Place #ifdef __HURD__ earlier to avoid warnings.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	Include missing header file in hurd/proc
	proc: Add missing header file.

	* proc/mgt: Include missing header file mach/task_notify.h.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/procfs
	procfs: Fix compiler warnings.

	* include/sys/procfs.h: Change uintptr_t to vm_address_t.
	* procfs/process.c: Fix format strings.
	* procfs/rootdir.c: Add missing casts.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/nfs and hurd/nfsd
	nfs: Fix compiler warnings.

	* nfs/ops.c (netfs_get_dirents): Initialize buf.
	* nfsd/nfsd.h: Define cache_handle_array union.
	* nfsd/cache.c: Use new cache_handle_array union.
	* nfds/ops.c: Likewise.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	drop the deprecated malloc/free hooks in hurd/mach-defpager

	fix compiler warnings in hurd/libstore

	fix compiler warnings in hurd/libshouldbeinlibc

	fix compiler warnings in hurd/libnetfs

	fix compiler warnings in hurd/libihash

	fix compiler warnings in hurd/libftpconn

	fix compiler warnings in hurd/isofs
	* isofs/rr.c (rrip_work): Use unsigned char.
	* isofs/rr.h: Use unsigned char instead of char.

	fix compiler warnings in hurd/libdiskfs

	fix compiler warnings in hurd/isofs
	* fatfs/dir.c: Use casts to avoid warnings.
	* fatfs/fat.c: Use unsigned char in fat_{from,to}_epoch.
	* fatfs/fat.h: Change arguments accordingly.
	* fatfs/fat.c (fat_read_sblock): Use size_t instead.
	* fatfs/inode.c (diskfs_cached_lookup_in_dirbuf): Remove err variable.
	* fatfs/inode.c (diskfs_user_read_node): Don't cast constant.
	* fatfs/inode.c (write_node): Check for errors in vm_map.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/console-client
	On Tue, Dec 29, 2015 at 08:43:24PM +0100, Samuel Thibault wrote:
	> Flavio Cruz, on Tue 29 Dec 2015 17:35:00 +0100, wrote:
	> > @@ -663,10 +663,11 @@ update_leds (void)
	> >  	| (led_state.num_lock ? 2 : 0)
	> >  	| (led_state.caps_lock ? 4 : 0);
	> >
	> > -      err = device_write_inband (kbd_dev, 0, -1, (void *) leds, 2, &data_cnt);
	> > +      err = device_write_inband (kbd_dev, 0, -1, (void *) leds, 2,
	> > +                                 (int *) &data_cnt);
	> >        if (!err && data_cnt == 1)
	> >  	err = device_write_inband (kbd_dev, 0, -1, (void *) &leds[1], 1,
	> > -				   &data_cnt);
	> > +				   (int *) &data_cnt);
	> >      }
	> >  }
	> >
	>
	> I'm surprised: if the device_write_inband RPC really wants an int*, why
	> not making data_cnt an int?

	That works better. Thanks.

	console-client: Fix compiler warning.

	* console-client/pc-kbd.c (update_leds): Replace mach_msg_type_number_t with
	int.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/ext2fs
	ext2fs: Fix compiler warnings.

	* ext2fs/balloc.c: Use unsigned char instead of char.
	* ext2fs/bitmap.c Use unsigned char for bitmaps.
	* ext2fs/dir.c: Fix format.
	* ext2fs/ext2fs.h: Use unsigned char for bitmaps.
	* ext2fs/ialloc.c: Use unsigned char for bitmaps. Fix format string in
	ext2_warning.
	* ext2fs/pager.c: Fix format string in ext2_warning and ext2_error.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/exec
	exec: Fix compiler warnings.

	* exec/elfcore.c: Cast arguments to vm_address_t.
	* exec/main.c: Use %lu in asprintf.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/daemons
	daemons: Fix compiler warnings.

	* daemons/lmail.c: Initialize cached to 0.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	fix compiler warnings in hurd/console-client
	console-client: Fix several compiler warnings.

	* console-client/bdf.c: Use size_t instead of int.
	* console-client/driver.c: Remove unused variable errstring.
	* console-client/pc-kbd.c: Cast sc to scancode_x1 before comparing with enum
	values.
	* console-client/vga-dynacolor.h: Use an explicit if in reference counting.
	* console-client/vga-dynafont.c: Use usigned char for bitmaps.
	* console-client/vga-support.c: Use unsigned char instead of char.
	* console-client/vga-support.h: Likewise.
	* console-client/vga.c: Use conchar_attr_equal instead of casting structures to
	integers.
	* hurd/console.h: Add conchar_attr_equal to compare conchar_attr_t structures.

2015-12-29  Flavio Cruz  <flaviocruz@gmail.com>

	boot: Fix boot.c compiler warning.
	* boot/boot.c: Compare header without using pointer dereferencing.

2015-12-01  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: use ihash for the node cache
	Replace the hand-written hash table in the node cache with libihash.
	Libihash is a self-tuning hash table, whereas the previous code used a
	fixed number of buckets.

	* libdiskfs/Makefile (HURDLIBS): Link to `ihash'.
	* libdiskfs/diskfs.h (struct node): Remove bucket list, add slot pointer.
	* libdiskfs/node-cache.c (nodecache): New ihash table replacing the
	old `nodehash'.
	(lookup): Drop function.
	(diskfs_cached_lookup_context): Adapt accordingly.
	(diskfs_cached_ifind): Likewise.
	(diskfs_try_dropping_softrefs): Likewise.
	(diskfs_node_iterate): Likewise.

2015-11-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: keep list of reusable disk cache entries
	This avoids a linear scan through the cache.

	*  ext2fs/ext2fs.h (struct disk_cache_info): New field 'next'.
	* ext2fs/pager.c (disk_cache_hint): Drop.
	(disk_cache_info_free, disk_cache_info_free_lock): New variables.
	(disk_cache_info_free_pop, disk_cache_info_free_push): New functions.
	(disk_cache_init): Adjust slightly.
	(disk_cache_block_ref): Use new functions.
	(disk_cache_block_deref): Likewise.

2015-11-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: disable block cache debugging by default
	* ext2fs/ext2fs.h: Disable block cache debugging by default.
	* ext2fs/pager.c: Likewise.

	ext2fs: improve the block cache
	* ext2fs/pager.c (disk_cache_block_ref): Improve the cache by using
	the new lookup and insertion functions that return and use a location
	pointer.

	libihash: provide a general purpose hash algorithm
	* libdiskfs/name-cache.c: Move the Murmur3 algorithm...
	* libihash/murmur3.c: ... here, and properly attribute the code.
	* libihash/ihash.h (hurd_ihash_hash32): New prototype.
	* libihash/Makefile (SRCS): Add new file.

	libihash: fix item insertion
	* libihash/ihash.c (find_index): Keep track and return the index where
	we could insert the item.
	(add_one): Use 'find_index'.

	libihash: generalize the interface to support non-integer keys
	* libihash/ihash.c (hash, compare): New functions that are used
	throughout libihash to hash and compare keys.
	(hurd_ihash_set_gki): New function.
	* libihash/ihash.h (hurd_ihash_fct_hash_t): New type for hash functions.
	(hurd_ihash_fct_cmp_t): New type for comparison functions.
	(struct hurd_ihash): New fields for hash and comparison functions.
	(HURD_IHASH_INITIALIZER_GKI): New static initializer.
	(hurd_ihash_set_gki): New prototype.

	libihash: fix fast insertion corner case
	* libihash/ihash.c (hurd_ihash_locp_add): Fix insertion if the key
	doesn't match.

	libihash: fix ill-devised locp lookup interface
	* libihash/ihash.c (hurd_ihash_locp_find): Return both the item and the slot.
	* libihash/ihash.h (hurd_ihash_locp_find): Adjust prototype.
	(hurd_ihash_locp_value): Remove function.

2015-11-29  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Use -L instead of -Wl,-rpath-link
	The latter does not work for libpthread.a which passes -lihash, which would
	find the installed libihash.a instead of the just-compiled one.

	* Makeconf (rpath): Remove, replaced by...
	(lpath): ... new variable.
	(link-executable, $(libname).so.$(hurd-version)): Use $(lpath) instead of
	$(rpath).

2015-11-29  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add missing menus

	Fix undefined reference
	* doc/hurd.texi (devnode): Do not reference not-yet-existing eth-multiplexer
	node.

	Add devnode documentation
	* doc/hurd.texi (devnode): Add section.

	Add libhurd-slab
	* libhurd-slab: New directory
	* Makefile (lib-subdirs): Add libhurd-slab.

	Add devnode translator
	* devnode: New directory
	* Makefile (prog-subdirs): Add devnode.

2015-11-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: prefer performance degradation over failure
	* libihash/ihash.c (hurd_ihash_add): Add the item even though we are
	above the load factor if resizing failed.

2015-11-06  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: optimize lookup-or-insert operations
	If libihash is used to implement a cache, a insertion is always
	preceeded by a lookup.  hurd_ihash_add has to do the lookup again.

	Provide a new pair of functions, hurd_ihash_locp_add and
	hurd_ihash_locp_find, that can be used in combination to avoid the
	second lookup.

	* libihash/ihash.c (hurd_ihash_locp_add): New function using a
	location pointer...
	(hurd_ihash_locp_find): ... that has been returned by this function.
	* libihash/ihash.h (hurd_ihash_locp_add): New declaration.
	(hurd_ihash_locp_find): Likewise.
	(hurd_ihash_locp_value): New function.

2015-11-06  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: add hurd_ihash_value_valid
	* libihash/ihash.h (hurd_ihash_value_valid): New function.
	* libihash/ihash.c (index_empty): Use hurd_ihash_value_valid.

	random: satisfy arbitrarily-sized reads
	* random/random.c (trivfs_S_io_read): Satisfy arbitrarily-sized reads.

	random: use /servers/startup to register for shutdown notifications
	* random/random.c (arrange_shutdown_notification): Use the new way to
	contact the startup server.

	random: improve error handling
	* random/random.c (arrange_shutdown_notification): Improve error
	handling.
	(main): Display warning if arranging the shutdown notification failed.

	random: fix odd formatting
	* random/random.c (trivfs_append_args): Fix odd formatting.

	Remove unused variables
	* console/pager.c (user_pager_init): Remove unused variables.
	* ext2fs/pager.c (create_disk_pager): Likewise.
	* fatfs/pager.c (create_fat_pager): Likewise.
	* storeio/pager.c (init_dev_paging): Likewise.

2015-11-03  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libtrivfs: remove deprecated static class vectors
	This API has been deprecated in Hurd 0.7.

	* doc/hurd.texi (trivfs_protid_portclasses,
	trivfs_protid_nportclasses, trivfs_cntl_portclasses,
	trivfs_cntl_nportclasses): Remove.
	* libtrivfs/trivfs.h: Likewise.
	* libtrivfs/mig-decls.h: Adapt accordingly.
	* libtrivfs/cntl-classes.c: Remove unused file.
	* libtrivfs/protid-classes.c: Likewise.
	* libtrivfs/Makefile (OTHERSRCS): Drop the two files.

2015-11-03  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: fix sanity check at translator startup time
	* pfinet/main.c (main): Properly iterate over `pfinet_protid_portclasses'.

2015-10-31  Thomas Schwinge  <thomas@codesourcery.com>

	GNU Hurd 0.7
	* configure.ac (AC_INIT): Set version to 0.7.
	* NEWS: Finalize for 0.7.

2015-10-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pflocal: avoid building the interrupt server
	* pflocal/io.c: Do not needlessly include `interrupt_S.h'.

	hurd: fix type of in-translation function
	* hurd/hurd_types.defs (interrupt_t): Fix type of in-translation
	function.

2015-10-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: improve demuxers
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.

	* trans/proxy-defpager.c (proxy_defpager_demuxer): Improve the demuxer
	function.
	* trans/streamio.c (demuxer): Likewise.

2015-10-20  Svante Signell  <svante.signell@gmail.com>

	Make fakerooted access() return real access
	Various realworld tests would otherwise think they can write to /, while
	they actually can't.

	* trans/fakeroot.c (netfs_report_access): Call file_check_access instead of
	returning O_RDWR|O_EXEC when faking mode too.

2015-10-12  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make dir_lookup create files with user permissions enabled
	So we will always be able to re-open them.

	* trans/fakeroot.c (netfs_S_dir_lookup): Call real_from_fake_mode() on modes
	before calling the underlying filesystem's dir_lookup.

2015-10-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make netfs_S_io_reauthenticate handle allocation errors
	* libnetfs/io-reauthenticate.c (netfs_S_io_reauthenticate): Loop when
	netfs_make_protid fails with EINTR, return error when it fails otherwise.

2015-10-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Drop duplicate port deallocation
	Follow-up dbfa8a3

	* libnetfs/io-reauthenticate.c (netfs_S_io_reauthenticate): Do not
	deallocate parameter port `rend_port' when an error will be returned.
	* libtrivfs/io-reauthenticate.c (trivfs_S_io_reauthenticate): Do not
	deallocate parameter port `rend_port' when an error will be returned.

2015-10-05  James Clarke  <jrtc27@jrtc27.com>

	Add missing null checks in libshouldbeinlibc
	The getpwnam_r and similar functions only return non-zero on error, but not
	finding the given name/UID/GID does not count as an error. When they return 0,
	the value of the result (*result when looking at the arguments in the man pages)
	still needs to be checked for null.

	* libshouldbeinlibc/idvec-rep.c (lookup_uid): Check result for null.
	(lookup_gid): Likewise.
	* libshouldbeinlibc/idvec-verify.c (verify_passwd): Likewise.
	(verify_id): Likewise.

2015-10-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Update NEWS file

	libdiskfs: fflush stdout when pausing
	* libdiskfs/boot-start.c (diskfs_start_bootstrap): fflush stdout when
	pausing for /hurd/startup.

2015-09-29  Joshua Branson  <bransoj@hotmail.com>

	Minor documentation changes
	* .gitignore: Add generated doc/hurd.aux, doc/hurd.cp, doc/hurd.cps,
	doc/hurd.fn, doc/hurd.ky, doc/hurd.log, doc/hurd.pdf, doc/hurd.pg,
	doc/hurd.sc, doc/hurd.toc, doc/hurd.tp, doc/hurd.vr files.
	* doc/hurd.texi: Fix typo, complete explanation about sharing Mach devices.
	Complete documentation for shutdown. Replace cthreads with POSIX threads.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libtrivfs: deprecate old api
	* libtrivfs/trivfs.h (trivfs_protid_portclasses): Deprecate, and
	schedule for removal in Hurd 0.8.
	(trivfs_protid_nportclasses): Likewise.
	(trivfs_cntl_portclasses): Likewise.
	(trivfs_cntl_nportclasses): Likewise.

	libtrivfs: optimize the object lookup code
	* libtrivfs/mig-decls.h: Remove the specialized cases, they really
	blow up these functions that are supposed to be inlined.  Also, look
	into the dynamically allocated vectors first, because this is the
	preferred way of using libtrivfs since 1997.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/proxy-defpager: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a severe bug.  As no classes are given to
	`trivfs_startup', they are created and inserted into the dynamic
	vector of classes.  The helper function `allowed', however, used the
	first item of the previously used static array, which is NULL.  This
	circumvented the typecheck, allowing the default pager protocol to be
	spoken over control ports, likely resulting in a crash.

	* trans/proxy-defpager.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/passwd: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* trans/password.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/new-fifo: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* trans/new-fifo.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/magic: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a severe bug.  As no classes are given to
	`trivfs_startup', they are created and inserted into the dynamic
	vector of classes.  The server function `trivfs_S_fsys_forward',
	however, used the first item of the previously used static array,
	which is NULL.  This circumvented the typecheck.

	* trans/magic.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/ifsock: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* trans/ifsock.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/crash: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* trans/crash.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pflocal: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* pflocal/pflocal.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* pfinet/main.c: Convert to dynamic classes and buckets.
	* pfinet/options.c: Likewise.
	* pfinet/pfinet.h: Likewise.
	* pfinet/socket-ops.c: Likewise.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: convert to trivfs dynamic classes and buckets
	libtrivfs contains two ways of managing more than one port class and
	bucket.  There is the old way of using a statically allocated array
	with explicit length, and the new way with dynamically allocated
	vectors.

	Converting all users to the new way of handling multiple classes
	and/or buckets, we can simplify the code in libtrivfs.  In many cases,
	the code will be simpler and more expressive for the user.

	This also fixes a mild bug.  The classes and buckets given to
	`trivfs_startup' end up in the dynamic vectors too, making the object
	lookup code use the more complicated code path.

	* exec/main.c: Convert to dynamic classes and buckets.

2015-09-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fflush stdout when pausing
	* libdiskfs/boot-start.c (start_execserver): fflush stdout when pausing.

	libdiskfs: improve error handling
	* libdiskfs/boot-start.c (start_execserver): Improve error handling.

2015-09-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: add missing include
	* exec/main.c: Include `argz.h'.

2015-09-22  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: remove unused variables
	* libports/inhibit-all-rpcs.c (ports_inhibit_all_rpcs): Remove unused
	variable `bucket'.
	* libports/inhibit-class-rpcs.c (ports_inhibit_class_rpcs): Remove unused
	variables `pi' and `rpc'.

2015-09-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Define TIME_VALUE_TO_TIMESPEC only when not defined already
	* exec/elfcore.c (TIME_VALUE_TO_TIMESPEC) [TIME_VALUE_TO_TIMESPEC]: Do not
	redefine macro.

2015-09-12  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Turn EADDRNOTAVAIL to more commonly-understood ECONNREFUSED
	Thanks Svante Signell for the investigation.

	* pflocal/socket.c (S_socket_connect, S_socket_send): When addr_get_sock
	returns EADDRNOTAVAIL, translate into ECONNREFUSED.

2015-09-12  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix build warning
	* pflocal/sock.h (sock_bind): Move declaration.

2015-09-12  James Clarke  <jrtc27@jrtc27.com>

	Add support for ANSI.SYS SCP/RCP escape codes
	This adds support for CSI s and u, which are equivalent to ESC 7 and 8,
	saving/restoring the cursor position.

	* console/display.c (handle_esc_bracket): Added support for CSI s and u.

2015-09-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix detection of terminated dgram pflocal server
	* libpipe/pipe.c (_pipe_no_readers): Break pipe for connection-less pipes
	too.

2015-09-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix closure of local server sockets
	Since bound socks always have a ref for their address, they would never get
	freed.  Thanks Svante Signell for the investigation.

	* pflocal/sock.h (sock_deref): When `sock' has one ref left and is bound to
	an address, unbound it, and thus shut it down.

2015-09-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix sock_bind(sock,NULL) support
	* pflocal/sock.c (sock_bind): When addr is NULL, do not take/release its
	mutex. When old_addr is also NULL, return EINVAL. When old_addr is not NULL,
	deref old_addr instead of addr.

2015-09-10  James Clarke  <jrtc27@jrtc27.com>

	Install port-deref-deferred.h header for ports.h
	* libports/Makefile (installhdrs): Add port-deref-deferred.h for ports.h

2015-09-10  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Do not install libtrivfs mig stub headers
	They were not usable anyway.

	* libtrivfs/Makefile (installhdrs): Remove generated mig stub headers.

2015-09-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc/maptime: use memory fences
	* libshouldbeinlibc/maptime.h (maptime_read): Use memory fences.

	pflocal: avoid nested function
	* pflocal/io.c (copy_time): Move function out of `S_io_stat', turning
	it into a static inline function.

2015-09-09  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	umount: Do not report errors on making the device go away
	This fixes umounting bind mounts or other mounts for which the device can
	not be made away.

	* utils/umount.c (do_umount): When the --force option is not passed, ignore
	errors from file_set_translator call on the device file.

2015-09-08  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Also do not realpath "proc" pseudo-device
	* sutils/fstab.c (fstab_find_device): Do not realpath "proc" pseudo-device.

2015-09-08  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make procfs accept none or proc as "device"
	This allows "mount none /proc -t proc" to work.

	* procfs/main.c (argp_parser): On ARGP_KEY_ARG, accept and ignore "none" and
	"proc".

2015-09-08  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix opening a fifo with O_RDWR
	We should not wait for a writer in that case, since that will be ourself.

	* trans/fifo.c (open_hook): Do not wait for a writer when flags contains
	O_WRITE.

2015-09-06  James Clarke  <jrtc27@jrtc27.com>

	Fix race condition in ext2fs when remounting
	On some systems, ext2fs.static would regularly hang at startup, as a
	race condition meant it would process paging requests while remounting.
	To fix this, libpager has been altered to allow inhibiting and resuming
	its worker threads, and ext2fs uses this to inhibit paging while
	remounting.

	* console/pager.c (pager_requests): New variable.
	(user_pager_init): Updated call to pager_start_workers to use new
	pager_requests variable.
	* daemons/runsystem.sh: Removed artificial delay working around the race
	condition.
	* ext2fs/ext2fs.c (diskfs_reload_global_state): Call new
	inhibit_ext2_pager and resume_ext2_pager functions, and leave sblock as
	non-NULL so it will be munmapped.
	* ext2fs/ext2fs.h (inhibit_ext2_pager,resume_ext2_pager): New functions.
	* ext2fs/pager.c (file_pager_requests): New variable.
	(create_disk_pager): Updated call to pager_start_workers to use new
	file_pager_requests variable.
	(inhibit_ext2_pager,resume_ext2_pager): New functions.
	* fatfs/fatfs.h (inhibit_fat_pager,resume_fat_pager): New functions.
	* fatfs/pager.c (file_pager_requests): New variable.
	(create_fat_pager): Updated call to pager_start_workers to use new
	file_pager_requests variable.
	(inhibit_fat_pager,resume_fat_pager): New functions.
	* libdiskfs/disk-pager.c (diskfs_disk_pager_requests): New variable.
	(diskfs_start_disk_pager): Updated call to pager_start_workers to use
	new diskfs_disk_pager_requests variable.
	* libdiskfs/diskfs-pager.h (diskfs_disk_pager_requests): New variable.
	* libpager/demuxer.c (struct pager_requests): Renamed struct requests to
	struct pager_requests. Replaced queue with queue_in and queue_out
	pointers. Added inhibit_wakeup field.
	(pager_demuxer): Updated to use new queue_in/queue_out pointers. Only
	wake up workers if not inhibited.
	(worker_func): Updated to use new queue_in/queue_out pointers. Final
	worker thread to sleep notifies the inhibit_wakeup condition variable.
	(pager_start_workers): Added out parameter for the requests instance.
	Allocate heap space shared by both queues. Initialise new inhibit_wakeup
	condition.
	(pager_inhibit_workers,pager_resume_workers): New functions.
	* libpager/pager.h (struct pager_requests): Public forward definition.
	(pager_start_workers): Added out parameter for the requests instance.
	(pager_inhibit_workers,pager_resume_workers): New functions.
	* libpager/queue.h (queue_empty): New function.
	* storeio/pager.c (pager_requests): New variable.
	(init_dev_paging): Updated call to pager_start_workers to use new
	pager_requests variable.

2015-08-31  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix build against glibc 2.21
	* Makeconf (CPPFLAGS): Remove -D_IO_MTSAFE_IO.
	* libthreads/lockfile.c (_IO_MTSAFE_IO): Define macro.
	(IS_IN): Define macro to 0.

2015-08-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: rename `error' variable
	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): Rename `error' to `err'.
	* libdiskfs/file-getcontrol.c (diskfs_S_file_getcontrol): Likewise.
	* libdiskfs/file-syncfs.c (diskfs_S_file_syncfs): Likewise.

	libdiskfs: add missing declarations
	* libdiskfs/diskfs.h (diskfs_node_disknode): Add missing declaration.
	(diskfs_disknode_node): Likewise.

	libdiskfs: fix typo
	* libdiskfs/diskfs.h: Fix typo.

2015-08-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix parent lookup in the name cache
	* libdiskfs/name-cache.c (diskfs_check_lookup_cache): Drop stray negation.

2015-08-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: provide unconditional debug macro
	* ext2fs/ext2fs.h (ext2_debug_): New macro that unconditionally prints
	the given message.
	(ext2_debug): Use the new macro.

	ext2fs: improve ext2fs debugging
	* ext2fs/ext2fs.h (ext2_debug): Print to stderr.
	(printf): Drop declaration.

2015-08-14  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fake full file access only for faked nodes
	Otherwise some scripts may try to modify system files just because they find
	they seem to be able to.

	* trans/fakeroot.c (netfs_report_access): When FAKE_MODE is not set on
	`np', call file_check_access on the underlying node instead of returning
	O_RDWR|O_EXEC.

2015-08-14  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make fakeroot return file types from underly fs
	Fakeroot does not support faking them anyway, and they may change on the
	underlying fs, e.g. when creating a local socket.

	* trans/fakeroot.c (netfs_validate_stat): Return S_IFMT part of st_mode as
	provided by underlying filesystem.

2015-08-14  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: clarify why we emulate protected payloads
	The Hurd uses protected payloads to improve the receiver lookup on the
	server side to the point that we no longer do a hash table lookup in
	the dispatch code.

	If the kernel does not support protected payloads, we degrade
	gracefully, do one lookup in libports' dispatching code, and emulate
	the protected payload feature to still save one hash table lookup in
	the intrans function.

	* libports/manage-multithread.c (ports_manage_port_operations_multithread):
	Add comment.
	* libports/manage-one-thread.c (ports_manage_port_operations_one_thread):
	Likewise.

2015-08-14  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pflocal: fix receiver lookup
	* pflocal/mig-decls.h (begin_using_addr_payload): Use
	`ports_lookup_payload'.

2015-08-08  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Print which path init tried to execv
	* init/init.c (main): On execv failure, print which path failed.

2015-07-14  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: fix setting the name of early servers
	Previously, the exec server did not set the name of the servers
	started before the proc server.  Instead this was done by the startup
	server, but this was merely a workaround, missing notably the startup
	server itself.

	* exec/exec.c (set_name): New function.
	(do_exec): Move the code setting the name to a new function, and also
	call it if the proc server is not started yet.
	* startup/startup.c (run): Drop hack.

2015-07-04  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Do not keep mutex locked while waiting for authenticate loop
	* libdiskfs/io-reauthenticate.c (diskfs_S_io_reauthenticate): Release the node
	lock while blocking on the auth server and client.
	* libnetfs/io-reauthenticate.c (netfs_S_io_reauthenticate): Likewise.
	* pfinet/io-ops.c (S_io_reauthenticate): Likewise.

2015-06-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpcscan: new utility
	* utils/rpcscan.c: New file.
	* utils/Makefile: Add `rpcscan'.

	utils: split-off the message id parsing
	* utils/rpctrace.c: Move all the code handling the message id files...
	* utils/msgids.c: ... to a new file.
	* utils/msgids.h: And add the relevand declarations.
	* utils/Makefile (SRCS): Add the new file.

2015-06-17  Svante Signell  <svante.signell@gmail.com>

	Cope with scripts which chmod -x directories
	As well as other potential mode changes which are indeed supposed to still
	work as root.

	* trans/fakeroot.c (netfs_attempt_chmod): Always set S_IRUSR and S_IWUSR in
	real_mode, and set S_IXUSR also when this is a directory.

2015-06-05  Esa Peuha  <esa.peuha@gmail.com>

	Fix ps -o %r infinite loop
	* libps/fmt.c (_fmt_create): When nothing at all was recognized, break out
	instead of looping.

2015-06-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: do not print a message on ENOMEM
	* libdiskfs/node-cache.c (diskfs_node_iterate): Do not print a message
	on ENOMEM.

2015-06-05  Diego Nieto Cid  <dnietoc@gmail.com>

	Check AWK usability when XKB is enabled
	* configure.ac: test whether AWK provides strtonum function.

2015-06-05  Diego Nieto Cid  <dnietoc@gmail.com>

	console-client: Fix lower range of binary search
	To prevent infinite recursion range checking was introduced
	as an exit condition adding two extra comparisons on each
	recursive call.

	By fixing the range used by the recursive call over the lower
	half of the array one can avoid penalizing successful lookups
	while still preventing infinite recursion due to `first`
	parameter being greater than `last` parameter.

	* console-client/xkb/kstoucs.c (find_ucs): don't remove middle from the
	lower range. Remove extra comparisons.

2015-06-05  Diego Nieto Cid  <dnietoc@gmail.com>

	console-client: assert precondition
	* console-client/xkb/kstoucs.c (find_ucs): assert precondition.

2015-05-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/vmstat: fix integer overflow
	Previously, the `vmstat' utility would stop displaying the memory
	object hit ratio after some time due to an integer overflow.

	* utils/vmstat.c (get_memobj_hit_ratio): Fix integer overflow.

2015-05-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: fix build with -O0
	* utils/Makefile: Link against `libshouldbeinlibc'.

2015-05-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	console-client: fix binary search
	Previously, the binary search through the keysym map was incorrectly
	implemented.  This resulted in infinite loops (thanks to the compilers
	tail call optimization) or crashes (if the stack space was exhausted).

	* console-client/xkb/kstoucs.c (find_ucs): Fix binary search.

2015-05-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	console-client: avoid nested function
	* console-client/xkb/kstoucs.c (find_ucs): Previously, this function
	was a nested function for no reason at all.  Turn it into a normal
	function.

	console-client: fix build with -O0
	* console-client/timer.h (fetch_jiffies): Make function `static inline'.

2015-05-22  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	fakeroot: Fix reopening files after a chmod
	Huge thanks to Svante Signell for having tracked the bug.

	* trans/fakeroot.c (netfs_attempt_chmod): Make the file_chmod call
	additionally include the modes from nn->openmodes.

2015-05-22  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make comment clearer
	* trans/fakeroot.c (check_openmodes): Make comment clearer about missing new
	openmodes.

2015-05-22  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make sure to record only RWX open modes
	Thanks Svante Signell for the investigation and proposed patch.

	* trans/fakeroot.c (new_node): Assert that `openmodes' includes only
	O_RDWR|O_EXEC
	(check_openmodes): Likewise with `newmodes'.
	(netfs_S_dir_lookup): Keep only O_RDWR|O_EXEC from `flags' when calling
	new_node.

2015-05-19  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: fix error handling
	* fatfs/dir.c (diskfs_dirrewrite_hard): Fix error handling.

2015-05-19  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix renaming of directories
	Previously, file permissions and ownership of the target directory
	were ignored when renaming a directory:

	    % mkdir a b
	    % chmod 555 a
	    % mv b a
	    % ls a
	    b

	* libdiskfs/dir-renamed.c (diskfs_rename_dir): Fix error handling.

2015-05-14  Svante Signell  <svante.signell@gmail.com>

	Fix creating named sockets inside fakeroot-hurd
	* trans/fakeroot.c (netfs_set_translator): New function.

2015-04-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: port to libdiskfs' node cache
	* fatfs/inode.c: Drop all cache-related code.
	(diskfs_user_make_node): New function.
	(diskfs_cached_lookup_in_dirbuf): Reimplement using the `lookup_context'.
	(read_node): Rename to diskfs_user_read_node and adopt accordingly.
	(diskfs_try_dropping_softrefs): Rename to `diskfs_user_try_dropping_softrefs'.
	(diskfs_node_reload): Pass context to `diskfs_user_read_node'.
	(diskfs_alloc_node): Pass `dir' via context to `diskfs_user_read_node'.
	* fatfs/fatfs.h (struct disknode): Drop fields `hnext', `hprevp'.
	(struct lookup_context): New definition.
	(ifind): Drop declaration.
	* fatfs/dir.c (diskfs_lookup_hard): Adjust accordingly.
	* fatfs/main.c (fetch_root): Likewise.

	isofs: port to libdiskfs' node cache
	* isofs/inode.c: Drop all cache-related code.
	(diskfs_user_make_node): New function.
	(calculate_file_start): Check for `record' being null.
	(cache_id): New function.
	(read_node): Rename to diskfs_user_read_node and adopt accordingly.
	(diskfs_try_dropping_softrefs): Rename to diskfs_user_try_dropping_softrefs.
	* isofs/isofs.h (struct lookup_context): New definition.
	(cache_id): New declaration.
	* isofs/lookup.c (diskfs_lookup_hard): Adjust accordingly.
	* isofs/main.c (fetch_root): Likewise.

2015-04-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: implement a node cache
	Previously, all users of libdiskfs implemented a node cache on their
	own.  Move the node cache from ext2fs into libdiskfs.  We preserve the
	previous API by marking all functions that we pull from ext2fs as
	weak, so that users like tmpfs can still implement their own node
	cache.

	* ext2fs/dir.c (diskfs_lookup_hard): Adjust accordingly.
	* ext2fs/ext2fs.c (main): Don't call `inode_init'.
	* ext2fs/ext2fs.h (struct disknode): Drop `hnext', `hprevp'.
	* ext2fs/inode.c: Move the node cache into diskfs.
	(diskfs_user_make_node): New function.
	(diskfs_try_dropping_softrefs): Rename to `diskfs_user_try_dropping_softrefs'.
	(read_node): Rename to `diskfs_user_read_node'.  Also move a chunk of
	code dealing with generations from `diskfs_cached_lookup' here.
	* libdiskfs/Makefile (OTHERSRCS): Add `node-cache.c'.
	* libdiskfs/diskfs.h (struct node): Add `hnext', `hprevp'.
	Amend existing comments, add forward declarations.
	* libdiskfs/node-cache.c: New file.

2015-04-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: use fat nodes
	Use `diskfs_make_node_alloc' to allocate both the node and the
	disknode in a continuous chunk of memory.  This increases locality and
	reduces the pressure on the memory allocator.

	* ext2fs/inode.c: Use `diskfs_node_disknode' to access the disknode.
	(diskfs_cached_lookup): Use `diskfs_make_node_alloc' to allocate the
	node.
	(diskfs_node_norefs): Only free `np'.
	* ext2fs/dir.c: Use `diskfs_node_disknode' to access the disknode.
	* ext2fs/ext2fs.h: Likewise.
	* ext2fs/getblk.c: Likewise.
	* ext2fs/ialloc.c: Likewise.
	* ext2fs/pager.c: Likewise.
	* ext2fs/truncate.c: Likewise.

2015-04-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: declare all inline functions as `extern inline'
	* libdiskfs/diskfs.h (diskfs_node_disknode, diskfs_disknode_node):
	Declare functions as `extern inline' so that we can use them in other
	functions declared as `extern inline'.

	libdiskfs: fix node initialization
	* libdiskfs/node-make.c (init_node): Initialize flag `author_tracks_uid'.

	libdiskfs: drop unused fields from struct node
	* libdiskfs/diskfs.h (struct node): Drop unused fields from struct
	node.

	libdiskfs: make struct node more compact
	* libdiskfs/diskfs.h (struct node): Turn flags into a bit field.

	libdiskfs: lock-less reference counting of nodes
	* libdiskfs/diskfs.h (struct node): Use refcounts_t for reference counting.
	(diskfs_node_refcnt_lock): Remove.
	(diskfs_node_norefs,diskfs_drop_node): Change comments accordingly.
	* libdiskfs/init-init.c: Adjust accordingly.
	* libdiskfs/node-drop.c: Likewise.
	* libdiskfs/node-make.c: Likewise.
	* libdiskfs/node-nput.c: Likewise.
	* libdiskfs/node-nputl.c: Likewise.
	* libdiskfs/node-nref.c: Likewise.
	* libdiskfs/node-nrefl.c: Likewise.
	* libdiskfs/node-nrele.c: Likewise.
	* libdiskfs/node-nrelel.c: Likewise.
	* ext2fs/inode.c: Likewise.
	* fatfs/inode.c: Likewise.
	* isofs/inode.c: Likewise.
	* tmpfs/node.c: Likewise.
	* doc/hurd.texi: Likewise.

2015-04-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	tmpfs: use a seperate lock to protect all_nodes
	Previously, tmpfs used diskfs_node_refcnt_lock to serialize access to
	the all_nodes and some other related global state related to memory
	consumption.

	Use a separate lock to protect all_nodes, and atomic operations to
	access the state related to memory consumption. Adjust the reference
	counting accordingly.  Every node in the all_nodes carries a light
	reference.  When we are asked to give up that light reference, we
	reacquire our lock momentarily to check whether someone else
	reacquired a reference through the all_nodes.

	* tmpfs/tmpfs.h (num_files, tmpfs_space_used): Use atomic operations
	for these variables.
	(adjust_used): Use atomic operations.
	(get_used): New convenience function to atomically retrieve
	tmpfs_space_used.
	* tmpfs/node.c (all_nodes_lock): New lock.
	(diskfs_alloc_node): Use a separate lock to protect all_nodes.
	Adjust the reference counting accordingly.
	(diskfs_free_node): Likewise.
	(diskfs_cached_lookup):Likewise.
	(diskfs_node_iterate): Likewise.
	(diskfs_node_norefs): Do not remove the node from all_nodes.  This
	actually looks like a mistake, I do not know why they did that here as
	well as in diskfs_free_node.
	(diskfs_try_dropping_softrefs): Check whether someone reacquired a
	reference, and if so hold on to our light reference.
	(diskfs_grow): Use atomic operations.
	* tmpfs/tmpfs.c (diskfs_set_statfs): Likewise.

2015-04-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	isofs: use a seperate lock to protect node_cache
	Previously, isofs used diskfs_node_refcnt_lock to serialize access to
	the node_cache.

	Use a separate lock to protect node_cache.  Adjust the reference
	counting accordingly.  Every node in the node_cache carries a light
	reference.  When we are asked to give up that light reference, we
	reacquire our lock momentarily to check whether someone else
	reacquired a reference through the node_cache.

	* isofs/inode.c (nodecache_lock): New lock.
	(inode_cache_find): Use a separate lock to protect node_cache.
	Adjust the reference counting accordingly.
	(diskfs_cached_lookup): Likewise.
	(load_inode): Likewise.
	(cache_inode): Update comment accordingly.
	(diskfs_node_iterate): Likewise.
	(diskfs_node_norefs): Move the code removing the node from node_cache...
	(diskfs_try_dropping_softrefs): ... here, where we check whether
	someone reacquired a reference, and if so hold on to our light
	reference.

2015-04-11  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: use a seperate lock to protect nodehash
	Previously, fatfs used diskfs_node_refcnt_lock to serialize access to
	the nodehash.

	Use a separate lock to protect nodehash.  Adjust the reference
	counting accordingly.  Every node in the nodehash carries a light
	reference.  When we are asked to give up that light reference, we
	reacquire our lock momentarily to check whether someone else
	reacquired a reference through the nodehash.

	* fatfs/inode.c (nodecache_lock): New lock.
	(diskfs_cached_lookup): Use a separate lock to protect nodehash.
	Adjust the reference counting accordingly.
	(ifind): Likewise.
	(diskfs_node_iterate): Likewise.
	(diskfs_node_norefs): Move the code removing the node from nodehash...
	(diskfs_try_dropping_softrefs): ... here, where we check whether
	someone reacquired a reference, and if so hold on to our light
	reference.

2015-04-11  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: use a seperate lock to protect nodehash
	Previously, ext2fs used diskfs_node_refcnt_lock to serialize access to
	the nodehash.

	Use a separate lock to protect nodehash.  Adjust the reference
	counting accordingly.  Every node in the nodehash carries a light
	reference.  When we are asked to give up that light reference, we
	reacquire our lock momentarily to check whether someone else
	reacquired a reference through the nodehash.

	* ext2fs/inode.c (nodecache_lock): New lock.
	(diskfs_cached_lookup): Use a separate lock to protect nodehash.
	Adjust the reference counting accordingly.
	(ifind): Likewise.
	(diskfs_node_iterate): Likewise.
	(diskfs_node_norefs): Move the code removing the node from nodehash...
	(diskfs_try_dropping_softrefs): ... here, where we check whether
	someone reacquired a reference, and if so hold on to our light
	reference.

2015-04-10  Thomas Schwinge  <thomas@codesourcery.com>

	GNU Hurd 0.6.
	* configure.ac (AC_INIT): Set version to 0.6.
	* NEWS: Finalize for 0.6.

2015-04-08  Justus Winter  <4winter@informatik.uni-hamburg.de>

	NEWS: mention that the init server has been split
	* NEWS: Mention that the init server has been split into the startup
	server and the init server.

2015-04-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: fix runtime option parsing
	* procfs/main.c (netfs_runtime_argp): Actually use the runtime option
	parser.

	libports: use protected payloads to optimize the object lookup
	* NEWS: Mention protected payloads.
	* libports/Makefile (SRCS): Add `port-deref-deferred.c'.
	* libports/create-internal.c (_ports_create_port_internal): Set the
	protected payload to the objects address.
	* libports/import-port.c (ports_import_port): Likewise.
	* libports/reallocate-from-external.c (ports_reallocate_from_external):
	Likewise.
	* libports/reallocate-port.c (ports_reallocate_port): Likewise.
	* libports/transfer-right.c (ports_transfer_right): Likewise.
	* libports/manage-multithread.c (ports_manage_port_operations_multithread):
	Use the protected payload for the object lookup if provided.  Add
	thread pool management calls.
	* libports/manage-one-thread.c (ports_manage_port_operations_one_thread):
	Likewise.
	* libports/destroy-right.c (ports_destroy_right): Defer the
	dereferencing of outstanding send rights to avoid a port_info
	use-after-free.
	* libports/port-deref-deferred.c: New file.
	* libports/port-deref-deferred.h: Likewise.
	* libports/ports.h (struct port_bucket): New field `threadpool'.
	(ports_lookup_payload): Check `port_right'.

	procfs: fix argument parsing
	* procfs/main.c (argp_parser): Fix argument parsing.

2015-03-05  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix space style

2015-02-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: avoid acquiring global lock in message dispatch
	* libports/interrupt-operation.c (ports_S_interrupt_operation): Update
	`cancel_threshold' using atomic operations.
	* libports/manage-multithread.c (internal_demuxer): Avoid taking the lock.
	* libports/ports.h (struct port_info): Mention that one needs atomic
	operations to access `cancel_threshold'.

2015-02-14  Justus Winter  <4winter@informatik.uni-hamburg.de>

	TODO: drop obsolete item
	* TODO (libpager): Drop item trying to prevent thread storms.  We
	dealt with that in a much nicer way.  Nowadays we use a fixed number
	of threads in libpager.

2015-02-08  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: add more error handling
	* startup/startup.c (launch_core_servers): Add more error handling.

2015-02-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Explicit the keymap compatibility flags
	Since "default" is not provided any more by xkb

	* console-client/xkb/xkb-data/keymap/hurd: Replace "default"
	xkb_compatibility by
	"basic+mousekeys+accessx(basic)+misc+iso9995+level5+caps(caps_lock)" for all
	keymaps.

2015-02-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Allow dhcp trafic and configuration
	2007-10-14  Christian Dietrich  <stettberger@dokucode.de>

	* options.c (options): Marked -a, -g -m, -p, -A, -G
	OPTION_ARG_OPTIONAL.
	(parse_interface_copy_device): New function.
	(parse_opt): When selecting another interface with -i
	set the options from e.g. a prior fsysopts call as default
	values. For -a, -g, -p, -g, -A, -G set the optional
	argument as value. When there is no argument, delete the
	value (e.g. unset default gateway). Delete delete default gateways
	only if the set gateway is on an interface modified in this call.
	Add always an route for dhcp packages on all devices. By doing
	this we can send dhcp renew packages.
	(trivfs_append_args): Add --gateway only once.

	2007-10-14  Marco Gerards  <metgerards@student.han.nl>

	        * options.c (parse_opt): Add the route for `0.0.0.0' so broadcasting
	        works.

	* linux-src/net/ipv4/devinet.c (inet_insert_ifa) [_HURD_]: Don't
	fail when the address is `0.0.0.0'.

2015-02-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Remove unimplemented -s option
	* pfinet/options.c (options): Remove 's' case.

2015-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: fix notification port handling
	* utils/rpctrace.c (new_receiver_info): Fix handling of old
	notification port.

2015-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	console: fix error and notification port handling
	This fixes a deallocation of an invalid port notably seen on system
	shutdown.

	* console/display.c (free_modreqs): Handle errors of
	`mach_port_request_notification' and check whether the old
	notification port was valid.
	(do_mach_notify_msg_accepted): Likewise.
	(display_notice_filechange): Likewise.

2015-01-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: call `startup_essential_task' earlier
	Previously, the proc server did not call `startup_essential_task'
	until it got the message port of the startup server using
	`proc_setmsgport'.

	Now that we have `/servers/startup', we can do this in main, before we
	start our message service loop.

	A complication arises because the traditional startup server is
	single-threaded.  Handle this by tweaking startup not to bind itself
	to `/servers/startup' before it is ready.

	* proc/main.c (main): Try to lookup `/servers/startup' and send the
	message here, or...
	* proc/msg.c (S_proc_setmsgport): ... fall back to the old way here.
	* proc/proc.h (startup_fallback): New variable.
	* startup/startup.c (main): Move code installing ourself on `/servers/startup'
	(install_as_translator): ... here.
	(launch_core_servers): And use it here, just before we reply to `/hurd/auth'.

2015-01-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	auth: remove implicit assumption about the bootstrap process
	The current code assumes that it can speak the startup protocol over
	its bootstrap port.

	* auth/auth.c (main): Generalize by trying to use `/servers/startup'
	before falling back to the bootstrap port.

2015-01-17  Justus Winter  <4winter@informatik.uni-hamburg.de>

	auth: simplify expression
	* auth/auth.c (S_auth_{user,server}_authenticate): Simplify expression.

	startup: give the tasks we create a name
	* startup/startup.c (run): Name the tasks we start.

	libports: silence pointless error message
	* libports/manage-multithread.c (adjust_priority): Silence pointless
	error message.

	libdiskfs: fix port leak
	* libdiskfs/boot-start.c (get_console): Deallocate `device_master'.

	libfshelp: improve error handling
	* libfshelp/start-translator-long.c (fshelp_start_translator_long):
	Once we have a task, go to `lose_task' so that we do not leave hosed
	tasks around.

2015-01-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	random: fix typo
	* random/gnupg-random.c (read_pool): Fix typo in comment.

2015-01-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Backport Linux changes for proper TCP EOF handling
	Notably when remote eagerly sends a RST: we want to return EOF to the
	application, not EPIPE.

	* pfinet/linux-src/net/ipv4/tcp_output.c (tcp_connect): Set sk->done to 0.
	* pfinet/linux-src/net/ipv4/tcp_input.c (tcp_fin): Set RCV_SHUTDOWN, and
	sk->done to 1.
	* pfinet/linux-src/net/ipv4/tcp.c (tcp_recv_urg): Only return ENOTCONN when
	we never actually connect.  Always return 0 when reception is closed.
	(tcp_recvmsg): When any data is available, ignore errors and EOF.  When no
	data is available, first check for reception being closed, then for errors.

2015-01-03  Stefan Weil  <sw@weilnetz.de>

	procfs: Fix typos in comments (found by codespell)

	libshouldbeinlibc: Fix typo in local variable name

	misc: Fix typos in comments (found by codespell)

	console: Fix typos in comments

	console-client: Fix typos in comments

	aclocal.m4, configure.ac: Fix typos and grammar in comment (found by codespell)

	lib*: Fix typos in comments (found by codespell)

2014-12-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Revert "Make sure to free content dir in procfs"
	This reverts commit 5fe615a4d66f4dea48812ed9e4f250010a8f9298.

2014-12-26  Lancelot SIX  <lancelot@lancleotsix.com>

	Make sure to free content dir in procfs
	In procfs/netfs.c:netfs_get_dirents, make sure to free the memory
	allocated with the "get_contents" callback of nodes.

2014-12-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Avoid ./ components in mtab output
	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): Match "." path as being the
	root directory.
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Likewise.

2014-12-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: make the protected payload changes less intrusive
	The changes to `hurd_types.defs' caused the glibc build to fail.
	Guard the problematic parts with `HURD_SERVER' similar how it is done
	in GNU Mach.

	* Makeconf: Define `HURD_SERVER' when preprocessing the RPC
	definitions for the server side.
	* hurd/hurd_types.defs: Guard problematic parts with `HURD_SERVER'.

2014-12-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix inclusion loop between hurd_types.defs and hurd/signal.h>
	* boot/Makefile (MIGSFLAGS): Add -DHURD_DEFAULT_PAYLOAD_TO_PORT=1.
	* mach-defpager/Makefile (MIGSFLAGS): Likewise.
	* hurd/hurd_types.defs: Do not include <hurd/ports.h>.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Replace `bcopy' with `memcpy' or `memmove' as appropriate
	* ext2fs/inode.c: Replace `bcopy' with `memcpy' or `memmove' as
	appropriate.
	* ext2fs/pager.c: Likewise.
	* isofs/lookup.c: Likewise.
	* isofs/main.c: Likewise.
	* isofs/rr.c: Likewise.
	* libdiskfs/file-get-trans.c: Likewise.
	* libiohelp/return-buffer.c: Likewise.
	* libpager/pagemap.c: Likewise.
	* libpipe/pq.c: Likewise.
	* libpipe/pq.h: Likewise.
	* libstore/unzipstore.c: Likewise.
	* mach-defpager/default_pager.c: Likewise.
	* pfinet/ethernet.c: Likewise.
	* pfinet/tunnel.c: Likewise.
	* storeio/dev.c: Likewise.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Replace `bzero' with `memset'
	For reference, this patch was created using the following semantic
	patch, and then manually applying the change in all functions
	containing nested functions, as those are not supported by Coccinelle.

	@@
	expression A, B;
	@@

	- bzero (A, B)
	+ memset (A, 0, B)

	* auth/auth.c: Replace `bzero' with `memset'.
	* boot/boot.c: Likewise.
	* defpager/defpager.c: Likewise.
	* exec/exec.c: Likewise.  Also, drop `safe_bzero' and just use
	`hurd_safe_memset' directly.
	* ext2fs/ext2fs.c: Likewise.
	* ext2fs/getblk.c: Likewise.
	* ext2fs/pager.c: Likewise.
	* fatfs/pager.c: Likewise.
	* ftpfs/dir.c: Likewise.
	* ftpfs/netfs.c: Likewise.
	* isofs/inode.c: Likewise.
	* isofs/pager.c: Likewise.
	* libdiskfs/file-getfh.c: Likewise.
	* libdiskfs/file-statfs.c: Likewise.
	* libfshelp/fetch-root.c: Likewise.
	* libfshelp/start-translator.c: Likewise.
	* libftpconn/create.c: Likewise.
	* libftpconn/open.c: Likewise.
	* libftpconn/unix.c: Likewise.
	* libpipe/pipe.c: Likewise.
	* libps/procstat.c: Likewise.
	* libps/spec.c: Likewise.
	* libshouldbeinlibc/cacheq.c: Likewise.
	* libshouldbeinlibc/idvec.c: Likewise.
	* libshouldbeinlibc/ugids.c: Likewise.
	* libstore/argp.c: Likewise.
	* libstore/enc.c: Likewise.
	* libstore/kids.c: Likewise.
	* libthreads/alpha/thread.c: Likewise.
	* libtreefs/fsys.c: Likewise.
	* libtrivfs/file-statfs.c: Likewise.
	* mach-defpager/default_pager.c: Likewise.
	* pfinet/glue-include/asm/uaccess.h: Likewise.
	* pfinet/io-ops.c: Likewise.
	* pfinet/options.c: Likewise.
	* pfinet/socket.c: Likewise.
	* pfinet/timer-emul.c: Likewise.
	* pflocal/io.c: Likewise.
	* startup/startup.c: Likewise.
	* storeio/storeio.c: Likewise.
	* sutils/fstab.c: Likewise.
	* usermux/usermux.c: Likewise.
	* utils/fakeauth.c: Likewise.
	* utils/frobauth.c: Likewise.
	* utils/login.c: Likewise.
	* utils/x.c: Likewise.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: tune the size of the inode cache
	The node cache uses a fixed number of buckets giving it a linear
	access complexity, although with a small constant factor.  Paper over
	this issue by increasing the number of buckets.

	* ext2fs/inode.c (INOHSZ): Increase from 512 to 8192 entries.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: use libports notification functions
	Now that we do not use sequence numbers anymore, we can simply use
	libports notification server functions.

	* libpager/Makefile (SRCS): Drop `no-senders.c', and `notify-stubs.c'.
	(OBJS): Drop `notifyServer.o'.
	* libpager/demuxer.c (pager_demuxer): Use libports server functions.
	* libpager/mig-mutate.h: Drop all notification mutators.
	* libpager/no-senders.c: Remove file.
	* libpager/notify-stubs.c: Likewise.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: remove the `seqno' parameters
	* libpager/Makefile (MIGSFLAGS): Drop `-DSEQNOS'.
	* libpager/priv.h (struct pager): Drop fields `seqno' and `waitingforseqno'.
	* libpager/chg-compl.c: Adopt accordingly.
	* libpager/data-request.c: Likewise.
	* libpager/data-return.c: Likewise.
	* libpager/data-unlock.c: Likewise.
	* libpager/demuxer.c: Likewise.
	* libpager/lock-completed.c: Likewise.
	* libpager/no-senders.c: Likewise.
	* libpager/notify-stubs.c: Likewise.
	* libpager/object-init.c: Likewise.
	* libpager/object-terminate.c: Likewise.
	* libpager/pager-create.c: Likewise.
	* libpager/stubs.c: Likewise.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: add `proc_make_task_namespace'
	Add a new RPC to the process protocol to create task namespaces.
	These can be used by an unprivileged process to claims the
	responsibility to manage all tasks in this namespace.  Any task
	created in this namespace will automatically be declared a child of
	the root process, and a `mach_notify_new_task' message is sent to a
	given port.  If the root process dies, the proc server will terminate
	all tasks in the namespace.

	* hurd/process.defs (proc_make_task_namespace): New RPC.

2014-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: implement `proc_make_task_namespace'
	* proc/proc.h (struct proc): Add field `p_task_namespace'.
	* proc/mgt.c (S_proc_child): Propagate `p_task_namespace' to child.
	(allocate_proc): Initialize `p_task_namespace'.
	(namespace_terminate): New function.
	(process_has_exited): Reparent children of dead tasks in the namespace
	to the root process.  Terminate all tasks if the root process dies.
	Reap dead tasks.
	(S_mach_notify_new_task): For newly created tasks thats parent is in a
	namespace, call S_proc_child and forward the `mach_notify_new_task'
	message.
	(S_proc_make_task_namespace): New function.

	proc: register for new task notifications
	* proc/Makefile (MIGSTUBS): Add `gnumachServer.o'.
	* proc/main.c (message_demuxer): Handle the `task_notify' protocol.
	(main): Register for new task notificatinos.
	* proc/mgt.c (S_mach_notify_new_task): Add server function.

	Makeconf: handle the task_notify protocol
	* Makeconf (mach_defs_names): Add `task_notify'.

2014-12-10  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	fakeroot: Fix initializing default faked field of nodes
	* trans/fakeroot.c (new_node): Initialize faked field to FAKE_DEFAULT.

2014-12-09  David Michael  <fedora.dm0@gmail.com>

	include: don't install nonexistent refcount.h
	* include/Makefile (installhdrs): Remove refcount.h.

2014-12-09  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix mode of nodes created with mkfile
	Their faked field was not initialized.
	Thanks a lot to Svante Signell for the investigation

	* trans/fakeroot.c (new_node): Initialize faked field of nn to 0.
	(netfs_attempt_mkfile): Call set_default_attributes on newly-allocated node,
	and if the real mode is not the same as the requested mode, fake the mode.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: add intranpayload functions to all hurd types
	For each hurd type defined in hurd_types.h, add a intranpayload
	function.  If an X_INTRAN mutation is defined for a type, a
	corresponding X_INTRAN_PAYLOAD has to be defined.  If no X_INTRAN
	mutation is defined, use ports_payload_get_name as intranpayload
	function, turning the payload back into an port name.

	* hurd/hurd_types.defs: Add intranpayload functions.
	* hurd/term.defs: Likewise.
	* hurd/default_pager.defs: Include `hurd_types.defs' for
	`MACH_PAYLOAD_TO_PORT'.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: make `trace_and_forward' payload-aware
	As the protected payloads were retrofitted into the Mach message
	format, the local port type is lost.

	* utils/rpctrace.c (is_notification): New function
	(trace_and_forward): Recover the original local port type.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/symlink: disable default payload to port mapping
	`fsysServer' is only used by the symlink translator which does not use
	libports.  Therefor, it is not necessary to use the default payload to
	port translation function.

	* trans/Makefile (fsys-MIGSFLAGS): Disable the default payload to port
	translation function.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/streamio: make the translator payload-aware
	* trans/Makefile (device_reply-MIGSFLAGS): Define MACH_PAYLOAD_TO_PORT.

	trans/password: add a payload-aware intrans function
	* trans/Makefile (password-MIGSFLAGS): Add mutator.

	trans/ifsock: add a payload-aware intrans function
	* trans/Makefile (ifsock-MIGSFLAGS): Add mutator.

	trans/fakeroot: make the demuxer payload-aware
	* trans/fakeroot.c (netfs_demuxer): Make the demuxer payload-aware.

	term: add a payload-aware intrans function
	* term/mig-mutate.h: Add mutator.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: disable default payload to port mapping
	startup does not use libports. Therefor, it is not necessary to use the
	default payload to port translation function.

	* startup/Makefile (MIGSFLAGS): Disable the default payload to port
	translation function.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: add payload-aware intrans functions
	* proc/mig-decls.h (begin_using_proc_payload): New function.
	(begin_using_exc_payload): Likewise.
	* proc/mig-mutate.h: Add mutators.
	* proc/proc_exc.defs (exception_t): Add payload-aware in-translator
	function.

	pflocal: add payload-aware intrans functions
	* pflocal/mig-mutate.h: Add mutators.
	* pflocal/mig-decls.c (begin_using_sock_user_payload): New function.
	(begin_using_addr_payload): Likewise.

	pfinet: make the demuxers payload-aware
	* pfinet/ethernet.c (ethernet_demuxer): Make the demuxer payload-aware.
	* pfinet/main.c (pfinet_demuxer): Likewise.

	pfinet: add payload-aware intrans functions
	* pfinet/mig-mutate.h: Add mutators.
	* pfinet/mig-decls.h (begin_using_socket_payload): New function.
	(begin_using_sockaddr_payload): Likewise.

	exec: add payload-aware intrans functions
	* exec/execmutations.h: Add mutators.
	* exec/mig-decls.h (begin_using_bootinfo_payload): New function.

	console-client: make the demuxer payload-aware
	* console-client/trans.c (console_demuxer): make the demuxer payload-aware.

	console: add a payload-aware intrans function
	* console/priv.h (begin_using_protid_payload): New function.
	* console/mutations.h: Add mutators.

	auth: add a payload-aware intrans function
	* auth/mig-mutate.h: Add mutator.
	* auth/mig-decls.h (auth_payload_to_handle): New function.

	libcons: add a payload-aware intrans function
	* libcons/mutations.h: Add mutator.
	* libcons/priv.h (begin_using_notify_payload): New function.

	libpager: add a payload-aware intrans function
	* libpager/mig-decls.h (begin_using_pager_payload): New function.
	* libpager/mig-mutate.h: Add mutators.

	libtrivfs: add payload-aware intrans functions
	* libtrivfs/mig-decls.h (trivfs_begin_using_protid_payload): New function.
	(trivfs_begin_using_control_payload): Likewise.
	* libtrivfs/mig-mutate.h: Add mutators.

	libnetfs: add a payload-aware intrans function
	* libnetfs/priv.h (begin_using_protid_payload): New function.
	* libnetfs/mutations.h: Add mutator.

	libdiskfs: add payload-aware intrans functions
	* libdiskfs/diskfs.h (diskfs_begin_using_protid_payload): New function.
	(diskfs_begin_using_control_payload): Likewise.
	(diskfs_begin_using_bootinfo_payload): Likewise.
	* libdiskfs/fsmutations.h: Add mutators.

	libports: add a payload-aware intrans function
	* libports/mig-decls.h (begin_using_port_info_payload): New function.
	* libports/mig-mutate.h: Add mutator.

2014-12-07  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: add `ports_lookup_payload' and `ports_payload_get_name'
	These two functions map payloads to objects and port names. The former
	can be used like `ports_lookup_port' to look up objects, the latter to
	map payloads to port names if the server function expects a
	`mach_port_t'.

	* libports/ports.h: Add function ports_payload_get_name.
	* libports/lookup-payload.c: New file.
	* libports/ports.h (ports_lookup_payload): Add declaration.
	* libports/Makefile (SRCS): Add lookup-payload.c.

2014-12-06  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix coding style

2014-12-01  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: move the reference counting primitives here
	Declare all functions `extern inline' instead of `static inline'.
	This allows us to use them in functions declared as `extern inline'.

	* libshouldbeinlibc/refcount.h: Move here, and declare all functions
	`extern inline'.
	* libshouldbeinlibc/refcount.c: And define the functions here.
	* libshouldbeinlibc/Makefile: Add `refcount.{c,h}'.

2014-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Revert "random: fix a receiver lookup"
	This reverts "8927fbd63e29005ddb9b2c2264046089bf669857".

	The change mistakenly adds mutators for the `startup' protocol, but
	the server routine is for the `startup_notify' protocol.

2014-11-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add atomicity support to fshelp_acquire_lock
	This adds support for the __LOCK_ATOMIC flag which requests atomicity of SH->EX
	upgrades and EX->SH downgrades.

	* libfshelp/lock-acquire.c (__LOCK_ATOMIC): New macro
	(fshelp_acquire_lock): When __LOCK_ATOMIC is set, do not release the
	lock early, change the lock hold atomically instead. On upgrade to LOCK_EX,
	prevent new shared locks from being acquired to avoid starvation.

2014-11-27  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix proc crashes
	* proc/notify.c (do_mach_notify_dead_name): When `pi' is NULL,
	immediately return EOPNOTSUPP.

2014-11-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix fabrication of protid
	* libdiskfs/dir-init.c (diskfs_init_dir): Fix fabrication of protid.

2014-11-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: make the request queue more memory-efficient
	Previously, `pager_demuxer' allocated a chunk of memory for the
	response message.  But if memory gets scarce, the kernel will issue a
	large number of paging requests to free up memory.  In such a
	situation, allocating memory is dangerous.

	Fix this by not allocating space for the response message, rather, use
	a chunk of the workers stack space.  Also, we only handle the `notify'
	and `memory_object' protocol, which both only contain simple routines,
	we only need a `mig_response_header_t'.

	* libpager/demuxer.c (struct request): Remove `inp' and `outp'.
	(request_inp): New function.
	(pager_demuxer): Do not allocate memory for the response.
	(mig_reply_setup): New function.
	(worker_func): Adjust accordingly.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	boot: improve the demuxer
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.

	* boot/boot.c (mig_reply_setup): Provide local version.
	(request_server): Rename to `boot_demuxer', and improve the dispatch.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	boot: implement pseudo-time device
	* boot/boot.c (pseudo_time): New variable.
	(main): Allocate port `pseudo_time'.
	(ds_device_open): Give out `pseudo_time'.
	(ds_device_map): Emulate Mach-style `Mapped Time'.

	boot: support ds_device_get_status with flavor DEV_GET_RECORDS
	* boot/boot.c (ds_device_get_status): Support flavor DEV_GET_RECORDS.

	boot: drop obsolete device procedures
	* boot/boot.c (ds_xxx_device_set_status): Remove function.
	(ds_xxx_device_get_status): Likewise.
	(ds_xxx_device_set_filter): Likewise.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	boot: remove unused function `boot_script_read_file'
	The unused function `boot_script_read_file' requires access to the
	default pager, which is privileged.

	* boot/boot.c (defpager): Remove now unused variable.
	(boot_script_read_file): Remove unused function.
	(main): Do not acquire port to the default pager.
	* boot/boot_script.h (boot_script_read_file): Remove declaration.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	boot: drop bootstrap compat code
	GNU Mach never sent old-style bootstrap messages.  Drop the unused
	compatibility code.

	* boot/boot.c (request_server): Drop unused code.
	(bootstrap_compat): Drop unused function.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: also open `console' for reading
	* startup/startup.c (main): Also open `console' for reading.

	proc: gracefully handle failure to increase priority
	* proc/main.c (increase_priority): New function.
	(main): Move code increasing the proc servers priority to a new
	function and handle errors gracefully.

	Makeconf: handle the gnumach protocol
	* Makeconf (mach_defs_names): Add `gnumach'.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: bind the startup server to /servers/startup
	Previously, the Hurd (ab)used the fact that the startup server speaks
	all protocols on its message port.  Any server that wished to register
	for shutdown notifications would use proc_getmsgport to get a port to
	the startup server.

	This hardcodes the PID of /hurd/startup, and does not allow one to
	point a server to ones own startup server (e.g. using remap).

	Bind the startup server to /servers/startup instead.  Use this to
	contact the startup server.

	* exec/main.c (S_exec_init): Use /servers/startup.  Fall back to the
	old method so that the system still boots when the node
	/servers/startup is missing.
	* hurd/paths.h (_SERVERS_STARTUP): New macro.
	* libdiskfs/boot-start.c (diskfs_S_fsys_init): Use /servers/startup.
	* libdiskfs/init-startup.c (_diskfs_init_completed): Likewise.
	* pfinet/main.c (arrange_shutdown_notification): Likewise.
	* startup/Makefile (OBJS): Add fsysServer.o.
	* startup/startup.c (demuxer): Handle the fsys protocol.
	(main): Bind to /servers/startup.
	(S_fsys_getroot): Implement fsys_getroot.  Stub out the rest.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: fix the declaration of the *_server functions
	* startup/startup.c (demuxer): Fix the declaration of the server functions.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: be more specific in the shutdown message
	Use the BOOT macro to print either halt or reboot instead of the
	generic shutdown in the event of an system shutdown.

	* startup/startup.c (reboot_system): Use more specific message.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: do not pass signals on to the child
	Formerly /hurd/startup would forward all signals to the child it
	started (e.g. /libexec/runsystem).

	The motivation for doing so is not revealed in the comments, nor it is
	mentioned in the history of the version control system.

	This patch removes the forwarding of signals to the child.

	* startup/startup.c (process_signal): Do not pass signals on to the child.
	* startup/stubs.c: Remove file.
	* startup/Makefile: Remove stubs.c.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	init: add a minimalist init program
	This patch adds a minimalist init program.  It is somewhat lacking in
	features, but is able to bring up a Hurd system with the runsystem and
	rc scripts.  In fact, it roughly does what the former /hurd/init did,
	modulo all the very early bootstrapping stuff and the startup
	protocol.  It is started when all the essential servers are up and
	running, so it can make use of most of the POSIX goodies, making its
	implementation much simpler.

	* Makefile (prog-subdirs): Add init.
	* daemons/runsystem.sh: Generalize runsystem so that it can start any
	init as specified on the kernel command line.  By default, it starts
	/hurd/init.
	* daemons/runsystem.hurd: This is a verbatim copy of runsystem.sh.  It
	is started by /hurd/init.
	* daemons/rc.sh: Do not start /hurd/mach-defpager as it is already
	started in runsystem.sh.
	* daemons/Makefile (SRCS): Add runsystem.hurd.
	* init/Makefile: New file.
	* init/init.c: Likewise.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	startup: rename /hurd/init to /hurd/startup
	This patch series splits /hurd/init into two programs.  As a first
	step, this patch renames /hurd/init to /hurd/startup.  It is called
	startup because it speaks the startup protocol.

	* startup: Rename init to startup.  Adjust accordingly.
	* Makefile (prog-subdirs): Likewise.
	* doc/hurd.texi (Server Bootstrap): Likewise.
	* hurd/paths.h (_HURD_STARTUP): Likewise.
	* libdiskfs/boot-start.c (diskfs_boot_init_program): Likewise.
	* libdiskfs/opts-std-startup.c (startup_options): Likewise.

2014-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: do not hard-code the default argument values
	* procfs/main.c (common_options): If possible, do not hard-code the
	default values.

	Add proc_set_init_task, make runsystem pid 1
	* hurd/process.defs (proc_set_init_task): New procedure.
	* hurd/process_reply.defs (proc_set_init_task): Likewise.
	* hurd/process_request.defs (proc_set_init_task): Likewise.
	* include/pids.h: Add HURD_PID_INIT as 1, adjust others accordingly.
	* init/init.c (start_child): Register the child task.
	* proc/proc.h (init_proc): New variable.
	(create_startup_proc): Rename to create_init_proc.
	* proc/main.c (main): Create placeholder proc object for pid 1.
	* proc/mgt.c: Use init_proc instead of startup_proc, as the former is
	the new root of the process tree.
	(create_startup_proc): Rename to create_init_proc.
	(S_proc_set_init_task): New function.
	* doc/hurd.texi (Server Bootstrap): Update accordingly.
	* procfs/main.c: Do not hard-code kernel pid, use pids.h instead.

	trans/mtab: avoid firmlink loops
	* trans/mtab.c (struct mtab): Add a hash table to keep track of seen
	ports.
	(mtab_mark_as_seen): New function that records the identity port of a
	given node in the hash table and reports whether it has been there
	before.
	(mtab_populate): Use the new function to avoid running in circles.
	(main, open_hook): Initialize hash table.
	(close_hook): Free ports and destroy hash table.

2014-11-21  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Always canonicalize fstab entries with realpath
	To avoid spurious ./, /, symlinks, etc.

	* sutils/fstab.c (fs_set_mntent): Try to call realpath on mnt_fsname and mnt_dir
	field of `mntent'.
	(fstab_find_mount): Try to call realpath on `name' parameter.
	(fstab_find): Do not try to call realpath.
	(fstab_read): Reset errno to zero before calling getmntent.
	* utils/umount.c (main): Do not warn about missing fstab entries for
	active translators.

2014-11-21  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix compiler warning
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Initialize
	register_translator to 0, otherwise it may be used uninitialized in case
	of non-ENOENT errors.

	Fix recording complete path of passive relative translators
	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Prepend current path to
	the relative path before recording the active translator.

	Fix recording complete path of passive relative translators
	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): Prepend current path to
	the relative path before recording the active translator.

	Let pty readers always read end of writer output
	* term/ptyio.c (pty_io_read): Do not return EIO when there is no writer
	any more but some output remains in the pipe.

2014-11-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: fix crash while printing messages
	% fakeroot rpctrace install
	[...]
	  63<--66(pid5363)->io_read (-1 8192) = 0 [... rpctrace crashes]
	/bin/fakeauth: Segmentation fault for child 5362
	/bin/settrans: Error 139 for child 5361

	* utils/rpctrace.c (print_data): Fix this by guarding the code
	escaping non-printable characters introduced in 84932431 against
	`data' being NULL.

2014-11-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make procfs appear in /proc/mounts
	d-i needs to be able to check whether /proc is mounted or not.

	* procfs/main.c (netfs_get_source): New function.

2014-11-10  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix mach-defpager's kalloc values
	* mach-defpager/kalloc.c (MINSIZE): Set to sizeof(vm_offset_t) instead
	of hardcoded 4.
	(kalloc_init): Set kalloc_max to MINSIZE << (KLIST_MAX-1) instead of
	hardcoded 16384.
	(kalloc, kfree): Use the cache for the maximum size too.

	Avoid hitting VM_MAX_ADDRESS
	* libpager/pager-memcpy.c (pager_memcpy): Reset address passed to vm_map
	on each loop, to avoid potentially monotonically increasing up to
	VM_MAX_ADDRESS.

2014-11-09  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Deal with odd kernel behavior
	Some versions of gnumach actually take address as a mapping hint, and would fail
	if the hint is bogus.  Make sure to pass 0 for those versions.

	* libstore/memobj.c (memobj_read): Make sure to set *buf to 0 before
	calling vm_map.

2014-11-09  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Deal with odd kernel behavior
	Some versions of gnumach actually take address as a mapping hint, and would fail
	if the hint is bogus.  Make sure to pass 0 for those versions.

	* console/pager.c (user_pager_create): Make sure to set *user to 0 before
	calling vm_map.
	* libdiskfs/disk-pager.c (diskfs_start_disk_pager): Make sure to set *image to 0
	before calling vm_map.
	* libpager/pager-memcpy.c (pager_memcpy): Set window to 0 before calling
	vm_map.
	* tmpfs/node.c (diskfs_get_filemap): Make sure to set np->dn->u.reg.memref to 0
	before calling vm_map.

2014-11-03  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: use a fixed number of threads
	Previously, libpager used an unbounded number of threads to receive
	messages from the pager bucket.  It used sequence barriers to execute
	the requests to order requests to each object.

	The sequence barriers are implemented in seqnos.c.  A server function
	uses _pager_wait_for_seqno to wait for its sequence number and
	_pager_release_seqno to release it, or it uses _pager_update_seqno to
	do both operations in one step.

	These sequence barriers divide each server function in three parts: A,
	B, and C.  A_i happens "before" the sequence barrier i, B_i happens
	"in order", C_i happens "after" the sequence barrier.  This partial
	order < has the following properties:

	* This order is *per object*.  Requests to different objects are not
	  ordered.

	* A_i < B_i,  B_i < C_i (due to the structure of the code)

	* B_i < B_{i+1} (this is due to the sequence barriers)

	* Note that only the B parts are ordered by the sequence numbers, we
	  are free to execute C_i and C_{i+1} in any possible order.  The same
	  argument applies to the A parts.

	The sequence barriers are implemented using a very simple ticket
	algorithm.  Every request, even the invalid ones, is processed by a
	thread, and waits until the ticket count reaches its seqno, does some
	work in-order, then increments the ticket and awakes all threads that
	have piled up up to this moment.  All of them except one will then
	discover that it's not their turn yet and go to sleep again.

	Creating one thread per request has proven to be problematic as
	memory_object requests often arrive in large batches.

	This patch does two things:

	* Use a single thread to receive messages from the port bucket.  All
	  incoming request are put into a queue.

	* Use a fixed-number of threads (though even one is actually enough)
	  to execute the the server functions.  If multiple threads are used,
	  a work-delegation mechanism ensures that the per object order < is
	  preserved.

	For reference, I used the following command to create workloads that
	highlight the problem this patch is addressing:

	% settrans t .../ext2fs --sync=30 /dev/sd2s1
	...
	% /usr/bin/time zsh -c 'for ((i=0; i < 1500; i++)); do
	  dd if=/dev/zero of=t/src/$i bs=4k count=290 2>/dev/null
	  echo -n .
	  if ((i % 100 == 0)) ; then echo -n $i; fi
	done'

	* libpager/queue.h: New file.
	* libpager/demuxer.c: Manage a queue of requests received from the
	port bucket.
	(pager_demuxer): Just decode the server function and enqueue the
	request.
	(worker_func): New function that consumes and executes the requests
	from the queue.
	(service_paging_requests): New function.
	(pager_start_workers): Likewise.
	* libpager/data-request.c: Remove the seqno barriers.
	* libpager/data-return.c: Likewise.
	* libpager/data-unlock.c: Likewise.
	* libpager/chg-compl.c: Likewise.
	* libpager/lock-completed.c: Likewise.
	* libpager/no-senders.c: Likewise.
	* libpager/notify-stubs.c: Likewise.
	* libpager/object-init.c: Likewise.
	* libpager/object-terminate.c: Likewise.
	* libpager/seqnos.c: Remove file.
	* libpager/stubs.c: Likewise.
	* libpager/pager.h (pager_demuxer): Drop declaration.
	(pager_start_workers): New declaration.
	* libpager/priv.h: Remove the _pager_seqno declarations.
	* libpager/Makefile (SRCS): Drop seqnos.c.
	* console/pager.c (user_pager_init): Call pager_start_workers.
	* libdiskfs/disk-pager.c: Likewise.
	* storeio/pager.c: Likewise.
	* ext2fs/pager.c (service_paging_requests): Remove function.
	(create_disk_pager): Start separate file pager using
	`pager_start_workers'.
	* fatfs/pager.c (service_paging_requests): Remove function.
	(create_fat_pager): Start separate file pager using
	`pager_start_workers'.

2014-11-03  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: use protected payloads for object lookups
	* mach-defpager/default_pager.c (pager_port_list_insert): Set
	protected payload.
	(pager_port_list_delete): Clear protected payload.
	* mach-defpager/mig-decls.h (begin_using_default_pager_payload): New
	function.
	* mach-defpager/mig-mutate.h: Add mutator.

2014-11-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix optional definitions in static binaries
	* libcons/extra-version.c (cons_extra_version): Add weak attribute.
	* libcons/vcons-add.c (cons_vcons_add): Likewise.
	* libcons/vcons-remove.c (cons_vcons_remove): Likewise.
	* libdiskfs/extra-version.c (diskfs_extra_version): Likewise.
	* libdiskfs/get-source.c (diskfs_get_source): Likewise.
	* libdiskfs/readonly-changed.c (diskfs_readonly_changed): Likewise.
	* libdiskfs/sync-default.c (diskfs_default_sync_interval): Likewise.
	* libdiskfs/validate-author.c (diskfs_validate_author_change): Likewise.
	* libdiskfs/validate-flags.c (diskfs_validate_flags_change): Likewise.
	* libdiskfs/validate-group.c (diskfs_validate_group_change): Likewise.
	* libdiskfs/validate-mode.c (diskfs_validate_mode_change): Likewise.
	* libdiskfs/validate-owner.c (diskfs_validate_owner_change): Likewise.
	* libdiskfs/validate-rdev.c (diskfs_validate_rdev_change): Likewise.
	* libnetfs/file-get-storage-info-default.c (netfs_file_get_storage_info):
	Likewise.
	* libnetfs/get-source.c (netfs_get_source): Likewise.
	* libnetfs/set-get-trans.c (netfs_set_translator, netfs_get_translator):
	Likewise.
	* libtrivfs/get-source.c (trivfs_get_source): Likewise.

2014-11-03  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Use a mere weak attribute instead of a weak alias
	We don't need to call the original function, so a weak attribute is
	enough.

	* libports/dead-name.c (ports_dead_name): Remove weak alias.
	(__ports_dead_name): Rename back to ports_dead_name, but add weak attribute.

2014-11-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix dead name notification in static binaries
	When linking statically, the libports definition would come before the
	libdiskfs definition, defeating the purpose of the ports_dead_name
	callback.

	* libports/dead-name.c (ports_dead_name): Rename into __ports_dead_name.
	(ports_dead_name): Add weak alias for __ports_dead_name.

2014-11-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix unlocking translator list
	* libfshelp/translator-list.c (fshelp_set_active_translator): Use common
	out path to unlock translator_ihash_lock before exitting on error.

	Fix actual procinfo_t type
	* exec/elfcore.c (dump_core): Use procinfo_t, which is already a
	pointer, instead of procinfo_t*.

2014-11-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix proc_getprocinfo calls
	The deallocation also needs to be fixed.
	Also, fetch_procinfo already took care of the conversion.

	* exec/elfcore.c (dump_core): Fix procinfoCnt taken from
	proc_getprocinfo.
	* utils/login.c (check_owned): Likewise.
	* libps/procstat.c (merge_procinfo): Remove conversion between bytes and
	int, already handled by fetch_procinfo.

2014-11-02  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix proc_getprocinfo calls
	The procinfoCnt argument is the number of elements of the procinfo_t array,
	not its size in bytes.

	* exec/elfcore.c (dump_core): Fix procinfoCnt given to proc_getprocinfo.
	* libps/procstat.c (merge_procinfo): Likewise.
	* utils/login.c (check_owned): Likewise.

2014-10-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: fix path in comment
	* pfinet/main.c: Fix path in comment.

2014-10-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: lock-less reference counting for port_info objects
	* libports/ports.h (struct port_info): Use the new type.
	* libports/lookup-port.c: No need to lock _ports_lock anymore.
	* libports/bucket-iterate.c: Likewise.
	* libports/complete-deallocate.c: Check if someone reacquired a
	reference through a hash table lookup.
	* libports/create-internal.c: Use the new reference counting primitives.
	* libports/get-right.c: Likewise.
	* libports/import-port.c: Likewise.
	* libports/port-deref-weak.c: Likewise.
	* libports/port-deref.c: Likewise.
	* libports/port-ref-weak.c: Likewise.
	* libports/port-ref.c: Likewise.
	* libports/reallocate-from-external.c: Likewise.
	* libports/transfer-right.c: Likewise.
	* utils/rpctrace.c: Likewise.

2014-10-05  Gabriele Giacone  <1o5g4r8o@gmail.com>

	utils/mount: add mount options to create firmlinks.
	* utils/mount.c (parse_opt): Add -B/--bind/--firmlink/-o bind mount
	  options.  (do_mount): Do not pass bind mount option to settrans, set
	  firmlink fstype.  (main): Likewise.

2014-10-04  Gabriele Giacone  <1o5g4r8o@gmail.com>

	utils/umount: clean up
	According to f2640263468aced5c91ac5fc1f15bb5691f7eb20, passive
	translators are no longer removed.

	* utils/umount.c (do_umount) Remove -p option from verbose message.
	(passive_flags): Remove.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: remove code counting cache misses
	* libdiskfs/lookup.c (cache_misses): Remove.
	(cm_lock): Likewise.
	(diskfs_lookup): Do not count cache misses.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: use a global hash table for the lookups
	Previously, libports used a hash table per port bucket.  This makes
	looking up a port difficult if one does not know the port bucket, as
	one has to iterate over all buckets and do a hash table lookup each.

	Having to iterate over the buckets makes it necessary to keep a list
	of all buckets, which has to be updated and protected by a lock as
	well.

	Also, the current code in _ports_bucket_class_iterate iterates over
	the hash table associated with the bucket given.  When
	ports_class_iterate calls this common function, it obtains a reference
	to the bucket from one of the ports in the given class.  This will not
	work if a class contains ports in different port buckets.  This
	limitation is not documented as far as I can see.  Again, having to
	maintain this list has its cost and requires serialization.

	Use a global hash table for lookups instead.  Keep the per-bucket hash
	tables for efficient iteration over buckets.  Furthermore, serialize
	access to all hash tables using a separate lock.  Remove the linked
	lists of all buckets and all ports in a class.

	* libports/bucket-iterate.c (ports_bucket_iterate): Acquire
	_ports_htable_lock.  Also, generalize ports_bucket_iterate so that it
	takes a pointer to a hash table as first argument.
	(ports_bucket_iterate): Ajust call to former function accordingly.
	* libports/class-iterate.c (ports_class_iterate): Just call the
	generalized _ports_bucket_class_iterate with the global hash table as
	argument.
	* libports/ports.h (struct port_info): Remove the port class links.
	(struct port_bucket): Remove the hash table, and the all buckets link.
	(_ports_all_buckets): Remove declaration.
	(_ports_htable): New global hash table.
	(_ports_htable_lock): Protected by this lock.
	* libports/claim-right.c: Adjust accordingly.
	* libports/complete-deallocate.c: Likewise.
	* libports/create-bucket.c: Likewise.
	* libports/create-class.c: Likewise.
	* libports/create-internal.c: Likewise.
	* libports/destroy-right.c: Likewise.
	* libports/import-port.c: Likewise.
	* libports/lookup-port.c: Likewise.
	* libports/reallocate-from-external.c: Likewise.
	* libports/reallocate-port.c: Likewise.
	* libports/transfer-right.c: Likewise.
	* libports/inhibit-all-rpcs.c: Iterate over the hash table.
	* libports/inhibit-bucket-rpcs.c: Likewise, but filter using bucket.
	* libports/inhibit-class-rpcs.c: Likewise, but filter using class.
	* libports/init.c (_ports_htable): Initialize.
	(_ports_htable_lock): Likewise.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: reorganize rootdir.c
	* procfs/rootdir.c: Move the translator linkage code to the
	appropriate location.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: generalize the translator linkage code
	Generalize the translator linkage code previously introduced for the
	`mounts' node.

	* procfs/rootdir.c (struct procfs_translated_node_ops): New
	specialized node operations structure for translated nodes.
	(rootdir_mounts_make_node): Generalize and rename to
	rootdir_make_translated_node.  Also, pass the entry_hook to
	procfs_make_node so that...
	(rootdir_mounts_get_translator): ... can be generalized to
	rootdir_translated_node_get_translator and read the argz vector from
	the hooked structure.
	(ROOTDIR_DEFINE_TRANSLATED_NODE): New convenience macro to define
	translated nodes.
	(rootdir_entries): Use the new code for the `mounts' node.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: do not test whether /hurd/mtab exists
	Now that procfs is merged into the Hurd repository we can just assume
	that the mtab translator exists.

	* procfs/rootdir.c (rootdir_mounts_exists): Drop function.
	(rootdir_entries): Adjust accordingly.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: implement /proc/filesystems
	* procfs/rootdir.c (rootdir_gc_filesystems): New function.
	(rootdir_entries): Use the new function to implement /proc/filesystems.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: implement /proc/N/maps
	Fixes https://savannah.gnu.org/bugs/?32770 .

	* procfs/process.c (process_file_gc_maps): New function.
	(entries): Use the new function to implement /proc/N/maps.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: redzone page zero before loading anything
	This prevents load_section from mapping any sections to page zero.

	* exec/exec.c (do_exec): Redzone page zero before loading anything.

2014-09-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: add proper argument parsing, add --device-master-port
	If the device master port is given, a boot-time exec server can print
	diagnostic messages earlier.

	* exec/main.c (opt_device_master): New variable.
	(OPT_DEVICE_MASTER_PORT): New macro.
	(options): New set of options.
	(parse_opt): New function.
	(trivfs_append_args): Likewise.
	(argp): Pull the argp definition out of main.
	(trivfs_runtime_argp): Set, so that we respond properly to fsysopts.
	(open_console): Pull the code out of S_exec_init and generalize it.
	(main): Call open_console if a device master port is given.
	(S_exec_init): Call open_console.

2014-09-28  Alexey Kuznetsov  <kuznet@ms2.inr.ac.ru>

	BSD apps want sin_zero cleared in sys_getname.
	Cherry-picked from Linux c1e9dcb37795b08a1f50b8de7b2ad5efcb15728f

	* pfinet/linux-src/net/ipv4/af_inet.c (inet_getname): Clear `sin_zero'
	part of `sin'.

2014-09-24  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Update NEWS file

2014-09-22  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: add symbolic name for the mtab translator
	* hurd/paths.h (_HURD_MTAB): New macro.
	* procfs/rootdir.c (rootdir_mounts_get_translator): Use the new macro.
	(rootdir_mounts_exists): Likewise.

2014-09-18  Justus Winter  <4winter@informatik.uni-hamburg.de>

	procfs: fix typo in comment
	* procfs/process.c (process_stat_make_node): Fix typo in comment.

2014-09-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/hello{,-mt}: properly escape contents in trivfs_append_args
	Fixes https://savannah.gnu.org/bugs/?15806 .

	* trans/hello-mt.c (trivfs_append_args): Escape contents.
	* trans/hello.c (trivfs_append_args): Likewise.

2014-09-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: make memory_object parameter polymorphic
	Make the memory_object parameter of default_pager_object_create
	polymorphic.  This fixes https://savannah.gnu.org/bugs/?26751 .

	* hurd/default_pager.defs (default_pager_object_create): Make
	memory_object parameter polymorphic.
	* mach-defpager/default_pager.c (S_default_pager_object_create):
	Adjust accordingly.
	* trans/proxy-defpager.c (S_default_pager_object_create): Likewise.

2014-09-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix /servers/exec lookup
	* libdiskfs/boot-start.c (diskfs_start_bootstrap): Pass retry_name to
	dir_lookup, which is later checked to be the empty string.

2014-08-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	include: detect use-after-free errors using the reference counts
	* include/refcount.h (refcount_init): There must be at least one
	reference at initialization time.
	(refcounts_init): Likewise.
	(refcount_unsafe_ref): New function retaining the previous
	functionality of refcount_ref.  It is occasionally useful to raise the
	reference count again after it dropped to zero.
	(refcounts_unsafe_ref): Likewise.
	(refcounts_unsafe_weak_ref): Likewise.
	(refcount_ref): Detect use-after-free errors.
	(refcounts_ref): Likewise.
	(refcounts_ref_weak): Likewise.
	* libtrivfs/protid-clean.c (trivfs_clean_protid): Use refcount_unsafe_ref.

2014-08-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: fix semantic of file_get_children
	When first introduced as fsys_get_children, it made sense to return
	the list of children using paths relative to the root of the
	filesystem that was queried.  Making the get_children method part of
	the fsys protocol was a mistake that has since been corrected in
	9366d6b2.

	Instead of returning paths relative to the root of the translator,
	return paths relative to the path of the receiving node.

	This fixes a problem with the mtab translator.  Previously, the mtab
	translator invoked on a target that was not the root directory of a
	translator would compute invalid paths, e.g.:

	/hurd/mtab: /any/path/servers/socket/26 No such file or directory

	* hurd/fs.defs (file_get_children): Update comment.
	* libfshelp/translator-list.c (fshelp_get_active_translators): Add
	argument PREFIX.  Filter entries not beginning with PREFIX if
	non-NULL, and omit PREFIX from the returned paths.
	* libfshelp/fshelp.h (fshelp_get_active_translators): Update comment
	accordingly.  Also clarify that both FILTER and PREFIX can be NULL.
	* libdiskfs/file-get-children.c (diskfs_S_file_get_children): Update
	comment, pass prefix to fshelp_get_active_translators.
	* libnetfs/file-get-children.c (netfs_S_file_get_children): Likewise.

2014-08-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: fix comparison between signed and unsigned integer
	* libihash/ihash.h (HURD_IHASH_ITERATE): Fix comparison between signed
	and unsigned integer expressions.

	trans/mtab: use setnullauth to drop privileges
	* trans/mtab.c (main): Use setnullauth to drop privileges.

	libtrivfs: fix typo
	* libtrivfs/protid-clean.c (trivfs_clean_protid): Fix typo.

2014-08-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix reference counting of peropen objects
	Previously, peropen objects were created with a reference count of
	zero.  Therefore, if diskfs_create_protid fails, passing such an
	object to diskfs_release_peropen would lead to a reference count
	underflow.

	* libdiskfs/peropen-make.c (diskfs_peropen_make): Initialize reference
	count to one.
	* libdiskfs/protid-make.c (diskfs_start_protid): And consume this
	reference on success.  Update comment.
	(diskfs_create_protid): Update comment.
	* libdiskfs/diskfs.h: Update comments.
	* libdiskfs/io-duplicate.c (diskfs_S_io_duplicate): Adjust reference
	counting accordingly.
	* libdiskfs/io-reauthenticate.c (diskfs_S_io_reauthenticate): Likewise.
	* libdiskfs/io-restrict-auth.c (diskfs_S_io_restrict_auth): Likewise.
	* doc/hurd.texi (Diskfs Internals): Update accordingly.

2014-08-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix ifsock permission check
	POSIX requires write access to the socket, not read access, to be able
	to connect to it.

	* trans/ifsock.c (S_ifsock_getsockaddr): Test for O_WRITE instead of
	O_READ.

2014-08-25  David Michael  <fedora.dm0@gmail.com>

	sutils: add urandom device target to MAKEDEV
	* sutils/MAKEDEV.sh (urandom): New target.
	(std): Add urandom to the standard devices list.

2014-08-23  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add missing linefeed
	* libpager/object-terminate.c (_pager_seqnos_memory_object_terminate):
	Add missing linefeed in error message.

2014-08-19  Svante Signell  <svante.signell@gmail.com>

	Make settrans return value returned by chroot command
	* utils/settrans.c (main): In case of chroot_command, get status from waitpid()
	call, and call error() appropriately.

2014-07-17  Marek Benc  <merkur32@gmail.com>

	Make the ncursesw driver of the console client compile properly
	* console-client/Makefile (NCURSESW_SO_SRCS): Move definition to after
	inclusion of Makeconf.

2014-06-30  Richard Braun  <rbraun@sceen.net>

	libpipe: fix spurious calls to pipe_send
	* libpipe/pipe.c (pipe_send): Skip processing if there is nothing to send.

2014-06-28  Richard Braun  <rbraun@sceen.net>

	Revert "libpipe: fix calls to pipe_send with no data"
	This reverts commit 6f856c62613ffc82bf3572a372d2851638c2fb90.

	As the comment right above the change says, "this [sending control
	packets] depends on the fact that we always write a data packet".

2014-06-28  Richard Braun  <rbraun@sceen.net>

	libpipe: fix calls to pipe_send with no data
	* libpipe/pipe.c (pipe_send): Check that there actually is any data to
	send before calling the pipe write operation.

2014-06-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: use correct type for block numbers
	* ext2fs/dir.c (count_dirents): Use block_t for nb.
	(diskfs_get_directs): Likewise for blkno, nblks.

2014-06-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix deadlock
	Previously, libdiskfs would deadlock on contention on renamedirlock
	due to the lock being taken spuriously.

	Found using fsstress from the Linux Test Project.

	* libdiskfs/dir-rename.c (diskfs_S_dir_rename): Remove spurious
	pthread_mutex_lock.

2014-06-22  Pino Toscano  <toscano.pino@tiscali.it>

	libdiskfs: expose the ST_NOATIME flag
	Expose ST_NOATIME as flag (if available in glibc) if diskfs is set in noatime
	mode.

	* libdiskfs/file-statfs.c (diskfs_S_file_statfs): Set ST_NOATIME if
	_DISKFS_NOATIME is set.

2014-06-18  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: add permission check to file_chflags
	Only root is allowed to change the high 16 bits.  The TODO entry says
	otherwise, but that must be a mistake.  For reference, see the glibc
	sources, sysdeps/mach/hurd/bits/stat.h.

	* libdiskfs/file-chflags.c (diskfs_S_file_chflags): Add permission
	check.
	* TODO (libdiskfs): Remove entry.

2014-06-18  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: avoid realloc(3) corner case
	If the size argument is 0, realloc may either return NULL, or return a
	pointer that is only valid for use with free(3).  In either case, the
	memory is freed.  So if realloc would return NULL (it does not on
	GNU), the current code would double free p.

	Found using the Clang Static Analyzer.

	* libports/bucket-iterate.c (_ports_bucket_class_iterate): Avoid
	calling realloc if no ports were matched.

2014-06-18  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: fix error handling
	Found using the Clang Static Analyzer.

	* trans/fakeroot.c (new_node): Do not leak a pointer to freed memory.
	Store NULL at *np instead.  This fixes a node use-after-free in
	netfs_S_dir_lookup.

2014-06-18  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: fix dead initialization in fmt_named_interval
	Found using the Clang Static Analyzer.

	* libshouldbeinlibc/timefmt.c (fmt_named_interval): Fix dead
	initialization.

2014-06-18  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ftpfs: fix error handling in refresh_dir
	Found using the Clang Static Analyzer.

	* ftpfs/dir.c (refresh_dir): Fix error handling.

2014-06-17  David Michael  <fedora.dm0@gmail.com>

	Add mach_debug defs rules
	* Makeconf (mach_debug_defs_names,mach_debug_defs): New variables.
	* Makeconf: Add rule to generate local $(mach_debug_defs) files.
	* procfs/Makefile: Remove vpath for mach_debug defs.

2014-06-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Add the procfs translator to prog-subdirs
	* Makefile (prog-subdirs): Add procfs.

	Merge procfs into the Hurd repository

2014-06-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Prepare the procfs translator to be merged into the Hurd sources
	Move the procfs translator to its own subdirectory 'procfs'.

	This is the last commit to this repository.  Development of the procfs
	translator will continue in the main Hurd repository.

	* procfs/Makefile: Replace the standalone Makefile with the one from
	the Debian packaging repository.

2014-06-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Merge branch 'merge-random'

2014-06-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/settrans: implement settrans --start
	Start the translator specified by the NODE's passive translator record
	and set it as NODE's active translator.  This is the equivalent of
	doing:

	% settrans --active /node $(showtrans /node)

	* utils/settrans.c (argp_option): Add --start.
	(parse_opt): Handle --start.
	(main): Retrieve the passive translator record if --start is given.

2014-06-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: fix receiver lookup in termctty_open_terminal
	* hurd/hurd_types.h (ctty_t): New type definition.
	* hurd/term.defs (ctty_t): New type definition.
	* term/mig-decls.h: New file.
	* term/mig-mutate.h: Add mutators, includes.
	* term/term.h: Add include guards.
	* term/users.c (S_termctty_open_terminal): Fix receiver lookup.
	* boot/boot.c (S_termctty_open_terminal): Likewise.

2014-06-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	term: improve the demuxer
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.

	* term/main.c (demuxer): Improve the demuxer function.

2014-06-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Add the random translator to prog-subdirs
	* Makefile (prog-subdirs): Add random.

	Merge the random translator into the Hurd repository

2014-06-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Prepare the random translator to be merged into the Hurd sources
	Move the random translator to its own subdirectory 'random'.

	This is the last commit to this repository.  Development of the random
	translator will continue in the main Hurd repository.

2014-06-08  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: fix type of retry_dotdot
	* ext2fs/dir.c (diskfs_lookup_hard): Use ino_t for retry_dotdot.

	ext2fs: fix type of blockaddr
	* ext2fs/dir.c (diskfs_lookup_hard): Use vm_address_t for blockaddr.

	ext2fs: use size_t where appropriate
	* extfs/dir.c: Use size_t where appropriate.

2014-06-06  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: fix compiler warning
	* ext2fs/pager.c (disk_cache_block_ref): block cannot be negative.

	libdiskfs: avoid implicit integer conversion
	* libdiskfs/boot-start.c (diskfs_boot_start): Avoid implicit integer
	conversion.

	libdiskfs: use correct type for disk offsets
	* libdiskfs/diskfs.h (struct peropen): Use off_t for filepointer.

	hurd: fix type of optimal_transfer_size
	* hurd/shared.h (struct shared_io): Use blksize_t for optimal_transfer_size.

	include: use unsigned literal in combination with binary not
	* include/refcount.h (refcounts_promote): Use ~0U.
	(refcounts_demote): Likewise.

2014-05-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libnetfs: fix memory leak
	* libnetfs/trans-callback.c (_netfs_translator_callback2_fn): Free
	user if creating the protid failed.

2014-05-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	tmpfs: use a thread timeout
	There is no need to keep all the threads around, just the master
	thread.

	* tmpfs/tmpfs (diskfs_thread_function): Use a thread timeout.

2014-05-30  Ludovic Courtès  <ludo@gnu.org>

	build: Remove checks for 'getgrouplist' and 'uselocale'.
	GNU libc has had them for a long time.

	* configure.ac: Remove checks for 'getgrouplist' and 'uselocale'.
	* libshouldbeinlibc/idvec-impgids.c (_merge_implied_gids): Remove #ifdef
	  HAVE_GETGROUPLIST and remove #else arm.
	* libthreads/cthreads.c: Remove #ifdef HAVE_USELOCALE, keeping its
	  bodies.

2014-05-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Merge branch 'master' of git://git.sv.gnu.org/hurd/hurd

2014-05-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libstore: provide function declaration until available upstream
	Until the Hurd specific header is available, provide a local
	declaration of ped_device_new_from_store.

	* libstore/part.c (ped_device_new_from_store): New declaration.

2014-05-29  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

2014-05-29  Ludovic Courtès  <ludo@gnu.org>

	Disable linking when cross-compiling
	* configure.ac: Call AC_NO_EXECUTABLES when cross-compiling.

2014-05-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: use a hash table for the name cache
	Previously, name cache lookup operation completed in O(n) time.  This
	means that making the cache too large would decrease the performance.
	Therefore it was required to tune the size.

	Implement the name cache using a hash table.

	We use buckets of a fixed size.  We approximate the least-frequently
	used cache algorithm by counting the number of lookups using
	saturating arithmetic in the two lowest bits of the pointer to the
	name.  Using this strategy we achieve a constant worst-case lookup and
	insertion time.

	Since we are not bound by the size of the cache anymore, increase its
	size from 200 to 1024.

	* libdiskfs/name-cache.c: Implement the name cache using a hash table.
	(diskfs_enter_lookup_cache): Change accordingly.
	(diskfs_purge_lookup_cache): Likewise.
	(diskfs_check_lookup_cache): Likewise.  Also, hard code a
	cache miss for the parent of the root directory and merge unlocking
	and releasing of node references.

2014-05-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: remove the statistics code from the name cache
	The current name cache lookup operation completes in O(n) time.  This
	means that making the cache too large would decrease the performance.
	Therefore it was required to tune the size, hence the need for
	statistics.

	We will use a data structure with worst case constant lookup times in
	the future, removing the need to fine tune the cache size.

	* libdiskfs/name-cache.c: Remove the statistics code from the name
	cache.

2014-05-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: use netfs_node_netnode instead of np->nn
	When using fat nodes, expressions of the form E->nn can be rewritten
	as netfs_node_netnode (E).  This is much faster as it only involves a
	offset calculation.  For reference, I used the following semantic
	patch to create the patch:

	@@
	expression E;
	@@

	- E->nn
	+ netfs_node_netnode (E)

	* trans/fakeroot.c: Use netfs_node_netnode instead of np->nn.

2014-05-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: use fat nodes to simplify the node cache
	Previously, fakeroot stored netnodes in the hash table.  But we are
	not interested in a cache for netnodes, we need a node cache.  So
	fakeroot kept pointers to the associated node object in each netnode
	object.

	Use fat netfs nodes, which combine node and netnode objects.

	* trans/fakeroot.c (struct netnode): Remove np.
	(idport_ihash): Fix ihash location pointer offset.
	(new_node): Allocate fat nodes, store the node pointer in the hash
	table.
	(netfs_node_norefs): Adjust accordingly.
	(netfs_S_dir_lookup): Likewise.

2014-05-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libnetfs: add netfs_make_node_alloc to allocate fat nodes
	libnetfs has two kind of nodes, struct node and struct netnode.
	struct node is used to store libnetfs specific data, while struct
	netnode contains user supplied data.  Previously, both objects were
	allocated separatly, and a pointer from the node to the netnode
	provided a mapping from the former to the latter.

	Provide a function netfs_make_node_alloc that allocates both nodes in
	a contiguous region.

	This reduces the memory allocation overhead when creating nodes.  It
	also makes the relation between node and netnode a simple offset
	calculation.  Provide two functions to compute the netnode address
	from the node address and vice-versa.

	Most notably, this makes implementing a cache on top of libnetfs
	easier.  Auxiliary data for the cache can be stored in the
	user-defined netnode, and the fat node can be used as the value.

	* libnetfs/make-node.c (init_node): Move initialization here.
	(netfs_make_node): Use init_node.
	(netfs_make_node_alloc): New function to allocate fat nodes.
	* libnetfs/netfs.h (netfs_make_node_alloc): New declaration.
	(_netfs_sizeof_struct_node): Likewise.
	(netfs_node_netnode): Compute netnode address from node address.
	(netfs_netnode_node): And vice-versa.
	* libnetfs/init-init.c (_netfs_sizeof_struct_node): New variable.

2014-05-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: add diskfs_make_node_alloc to allocate fat nodes
	libdiskfs has two kind of nodes, struct node and struct netnode.
	struct node is used to store libdiskfs specific data, while struct
	netnode contains user supplied data.  Previously, both objects were
	allocated separatly, and a pointer from the node to the netnode
	provided a mapping from the former to the latter.

	Provide a function diskfs_make_node_alloc that allocates both nodes in
	a contiguous region.

	This reduces the memory allocation overhead when creating nodes.  It
	also makes the relation between node and netnode a simple offset
	calculation.  Provide two functions to compute the netnode address
	from the node address and vice-versa.

	Most notably, this makes implementing a cache on top of libdiskfs
	easier.  Auxiliary data for the cache can be stored in the
	user-defined netnode, and the fat node can be used as the value.

	* libdiskfs/node-make.c (init_node): Move initialization here.
	(diskfs_make_node): Use init_node.
	(diskfs_make_node_alloc): New function to allocate fat nodes.
	* libdiskfs/diskfs.h (diskfs_make_node_alloc): New declaration.
	(_diskfs_sizeof_struct_node): Likewise.
	(diskfs_node_disknode): Compute disknode address from node address.
	(diskfs_disknode_node): And vice-versa.
	* libdiskfs/init-init.c (_diskfs_sizeof_struct_node): New variable.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libtrivfs: lock-less reference counting for trivfs_peropen objects
	* libtrivfs/trivfs.h (struct trivfs_peropen): Use refcount_t for field
	refcnt.
	(struct trivfs_control): Remove unused field lock.
	* libtrivfs/cntl-create.c (trivfs_create_control): Drop the mutex
	initialization.
	* libtrivfs/io-reauthenticate.c (trivfs_S_io_reauthenticate): Adjust
	accordingly.
	* libtrivfs/io-restrict-auth.c (trivfs_S_io_restrict_auth): Likewise.
	* libtrivfs/open.c (trivfs_open): Initialize refcnt.
	* libtrivfs/protid-clean.c (trivfs_clean_protid): Likewise.
	* libtrivfs/protid-dup.c (trivfs_protid_dup): Likewise.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: do not use an integer hash function by default
	Recently libihash was changed to use an integer hash function on the
	keys in an attempt to reduce the rate of collisions (2d898893), which
	has long been assumed to be high.

	Richard Braun was kind enough to run some benchmarks.  He observed:

	"1/ Using an extremely simple microbenchmark [1] that merely inserts
	keys, either random integers or sequential ones to match the way port
	names are managed, it seems that the previous code, despite its
	apparent flaws, did quite well.

	[1] http://darnassus.sceen.net/gitweb/rbraun/ihtest.git

	Using an integer hashing function actually reduces performance on the
	sequential integer test case. It makes sense because, considering a
	set of consecutive integers starting from 0, and a hash table that
	always has more slots than items, a modulo is a perfect hash
	function. Even when taking into account that only names for receive
	rights are normally managed with libihash, i.e. that keys aren't
	actually sequential, they are almost all equally distributed, leading
	to very few collisions.

	Therefore, as a third option, I've removed the hashing function,
	leaving only a fast modulo (an AND) and this variant provided the best
	raw results.

	2/ I've also built hurd packages multiple times and got average build
	times with each variant (previous, new, new without hash function) and
	here are the results I obtained respectively : 52m59s, 52m31s, 52m22s."

	Do not use the integer hash function on the keys by default.

	* libihash/ihash.c (murmur3_mix32): Remove now unused function.
	(find_index): Use the fast division method to derive the index.
	(add_one): Likewise.  Also, update the comment to reflect the current
	hashing method.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix node leak in the name cache
	* libdiskfs/name-cache.c (diskfs_check_lookup_cache): Release node
	reference in a special case of lookup failure.

	trans/mtab: fix initialization
	* trans/mtab.c (main): Fix initialization of mtab in one-shot mode.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: fix diskfs_pager_users
	This fixes a bug introduced in 86122789.

	* ext2fs/pager.c (diskfs_pager_users): We count file_pager_bucket,
	which does not include the disk pagers.  Fix condition accordingly.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: drop unused fields from struct pager
	* libpager/priv.h (struct pager): Drop fields next, pprev.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	term: fix memory leak
	I tested this change for some days and have not experienced any
	problems with it.

	* term/users.c (pi_destroy_hook): Fix memory leak.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Avoid compiler warning about empty bodies
	Make empty bodies of control flow statements more explicit.  Doing so
	will allow us to use stricter compiler settings.  This would have
	cought 4ece292c.

	* console-client/xkb/xkb.c: Make empty bodies more explicit
	* libpipe/pipe.c: Likewise.
	* mach-defpager/default_pager.c: Likewise.
	* pfinet/linux-src/net/ipv4/fib_hash.c: Likewise.
	* pflocal/connq.c: Likewise.
	* pflocal/socket.c: Likewise.

2014-05-26  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix type of dir_cache_id, node_cache_id
	* libdiskfs/name-cache.c (struct lookup_cache): Fix type of
	dir_cache_id, node_cache_id.

	pfinet: add missing include
	*  pfinet/linux-src/include/net/addrconf.h: Include ipv6.h.

	exec: add missing includes
	* exec/exec.c: Include mach/gnumach.h.
	* exec/main.c: Include device/device.h.

	libdiskfs: lock-less reference counting for peropen objects
	* libdiskfs/diskfs.h (struct peropen): Use refcount_t for field refcnt.
	* libdiskfs/peropen-make.c (diskfs_make_peropen): Initialize refcnt.
	* libdiskfs/peropen-rele.c (diskfs_release_peropen): Adjust accordingly.
	* libdiskfs/protid-make.c (diskfs_start_protid): Likewise.  Also, the
	node must no longer be locked, adjust comment accordingly.
	(diskfs_create_protid): Likewise.

2014-05-22  Justus Winter  <4winter@informatik.uni-hamburg.de>

	include: install refcount.h
	* include/Makefile (installhdrs): Add refcount.h.

2014-05-22  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: override fshelp_isowner
	As of recently, fakeroot would fail to create symlinks:

	% fakeroot-hurd ln -s foo a
	ln: failed to create symbolic link ‘a’: Operation not permitted

	Fix this by overriding fshelp_isowner.

	Various netfs functions will call fshelp_isowner to check whether USER
	is allowed to do some operation.  As fakeroot is not running within
	the fakeauth'ed environment, USER contains the real user.

	I have no explanation why this ever worked.

	* trans/fakeroot.c (fshelp_isowner): New function.

2014-05-22  Justus Winter  <4winter@informatik.uni-hamburg.de>

	include: add lock-less reference counting primitives
	* include/refcount.h: New file.

	libihash: add hurd_ihash_get_load
	* libihash/ihash.c (hurd_ihash_add): Move the code computing the load
	factor of the hash table...
	* libihash/ihash.h (hurd_ihash_get_load): ... here, together with the
	comment describing the method and the rationale for chosing binary
	percent.

	libihash: fix typo
	* libihash/ihash.c (hurd_ihash_add): Fix typo.

2014-05-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: move translation functions to mig-decls.h
	* proc/hash.c (reqport_find): Move this function...
	* proc/proc.h (process_drop): ... and this...
	* proc/mig-decls.h: ... here and rename them.
	* proc/mig-mutate.h: Update accordingly.

	trans/fakeroot: use C99-style struct initialization
	* trans/fakeroot.c (main): Use C99-style struct initialization to
	initialize argp.  This avoids a warning about missing field
	initializers.

	trans/fakeroot: fix comparison between signed and unsigned
	* trans/fakeroot.c (netfs_attempt_chown): Fix comparison between
	signed and unsigned integer expressions.

2014-05-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: remove spurious semicolon
	A spurious semicolon caused a control flow bug in check_openmodes,
	leading to a port leak.

	* trans/fakeroot.c (check_openmodes): Remove spurious semicolon.

2014-05-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: use fast binary scaling to determine the load
	Expressing the maximum load in binary percent (where 128b% corresponds
	to 100%) allows us to use fast binary scaling to determine if the
	maximum load has been reached without losing precision.

	Furthermore, the previously used expression 'ht->nr_items * 100'
	overflows int at 2^25 (unsigned int at 2^26).  When a hash table
	reached that limit, it would fail to resize and fill up the table.
	This change fixes that.

	* libihash/ihash.c (hurd_ihash_set_max_load): Update the comment.
	(hurd_ihash_add): Use fast binary scaling to determine the current
	load.
	* libihash/ihash.h (struct hurd_ihash): Update comment for max_load.
	(hurd_ihash_set_max_load): Update the comment.

2014-05-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: use linear probing and fast modulo operation
	libihash uses open addressing.  Previously, quadratic probing in both
	directions was used to resolve collisions.  Quadratic probing might
	result in a less efficient use of caches.

	Also, prime numbers of the form 4 * i + 3 were used as array sizes.
	This was used in combination with the integer modulo operation for
	hashing.  It has been known for some time that libihash suffers from
	collisions, so a integer hash function is now applied to the keys to
	derive the index.

	Use linear probing instead.  Also, use powers of two for the array
	sizes, so a bit mask can be used for the modulo operation.

	* libihash/ihash.c (ihash_sizes, ihash_nsizes): Remove.
	(find_index): Use linear probing and fast modulo operation.
	(add_one): Likewise.
	* libihash/ihash.h (HURD_IHASH_MIN_SIZE): New macro.

2014-05-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: use an integer hash function on the keys
	Use an integer hash function to derive the index from the key.  This
	should reduce the number of collisions.

	* libihash/ihash.c (hash_int32): New function.
	(find_index): Use hash_int32 on the key to derive the index.
	(add_one): Likewise.

2014-05-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: fix type of max_load
	Previously, int was used for the field max_load of struct hurd_ihash.
	There is no reason for this as far as I can tell.  Furthermore,
	hurd_ihash_set_max_load takes an unsigned int max_load.

	* libihash/ihash.h (struct hurd_ihash): Use unsigned int for field
	max_load.

2014-05-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: reduce the default maximum load factor to 75%
	The performance of hash tables depend critically on a low number of
	hash collisions.  As the table fills up, the chance of collisions
	necessarily raises.

	Previously, libihash resized the hash table when the load exceeded
	80%.  This seems a bit optimistic (e. g. java.util.Hashtable uses 75%
	as default).

	* libihash/ihash.h (HURD_IHASH_MAX_LOAD_DEFAULT): Set to 75.

2014-05-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: cache the superblock
	Previously, the superblock was mmaped and a pointer stored in sblock
	by map_hypermetadata.  This memory is backed by our disk pager.

	This is rather unfortunate, as this means that whenever we read a
	value from that location, we might generate a request our disk pager.
	This amplifies the so-called thread-storm problem.

	Rather than relying on a mmaped region of memory, just use the data
	loaded by get_hypermetadata.

	* ext2fs/hyper.c (get_hypermetadata): Do not free sblock.
	(mapped_sblock): New variable.
	(map_hypermetadata): Map the superblock to mapped_sblock instead.
	(diskfs_set_hypermetadata): Copy superblock into mapped_superblock.
	* ext2fs/ext2fs.h (get_hypermetadata, map_hypermetadata): Adjust
	comments accordingly.

2014-05-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: use two distinct pager buckets for the disk and file pager
	fatfs has two kinds of pagers.  One for the files, one for the disk.
	Previously, both were in the same port bucket.

	If a request for a file pager arrives, it most likely touches some
	metadata (like the superblock).  This is in turn backed by the disk
	pager, so another request is generated for the disk pager.

	Seperate all pagers clearly by using two port buckets.  This will
	enable us to use a single thread per port bucket in the future.

	* fatfs/pager.c (pager_bucket): Rename to...
	(disk_pager_bucket): ... this to make the change explicit at every
	occurrence.
	(file_pager_bucket): New variable.
	(service_paging_requests): New function.
	(create_fat_pager): Also create the file pager.
	(diskfs_get_filemap): Handout pagers from the file_pager_bucket.
	(diskfs_shutdown_pager): This is only concerned with the file pager.
	Simplify code accordingly.
	(diskfs_sync_everything): Likewise.
	(diskfs_pager_users): Likewise.
	(diskfs_max_user_pager_prot): Likewise.
	(disable_caching): Iterate over both buckets.
	(enable_caching): Likewise.

2014-05-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: unlock _ports_lock on malloc failure
	* libports/bucket-iterate.c (_ports_bucket_class_iterate): Unlock
	_ports_lock on malloc failure.

2014-05-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: use two distinct pager buckets for the disk and file pager
	ext2fs has two kinds of pagers.  One for the files, one for the disk.
	Previously, both were in the same port bucket.

	If a request for a file pager arrives, it most likely touches some
	metadata (like the superblock).  This is in turn backed by the disk
	pager, so another request is generated for the disk pager.

	Seperate all pagers clearly by using two port buckets.  This will
	enable us to use a single thread per port bucket in the future.

	* ext2fs/pager.c (pager_bucket): Rename to...
	(disk_pager_bucket): ... this to make the change explicit at every
	occurrence.
	(file_pager_bucket): New variable.
	(service_paging_requests): New function.
	(create_disk_pager): Also create the file pager.
	(diskfs_get_filemap): Handout pagers from the file_pager_bucket.
	(diskfs_shutdown_pager): This is only concerned with the file pager.
	Simplify code accordingly.
	(diskfs_sync_everything): Likewise.
	(diskfs_pager_users): Likewise.
	(diskfs_max_user_pager_prot): Likewise.
	(disable_caching): Iterate over both buckets.
	(enable_caching): Likewise.

2014-04-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	tmpfs: improve diskfs_node_iterate
	Currently, diskfs_node_iterate iterates twice over all nodes.  The
	first time only to determine the number of nodes.  Simply count them
	instead.

	* tmpfs/node.c (all_nodes_nr_items): New variable.
	(diskfs_free_node): Decrement all_nodes_nr_items.
	(diskfs_node_norefs): Likewise.
	(diskfs_cached_lookup): Increment all_nodes_nr_items.
	(diskfs_node_iterate): Fix type of sum_nodes, use all_nodes_nr_items.

2014-04-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: improve diskfs_node_iterate
	Currently, diskfs_node_iterate iterates twice over all nodes in the
	cache.  The first time only to determine the number of nodes currently
	in the cache.  Simply count them instead.

	* fatfs/inode.c (nodehash_nr_items): New variable.
	(diskfs_cached_lookup): Increment nodehash_nr_items.
	(diskfs_cached_lookup_in_dirbuf): Likewise.
	(diskfs_node_norefs): Decrement nodehash_nr_items.
	(diskfs_node_iterate): Fix the type of num_nodes, use nodehash_nr_items.

2014-04-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: improve diskfs_node_iterate
	Currently, diskfs_node_iterate iterates twice over all nodes in the
	cache.  The first time only to determine the number of nodes currently
	in the cache.  Simply count them instead.

	* ext2fs/inode.c (nodehash_nr_items): New variable.
	(diskfs_cached_lookup): Increment nodehash_nr_items.
	(diskfs_node_norefs): Decrement nodehash_nr_items.
	(diskfs_node_iterate): Fix the type of num_nodes, use nodehash_nr_items.

2014-04-30  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: simplify expression
	* fatfs/pager.c (add_pager_max_prot): Simplify expression.

2014-04-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: reduce malloc overhead in _ports_bucket_class_iterate
	_ports_bucket_class_iterate creates a snapshot of the buckets hash
	table.  This is done so that the lock protecting the hash table can be
	released while we iterate over the snapshot.

	Formerly, a linked list was used to store the snapshot.  As the
	maximal number of items is known, using an array is much simpler.

	_ports_bucket_class_iterate implements both ports_bucket_iterate and
	ports_class_iterate.  For this change might make ports_class_iterate
	less efficient memory-wise if the number of ports belonging to the
	class is low with respect to the number of ports in the bucket.  If
	this happens, we allocate too much.  Alleviate this by releasing
	unused memory.

	On the other hand, the array representation is more compact.
	Furthermore a survey of the Hurd code revealed that
	ports_class_iterate is rarely used, while ports_bucket_iterate is used
	more often, most prominently in paging code.

	* libports/bucket-iterate.c (_ports_bucket_class_iterate): Use an
	array instead of a linked list.

2014-04-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: simplify expression
	* ext2fs/pager.c (add_pager_max_prot): Simplify expression.

2014-04-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: fix type of inum
	Previously, inum was of type int, whereas dino_ref expects ino_t.  On
	Hurd/x86 the former is 32 bit wide, the latter 64.  If dino_ref is
	inlined, this does not seem to pose a problem, but if ext2fs is
	compiled with -O0, this most likely results in an invalid memory access.

	* ext2fs/ialloc.c (ext2_alloc_inode): Use type ino_t for inum.

2014-04-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: abbreviate the task name if necessary
	* exec/exec.c (do_exec): If the formatted task name exceeds
	TASK_NAME_SIZE, abbreviate it.

2014-04-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: work around bugs in server termination
	Some servers use ports_manage_port_operations_one_thread to process
	requests and terminate when it returns. Since many of them don't detach
	before shutting down, a client may receive an error if its request
	arrived while the server is shutting down. Prevent those spurious errors
	by forcing ports_manage_port_operations_one_thread not to return.

	This is the same change as 235491231bdd1fd93507c835767503f047e10b91
	introduced for ports_manage_port_operations_multithread.

	* libports/manage-one-thread.c
	(ports_manage_port_operations_one_thread): Force timeout to 0.

2014-04-29  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: set the default sync interval to 30 seconds
	The default sync interval has been changed in 9e55fdd7 from 30 to 5
	seconds.  This change was not reflected in the documentation.

	At least for current hardware, using 30 seconds instead of just 5
	alleviates the thread-storm problem.  Make 30 seconds the default
	again.

	* libdiskfs/priv.h (DEFAULT_SYNC_INTERVAL): Set to 30 seconds.

2014-04-22  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add missing receiver lookup fix
	following 7cb7fa6b3a0d02985b4a51f7823bc1cb631d6bfa

	* proc/mgt.c (S_proc_exception_raise): Do not dereference e on returning
	EINVAL, the translation functions does it for us.

2014-04-22  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

	Add TODO about fork() making rpctrace emit an error
	* utils/rpctrace.c (rewrite_right): Explain why the unknown send right
	error happens on fork().

2014-04-22  Ludovic Courtès  <ludo@gnu.org>

	build: Remove configure check for libcrypt.
	GNU libc has provided the 'crypt' function in libcrypt for a long time,
	making this check unnecessary.

	* configure.ac: Remove libcrypt check and 'LIBCRYPT' substitution.
	* config.make.in (LIBCRYPT): Remove.
	* trans/Makefile (password-LDLIBS): Change $(LIBCRYPT) to -lcrypt.
	* utils/Makefile (login-LDLIBS, addauth-LDLIBS, setauth-LDLIBS):
	  Likewise.

2014-04-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Include the MIG-generated server header files
	This enables the compiler to check that the server function
	declarations match MIGs expectations.  Fix a few oddities along the
	way.

	* console-client/trans.c: Include MIG-generated server header file(s).
	* console/console.c: Likewise.  Also, fix declarations.
	* console/mutations.h (TIOCTL_IMPORTS): Just use libnetfs/priv.h.
	* console/priv.h: Delete now unused file.
	* ext2fs/storeinfo.c: Include MIG-generated server header file(s).
	* fatfs/inode.c: Likewise.
	* fatfs/main.c: Likewise.  Also, fix declaration.
	* isofs/inode.c: Likewise.
	* libdiskfs/boot-start.c: Likewise.
	* libdiskfs/file-chg.c: Include the correct MIG-generated server header file.
	* libdiskfs/file-chmod.c: Include MIG-generated server header file(s).
	* libdiskfs/file-get-fs-opts.c: Likewise.
	* libdiskfs/init-startup.c: Likewise.
	* libnetfs/file-get-children.c: Likewise.
	* libnetfs/file-getcontrol.c: Include the correct MIG-generated server
	header file.
	* libnetfs/file-set-translator.c: Include MIG-generated server header file(s).
	* libnetfs/fsstubs.c: Likewise.
	* libtrivfs/file-access.c: Likewise.
	* libtrivfs/file-chauthor.c: Likewise.
	* libtrivfs/file-chflags.c: Likewise.
	* libtrivfs/file-chg.c: Likewise.
	* libtrivfs/file-chmod.c: Likewise.
	* libtrivfs/file-chown.c: Likewise.
	* libtrivfs/file-exec.c: Likewise.
	* libtrivfs/file-get-children.c: Likewise.
	* libtrivfs/file-get-fs-options.c: Likewise.
	* libtrivfs/file-get-source.c: Likewise.
	* libtrivfs/file-get-storage-info.c: Likewise.
	* libtrivfs/file-get-trans.c: Likewise.
	* libtrivfs/file-get-transcntl.c: Likewise.
	* libtrivfs/file-getcontrol.c: Likewise.
	* libtrivfs/file-getfh.c: Likewise.
	* libtrivfs/file-getlinknode.c: Likewise.
	* libtrivfs/file-lock.c: Likewise.
	* libtrivfs/file-reparent.c: Likewise.
	* libtrivfs/file-set-size.c: Likewise.
	* libtrivfs/file-set-trans.c: Likewise.
	* libtrivfs/file-statfs.c: Likewise.
	* libtrivfs/file-sync.c: Likewise.
	* libtrivfs/file-syncfs.c: Likewise.
	* libtrivfs/file-utimes.c: Likewise.
	* libtrivfs/fsys-forward.c: Likewise.
	* libtrivfs/fsys-get-options.c: Likewise.
	* libtrivfs/fsys-getroot.c: Likewise.
	* libtrivfs/fsys-goaway.c: Likewise.
	* libtrivfs/fsys-set-options.c: Likewise.
	* libtrivfs/fsys-stubs.c: Likewise.
	* libtrivfs/fsys-syncfs.c: Likewise.
	* libtrivfs/io-async-icky.c: Likewise.
	* libtrivfs/io-async.c: Likewise.
	* libtrivfs/io-duplicate.c: Likewise.
	* libtrivfs/io-identity.c: Likewise.
	* libtrivfs/io-map.c: Likewise.
	* libtrivfs/io-modes-get.c: Likewise.
	* libtrivfs/io-modes-off.c: Likewise.
	* libtrivfs/io-modes-on.c: Likewise.
	* libtrivfs/io-modes-set.c: Likewise.
	* libtrivfs/io-owner-get.c: Likewise.
	* libtrivfs/io-owner-mod.c: Likewise.
	* libtrivfs/io-pathconf.c: Likewise.
	* libtrivfs/io-read.c: Likewise.
	* libtrivfs/io-readable.c: Likewise.
	* libtrivfs/io-reauthenticate.c: Likewise.
	* libtrivfs/io-restrict-auth.c: Likewise.
	* libtrivfs/io-revoke.c: Likewise.
	* libtrivfs/io-seek.c: Likewise.
	* libtrivfs/io-select.c: Likewise.
	* libtrivfs/io-stat.c: Likewise.
	* libtrivfs/io-stubs.c: Likewise.
	* libtrivfs/io-version.c: Likewise.
	* libtrivfs/io-write.c: Likewise.
	* pfinet/tunnel.c: Likewise.
	* storeio/io.c: Likewise.
	* storeio/storeio.c: Likewise.
	* term/users.c: Likewise.
	* tmpfs/node.c: Likewise.
	* trans/fakeroot.c: Likewise.  Also, include all server headers that provide
	the X_server_routine functions...
	(netfs_demuxer): ... that were previously declared here.
	* trans/fifo.c: Include MIG-generated server header file(s).
	* trans/firmlink.c: Likewise.
	* trans/hello-mt.c: Likewise.
	* trans/hello.c: Likewise.
	* trans/magic.c: Likewise.
	* trans/mtab.c: Likewise.
	* trans/new-fifo.c: Likewise.
	* trans/null.c: Likewise.
	* trans/proxy-defpager.c: Likewise.
	* trans/streamio.c: Likewise.
	* libdiskfs/fsmutations.h: Qualify the import with the libraries path.
	Without this change, out-of-tree builds would no longer work.
	* libnetfs/mutations.h: Likewise.
	* libtrivfs/mig-mutate.h: Likewise.

2014-04-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: fix notify_port_t receiver lookups
	This fixes one more occurence of a notify_port_t receiver lookup that
	I overlooked in 5a4926dd52aed56913cbe10592063ff0da753700.

	* libpager/no-senders.c: Include "notify_S.h" so that the compiler can
	spot such mistakes in the future.
	(_pager_do_seqnos_mach_notify_no_senders): Fix receiver lookup.

2014-04-14  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: fix notify_port_t receiver lookups
	* libpager/mig-mutate.h: Add mutators.
	* libpager/notify-stubs.c: Adjust accordingly.

2014-04-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	console: fix notify_port_t receiver lookups
	This complements e9687ec4ff525ae4a88314ba4ae97da770bd012f.

	* console/display.c: Fix receiver lookups, adjust function declarations.
	* console/mutations.h: Add NOTIFY mutators.

2014-04-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	boot: remove the ourdevice hack
	Previously, the device definitions were filtered using sed to replace
	the device_t type with mach_port_send_t to make the device argument of
	device_open polymorphic.  Rather than doing that, which makes it
	impossible to use translation functions, the definition of device_open
	has been amended.

	* boot/Makefile: Remove the ourdevice hack.
	* boot/boot.c: Adjust the include accordingly.

2014-04-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	console-client: drop DIST_FILES from Makefile
	Since 50bfb9acf98d5f4c0c5948cc28285e990b40b659 git is used to produce
	dist tarballs.

	* console-client/Makefile (DIST_FILES): Do not set obsolete variable.

2014-04-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: fix receiver lookup
	* libports/interrupt-operation.c (ports_S_interrupt_operation): Fix
	receiver lookup.
	* libports/mig-mutate.h: Add mutators.
	* libports/ports.h: Remove superfluous declarations.

	hurd: add a new type interrupt_t for the interrupt protocol
	* hurd/hurd_types.defs (interrupt_t): New type.
	* hurd/hurd_types.h (interrupt_t): Likewise.
	* hurd/interrupt.defs (interrupt_operation): Use the new type.

2014-04-06  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: fix notify_port_t receiver lookups
	* libports/Makefile (MIGSFLAGS): Include mig-mutate.h.
	* libports/mig-decls.h: New file.
	* libports/mig-mutate.h: Likewise.
	* libports/notify-dead-name.c: Fix receiver lookups.
	* libports/notify-no-senders.c: Likewise.
	* libports/notify-msg-accepted.c: Adjust function declaration.
	* libports/notify-port-deleted.c: Likewise.
	* libports/notify-port-destroyed.c: Likewise.
	* libports/notify-send-once.c: Likewise.
	* libports/ports.h: Likewise.
	* proc/Makefile (MIGSFLAGS): Include mig-mutate.h, move PROCESS mutators...
	* proc/mig-mutate.h: ... into a new file, add NOTIFY mutators.
	* proc/notify.c: Fix receiver lookups, adjust function declarations.
	* term/devio.c (ports_do_mach_notify_send_once): Adjust accordingly.

2014-04-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix receiver lookup
	* libdiskfs/Makefile (exec_startup-MIGSFLAGS): New variable.
	* libdiskfs/diskfs.h (struct bootinfo): New struct declaration.
	(diskfs_begin_using_bootinfo_port): New function.
	(diskfs_end_using_bootinfo): Likewise.
	* libdiskfs/fsmutations.h: Add mutators for exec_startup_t.
	* libdiskfs/priv.h (bootinfo_t): New type declaration to appease mig.
	* libdiskfs/boot-start.c (S_exec_startup_get_info): Fix receiver lookup.

	exec: fix receiver lookup
	* exec/Makefile (exec_startup-MIGSFLAGS): New variable.
	* exec/execmutations.h: Add mutators for exec_startup_t.
	* exec/mig-decls.h: New file.
	* exec/priv.h (bootinfo_t): New type declaration to appease mig.
	* exec/exec.c (S_exec_startup_get_info): Fix receiver lookup.

	hurd: add a new type for the exec_startup protocol
	* hurd/hurd_types.defs (exec_startup_t): New type.
	* hurd/hurd_types.h (exec_startup_t): Likewise.
	* hurd/exec_startup.defs: Honor EXEC_STARTUP_IMPORTS.
	(exec_startup_get_info): Use the new type as receiver.

2014-04-04  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

2014-04-04  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix spurious unlock on error
	Thanks Cyril Roelandt for finding the issue.

	* libdiskfs/dir-renamed.c (diskfs_rename_dir): On diskfs_lookup error,
	set fnp to NULL to avoid unlocking it spuriously.

2014-04-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: fix receiver lookups
	Previously, the receiver lookup was done manually in all the server
	functions.  Use mig translator functions instead.

	* libpager/mig-decls.h: New file.
	* libpager/mig-mutate.h: Likewise.
	* libpager/Makefile (MIGSFLAGS): Include mig-mutate.h.
	* libpager/chg-compl.c: Fix receiver lookups.
	* libpager/data-request.c: Likewise.
	* libpager/data-return.c: Likewise.
	* libpager/data-unlock.c: Likewise.
	* libpager/lock-completed.c: Likewise.
	* libpager/object-init.c: Likewise.
	* libpager/object-terminate.c: Likewise.
	* libpager/stubs.c: Likewise.
	* libpager/seqnos.c (_pager_update_seqno): Move the actual
	functionality...
	(_pager_update_seqno_p): ... into a new function that can be called
	with a pointer to struct pager.
	* libpager/priv.h (_pager_update_seqno_p): New declaration.

2014-03-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Handle fonts with multiple-of-8 bbox width
	* console-client/vga-dynafont.c (dynafont_new): When the bbox width of
	the font is a multiple of 8, set width to 8.  Reject any other value
	than 8 or 9 with EINVAL.

	Fix setting LGE flag
	* console-client/vga-support.c (vga_set_font_width): Fix setting the
	`VGA_ATTR_MODE_LGE' flag.

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

2014-03-26  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Align VGA buffers
	Some "hardware" (such as kvm on linux 3.2) would hang when transferring
	between video memory and unaligned main memory.  This also allows
	better optimized transfers anyway.

	Thanks Petter Reinholdtsen for the report and patient tests.

	* console-client/vga-support.c (vga_state): Force maximum alignment of
	`videomem' and `fontmem' fields.

2014-03-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: replace the magic typecast with a hash table
	Previously, the mach-defpager used a "magic typecast" for object
	lookups.  It renamed the port to the address of the associated object,
	and upon receiving a message it would cast the port name back to a
	pointer.

	While this might seem like an optimization, it actually makes the port
	handling in the kernel less efficient.  Ports with small continuous
	names are stored in an array, while other ports get spilled in a splay
	tree.

	Replace the linked list of default_port_t objects with a hash table.
	Do not rename the ports, rather use the hash table to lookup objects
	associated with ports.

	* mach-defpager/default_pager.c (struct pager_port): Replace queue
	with hash table, remove count, move type declaration to priv.h.
	(pager_port_list_init): Adjust accordingly.
	(pager_port_list_insert): Likewise.
	(pager_port_list_delete): Likewise.
	(destroy_paging_partition): Replace queue_iterate with HURD_IHASH_ITERATE.
	(S_default_pager_objects): Likewise.
	(S_default_pager_object_pages): Likewise.
	(seqnos_memory_object_create): Do not rename the port but store it in
	the hash table.
	(S_default_pager_object_create): Likewise.
	* mach-defpager/priv.h (struct dstruct): Add fast-removal pointer.
	(pnameof): Remove obsolete macro definition.
	(dnameof): Likewise.
	* mach-defpager/mig-decls.h (begin_using_default_pager): Replace the
	magic typecast with a hash table lookup.
	* mach-defpager/Makefile (HURDLIBS): Add ihash.

2014-03-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix local includes
	* mach-defpager/default_pager.c: Fix local includes.
	* mach-defpager/main.c: Likewise.
	* mach-defpager/setup.c: Likewise.

2014-03-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix receiver lookups
	Previously, the receiver lookup was done manually in all the server
	functions.  Use mig translator functions instead.

	* mach-defpager/mig-decls.h: New file.
	* mach-defpager/mig-mutate.h: Likewise.
	* mach-defpager/Makefile (MIGSFLAGS): Include mig-mutate.h.
	* mach-defpager/mach-defpager.c: Fix receiver lookups, move type
	definitions...
	* mach-defpager/priv.h: ... here, so that they can be used in
	mig-decls.h.

2014-03-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: fix receiver type, honor DEFAULT_PAGER_IMPORTS
	* hurd/default_pager.defs: Honor DEFAULT_PAGER_IMPORTS.
	(default_pager_object_set_size): Fix receiver type.

2014-03-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix string termination
	Found using the Clang Static Analyzer.

	* libdiskfs/fsys-getroot.c (diskfs_S_fsys_getroot): Fix string
	termination.

2014-03-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	isofs: also copy the terminating zero in read_symlink_hook
	* isofs/inode.c (read_symlink_hook): Use memcpy, also copy terminating
	zero.

2014-03-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: fix potential deadlock
	This patch releases the interlock before doing an rpc call, analogous
	to 901c61a1d25e7c8963e51012760a82730eda1910.

	* libpager/pager-attr.c (pager_change_attributes): Release interlock
	before calling memory_object_change_attributes, to let the callbacks
	take it.

2014-03-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: fix comment of pager_change_attributes
	* libpager/pager-attr.c: Fix comment.
	* libpager/pager.h: Likewise.

2014-03-20  Gabriele Giacone  <1o5g4r8o@gmail.com>

	Make bz2 and gz support optional
	* config.make.in (HAVE_LIBBZ2, HAVE_LIBZ): New variables.
	* configure.ac (--without-libbz2, --without-libz): New options.
	* ext2fs/Makefile (OTHERLIBS): Make -lbz2 and -lz optional.
	* fatfs/Makefile (OTHERLIBS): Likewise.
	* isofs/Makefile (OTHERLIBS): Likewise.
	* libstore/Makefile (maybe_part): Remove variable.
	(store-types): Add part, bunzip2 and gunzip support conditionnally.
	(LDLIBS): Make -lbz2 and -lz optional.
	(OBJS): Add GUNZIP_OBJS and BUNZIP2_OBJS optional.

2014-03-16  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix handling of console readlink errors
	* console-client/trans.c (netfs_attempt_lookup): Look for errors returned by
	`readlink' before allocating a node.
	(netfs_attempt_readlink): Look for errors returned by `readlink'.

	Fix vcs_readlink propagating error returned by console_current_id
	* console-client/current-vcs.c (vcs_readlink): Return error returned by
	`console_current_id' as a negative value.

	Fix crash on accessing vcs without a console being active
	* console-client/current-vcs.c (vcs_readlink): Return error as negative
	values.
	(vcs_read): Convert errors returned by vcs_readlink before returning
	them.

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

	Fix crash on opening /dev/kbd or mouse without any console being active
	* console-client/console.c (console_switch_away): Check for `active_vcons`
	being NULL before saving the currently active console.

2014-03-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: silently ignore requests to page to active partition
	Currently, if mach-defpager is asked to page to an already active
	partition, it ignores this request and returns success.  It does,
	however, print a message about this to stdout.

	This message might indicate to the user that there is some kind of a
	problem with the configuration of the machine, even though the code in
	new_partition clearly does not consider it an error to do such an
	request.

	* mach-defpager/default_pager.c (new_partition): Do not print a
	message if requested to page to an already active partition.

2014-03-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix type of size arguments
	* mach-defpager/default_pager.c (new_partition): Fix type of bsize.
	* mach-defpager/file_io.h (page_read_file_direct): Fix type of size argument.
	(page_write_file_direct): Likewise.
	* mach-defpager/setup.c (page_read_file_direct): Likewise.
	(page_write_file_direct): Likewise.

	mach-defpager: fix warnings about uninitialized variables
	* mach-defpager/default_pager.c (S_default_pager_objects): Initialize
	address, size-pairs to 0.
	(S_default_pager_object_pages): Likewise.
	* mach-defpager/kalloc.c (kget_space): Likewise.

2014-03-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix warning about uninitialized variable
	Previously, failure to look up the given partition was detected after
	the loop by checking whether the loop ran over all existing
	partitions.  Initialize part to NULL and check for that instead.  This
	retains the behavior, but expresses it in a way the compiler
	understands better.

	* mach-defpager/default_pager.c (destroy_paging_partition): Initialize
	part to NULL and check for it still being NULL after the loop.

2014-03-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix error handling in S_default_pager_object_set_size
	Fix a compiler warning about kr being potentially being uninitialized.

	* mach-defpager/default_pager.c (S_default_pager_object_set_size):
	Initialize kr.

2014-03-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: add and use synchronized_printf for dprintf
	* mach-defpager/default_pager.c (synchronized_printf): New function.
	(printf_lock): Move to synchronized_printf.
	(dprintf): Use synchronized_printf.
	(ddprintf): Likewise.

	mach-defpager: fix warnings about unused variables
	* mach-defpager/default_pager.c (pager_alloc): Declare variables only
	when needed.
	(dealloc_direct): Remove unused variables.
	(seqnos_memory_object_terminate): Remove unused variable, adjust
	ddprintfs accordingly.
	(seqnos_memory_object_data_write): Remove unused variable.

2014-03-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: remove comments around form feeds
	Form feed characters (\f) are whitespace and are treated as such by c
	compilers.  There is no need to enclose them in comments.

	* mach-defpager/default_pager.c: Remove comments around form feeds.

2014-03-01  Justus Winter  <4winter@informatik.uni-hamburg.de>

	auth: improve the mig mutator functions
	Previously, the mig mutator function auth_port_to_handle was defined
	in auth.c (fakeauth.c), preventing it from being inlined into the
	mig-generated server functions.  Put it in mig-decls.h instead.
	Rename authmutations.h to mig-mutate.h, auth_mig.h to mig-decls.h.
	This is the naming convention used for pflocal.

	* auth/auth.h: New file.
	* auth/auth_mig.h: Rename to mig-decls.h, add copyright notice, define
	mutator functions.
	* auth/authmutations.h: Rename to mig-mutate.h, restore copyright
	notice, adjust accordingly.
	* auth/auth.c: Include auth.h, remove auth_port_to_handle.
	* utils/fakeauth.c: Likewise.
	* auth/Makefile: Adjust accordingly.
	* utils/Makefile: Likewise.

2014-03-01  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/ifsock: fix receiver lookup
	* trans/Makefile: Add ifsock-MIGSFLAGS.
	* trans/ifsock.c (S_ifsock_getsockaddr): Fix receiver lookup.

2014-02-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	term: fix receiver lookups in the term server functions
	* term/mig-mutate.h: Define TERM_IMPORTS.
	* term/Makefile: Set term-MIGSFLAGS.
	* term/users.c: Fix receiver lookups in the term server functions.

	term: fix receiver lookups in the tioctl server functions
	* term/mig-mutate.h: New file.
	* term/Makefile: Set tioctl-MIGSFLAGS.
	* term/ptyio.c: Fix receiver lookups in the tioctl server functions.
	* term/users.c: Likewise.

2014-02-27  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: fix receiver lookups in iioctl-ops.c
	* pfinet/iioctl-ops.c: Fix receiver lookups.
	* pfinet/mig-mutate.h: Add IIOCTL_IMPORTS.
	* pfinet/Makefile: Set iioctl-MIGSFLAGS.

	hurd: add IIOCTL_IMPORTS
	* hurd/iioctl.defs: Add IIOCTL_IMPORTS.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libtrivfs: improve the mig mutator functions
	Previously, the mig mutator functions were in migsupport.c, preventing
	them from being inlined into the mig-generated server functions.  Put
	them in mig-decls.h instead.  Rename mutations.h to mig-mutate.h.
	This is the naming convention used for pflocal.

	* libtrivfs/fsmutations.h: Rename to mig-mutate.h, adopt imports.
	* libtrivfs/Makefile: Adopt accordingly.
	* libtrivfs/migsupport.c: Rename to mig-decls.h.
	* libtrivfs/trivfs.h: Move dynamic classes/buckets declarations to
	mig-decls.h, remove superfluous imports.
	* exec/execmutations.h: Fix import.
	* pfinet/mig-mutate.h: Likewise.
	* trans/Makefile: Likewise.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: improve the mig mutator functions
	Previously, the mig mutator functions were in misc.c, preventing them
	from being inlined into the mig-generated server functions.  Put them
	in mig-decls.h instead.  Rename mutations.h to mig-mutate.h.  This is
	the naming convention used for pflocal.

	* pfinet/mutations.h: Rename to mig-mutate.h, adopt imports.
	* pfinet/Makefile: Adopt accordingly.
	* pfinet/mig-decls.h: New file.
	* pfinet/misc.c: Move mutator functions to mig-decls.h.
	* pfinet/pfinet.h: Move type declarations to mig-decls.h, remove
	mutator declarations.
	* pfinet/iioctl-ops.c: Include mig-decls.h.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix receiver lookups in fsys server functions
	* libdiskfs/diskfs.h (struct diskfs_control): New declaration.
	(diskfs_begin_using_control_port): New declaration and function.
	(diskfs_end_using_control_port): Likewise.
	* libdiskfs/fsmutations.h: Add translation functions.
	* libdiskfs/priv.h (control_t): New type declaration for mig.
	* libdiskfs/boot-start.c: Fix receiver lookups.
	* libdiskfs/fsys-getfile.c: Likewise.
	* libdiskfs/fsys-getroot.c: Likewise.
	* libdiskfs/fsys-goaway.c: Likewise.
	* libdiskfs/fsys-options.c: Likewise.
	* libdiskfs/fsys-syncfs.c: Likewise.

	libnetfs: fix receiver lookups in fsys server functions
	* mutations.h: Add translation functions.
	* netfs.h (struct netfs_control): New declaration.
	* priv.h: Define translation functions.
	* fsys-get-options.c: Fix receiver lookups.
	* fsys-getroot.c: Likewise.
	* fsys-goaway.c: Likewise.
	* fsys-set-options.c: Likewise.
	* fsys-syncfs.c: Likewise.
	* fsysstubs.c: Likewise.

	New RPCs, fix build

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/mtab: do not map unknown source strings to "none"
	Previously, map_device_to_path mapped unknown device strings to
	"none".  Return a copy of the original source string instead so that
	e.g. nfs mount point points are properly handled.

	* trans/mtab.c (map_device_to_path): Do not map unknown source strings
	to "none".

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	tmpfs: set diskfs_disk_name to "none"
	By default diskfs_disk_name is returned as the source of
	libdiskfs-based translators.  Hurds fstab allows multiple entries with
	the mnt_fsname being "none".

	* tmpfs/tmpfs.c (diskfs_disk_name): Set to "none".

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/mtab: ignore translators that do not implement file_get_source
	Previously, the mtab translator would guess the source of a filesystem
	translator from its last argument.  This made all kinds of
	non-filesystem translators appear in /proc/mounts, causing severe
	problems due to umount --all removing vital passive translator
	records.

	Fix this by ignoring all translators that do not explicitly implement
	file_get_source.

	* trans/mtab.c (mtab_populate): Ignore translators that do not
	implement file_get_source.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	nfs: implement netfs_get_source
	Implement netfs_get_source so that nfs translators show up in
	/proc/mounts.

	* nfs/main.c (netfs_get_source): New function.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	hurd: fix the get-children and get-source procedures
	* hurd/fs.defs: Add file_get_children and file_get_source.
	* hurd/fsys.defs: Remove fsys_get_children and fsys_get_source.
	* libdiskfs/fsys-get-children.c: Rename and adapt accordingly.
	* libdiskfs/fsys-get-source.c: Likewise.
	* libnetfs/fsys-get-children.c: Likewise.
	* libnetfs/fsys-get-source.c: Likewise.
	* libtrivfs/fsys-get-children.c: Likewise.
	* libtrivfs/fsys-get-source.c: Likewise.
	* libdiskfs/diskfs.h: Adapt prototype and comment.
	* libnetfs/netfs.h: Likewise.
	* libtrivfs/trivfs.h: Likewise.
	* libdiskfs/get-source.c: Adapt default implementation, provide
	diskfs_disk_name by default.
	* libnetfs/netfs.h: Adapt default implementation.
	* libtrivfs/get-source.c: Likewise.
	* libdiskfs/Makefile: Adapt accordingly.
	* libnetfs/Makefile: Likewise.
	* libtrivfs/Makefile: Likewise.
	* trans/symlink.c: Likewise.
	* trans/mtab.c: Likewise.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: improve the default_pager_demux_object function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.

	* mach-defpager/default_pager.c (default_pager_demux_object): Improve
	the demuxer function.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: add function mig_reply_setup
	Currently, mig_reply_setup is not provided by libmachuser or the
	glibc.  Provide it locally.

	* mach-defpager/default_pager.c (mig_reply_setup): New function.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix definition of seqnos_memory_object_data_unlock
	* mach-defpager/default_pager.c (seqnos_memory_object_data_unlock):
	Fix function arguments.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libpager: improve the pager_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* libpager/demuxer.c (pager_demuxer): Improve the demuxer function.

2014-02-25  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/umount: do not remove passive translator records
	Passive translator records are a Hurd concept.  Therefore, the umount
	compatibility program should not remove them.

	* utils/umount.c (passive_flags): Unset FS_TRANS_SET.
	(doc): Adjust accordingly.

2014-02-25  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix fakeroot and remap parsing corner cases
	Fix case when $PWD contains spaces.
	Pass directly arguments to command, to directly avoid escaping issues.
	Based on suggestion by Ivan Shmakov <oneingray@gmail.com>

	* utils/fakeroot.sh (TARGET): Do not define.
	(sh): Rather pass PWD and commandline as parameters.
	* utils/remap.sh: Likewise.

2014-02-23  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: provide a meaningful name for new tasks
	The name will be used in error messages printed by the kernel.  This
	makes attributing the errors to processes possible.

	* exec/exec.c (do_exec): Set the name of the new task.

2014-02-22  Richard Braun  <rbraun@sceen.net>

	pfinet: set a non-zero ports management timeout
	* pfinet/main.c (main): Call ports_manage_port_operations_multithread
	with non-zero timeouts.

2014-02-22  Richard Braun  <rbraun@sceen.net>

	libports: work around bugs in server termination
	Most servers use ports_manage_port_operations_multithread to process
	requests and terminate when it returns. Since many of them don't detach
	before shutting down, a client may receive an error if its request
	arrived while the server is shutting down. Prevent those spurious errors
	by forcing ports_manage_port_operations_multithread not to return.

	* libports/manage-multithread.c
	(ports_manage_port_operations_multithread): Force global_timeout to 0.

2014-02-19  Ignazio Sgalmuzzo  <ignaker@gmail.com>

	libstore: fixed some pointer-sign related warnings
	libstore/do-bunzip2.c: fixed type modifier, avoiding cast

2014-02-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add missing copyright notice

2014-02-19  Ignazio Sgalmuzzo  <ignaker@gmail.com>

	libstore: replaced gz decompression code with libz
	Note: dropped .zip support

	configure.ac: added check for libz
	ext2fs/Makefile: linked libz
	fatfs/Makefile: linked libz
	isofs/Makefile: linked libz
	libstore/Makefile: linked libz
	libstore/do-gunzip.c: new decompression function using libz calls.
	libstore/gunzip.c: removed no longer needed code replaced by do_gunzip()
	libstore/gzip.h: deleted, no longer needed
	libstore/inflate.c: deleted: no longer needed
	libstore/tailor.h: deleted: no longer needed
	libstore/unzip.c: deleted: no longer needed
	libstore/util.c: removed no longer needed code.

2014-02-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

	Add missing copyright notice

2014-02-14  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix typo
	* libdiskfs/boot-start.c (diskfs_S_fsys_init): Fix typo.

2014-02-13  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Add --font-width option to force 8/9 pixel font width
	This permits to choose between 720x400 or 640x400 textmode without
	changing the font.

	* console-client/vga-hw.h (VGA_ATTR_MODE_ADDR, VGA_ATTR_MODE_LGE,
	VGA_ATTR_ENABLE_ADDR): New macros.
	* console-client/vga-support.c (vga_state): Add `attr_mode' field.
	(vga_init): Save attribute mode subregister content.  Re-enable the
	screen after that.
	(vga_fini): Restore attribute mode subregister content.  Re-enable the
	screen after that.
	(vga_set_font_width): When the font width is set to 9, enable VGA LGE to
	properly handle box-drawing unicode characters.  Re-nable the screen
	after that.
	(vga_exchange_palette_attributes): Use VGA_ATTR_ENABLE_ADDR macro
	instead of harcoded 0x20.
	* console-client/vga-dynafont.h (dynafont_new): Add `width' parameter.
	* console-client/vga-dynafont.c (dynafont): Add `width' field.
	(dynafont_new): Add `width' parameter, stored in `width' field of `df',
	but using the font bbox as default value.  Use it to decide whether to
	use VGA LGE or not.
	(dynafont_activate): Use `width' field of `df' instead of the font bbox
	to configure the VGA glyph width.
	* console-client/vga.c (vga_display_font_width): New variable.
	(vga_display): New `df_width' field.
	(argp_option): New `font-width' option.
	(parse_opt): Handle `font-width' option.
	(vga_display_init): Copy `vga_display_font_width' to `disp'.
	(vga_display_start): Pass `df_width' to `dynafont_new'.

2014-02-12  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

	Fix typos

2014-02-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: add bz2 to OTHERLIBS
	* fatfs/Makefile (OTHERLIBS): Add bz2.

	isofs: add bz2 to OTHERLIBS
	* isofs/Makefile (OTHERLIBS): Add bz2.

2014-02-09  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

2014-02-09  Ignazio Sgalmuzzo  <ignaker@gmail.com>

	Replaced bz2 decompression code with libbz2
	configure.ac: added check for libbz2
	libstore/Makefile: linked libbz2
	ext2fs/Makefile: linked libbz2
	do-bunzip2.c: rewritten do_bunzip2 using libbz2 calls. Removed no longer needed functions.

2014-02-07  Richard Braun  <rbraun@sceen.net>

	trans/fakeroot: fix cached node retrieval on lookup
	When a client finds a node from the hash table, it could happen that
	another thread is still holding one reference on it before the current
	thread has acquired its own. Simply checking for a non zero refcount isn't
	enough, the new client must atomically acquire its own reference.

	* trans/fakeroot.c (netfs_S_dir_lookup): Find and acquire node reference
	while holding netfs_node_refcnt_lock.

2014-02-06  Richard Braun  <rbraun@sceen.net>

	trans/fakeroot: fix netfs_S_dir_lookup
	* trans/fakeroot.c (netfs_S_dir_lookup): Fix node dereference.

2014-02-05  Richard Braun  <rbraun@sceen.net>

	trans/fakeroot: rework node caching
	Instead of the FAKE_REFERENCE flag, rework node caching so that nodes are
	retained only if their attributes are actually changed. In addition, don't
	remove unreferenced nodes from the hash table at protid release, since
	their reference counter is unstable. Do it on node destruction, once the
	reference counter has reached 0. This means lookups can return nodes not
	referenced (other than by the hash table), a condition for which a check
	is added. By never acquiring a reference on such nodes, their counter is
	guaranteed to remain stable once unreferenced.

	* trans/fakeroot.c (FAKE_REFERENCE): Remove macro.
	(FAKE_DEFAULT): New macro.
	(set_default_attributes): New function.
	(set_faked_attribute): Likewise.
	(netfs_node_norefs): Remove node from hash table, properly taking care
	of all the locks involved.
	(fakeroot_netfs_release_protid): Remove node handling code, merely call
	netfs_release_protid.
	(netfs_S_dir_lookup): Handle unreferenced nodes, call set_default_attributes
	on node creation, remove call to netfs_attempt_chown.
	(netfs_attempt_chown): Call set_faked_attribute instead of accessing faked
	flags directly.
	(netfs_attempt_chauthor): Likewise.
	(netfs_attempt_chmod): Likewise.
	(main): Likewise.

2014-02-05  Richard Braun  <rbraun@sceen.net>

	trans/fakeroot: fix chmod
	Unconditionally relay chmod requests instead of filtering those that
	don't change the executable bit.

	* trans/fakeroot.c (netfs_attempt_chmod): Unconditionally call file_chmod
	with an unaltered mode.

2014-02-05  Richard Braun  <rbraun@sceen.net>

	Revert "trans: fix locking issue in fakeroot"
	This reverts commit 672005782e57e049c7c8f4d6d0b2a80c0df512b4.

	That change is apparently not needed and introduced a deadlock.

	* trans/fakeroot.c (netfs_attempt_mkfile): Unlock directory node before
	creating new node.

2014-02-05  Richard Braun  <rbraun@sceen.net>

	trans/fakeroot: fix right leak
	* trans/fakeroot.c (netfs_S_dir_lookup): Deallocate rights to intermediate
	file systems.

2014-02-05  Justus Winter  <4winter@informatik.uni-hamburg.de>

	daemons/getty: always print a newline before the banner
	* daemons/getty.c (load_banner): Drop first newline from default banner.
	(print_banner): Print a newline.

2014-02-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: connect std{in,out,err} to the mach console
	* exec/main.c (S_exec_init): Get the device master port and connect
	std{in,out,err} to the mach console.

2014-01-31  Justus Winter  <4winter@informatik.uni-hamburg.de>

	daemons/getty: display /etc/issue if available
	Previously, a banner was hardcoded in Hurds getty.  Load /etc/issue
	instead.  Fall back to a hardcoded version if that fails.  Expand
	common \char sequences.  If no /etc/issue is provided, the old
	behavior is retained.

	* daemons/getty.c (load_banner): New function.
	(print_banner): Expand \char sequences.

2014-01-30  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Fix crash on fsysopts when pfinet has no IPv6
	* pfinet/options.c (add_dev_opts): Use a for loop over `idev->addr_list'
	instead of a while loop which assumes that it is not empty.

2014-01-29  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	pfinet: really deallocate device port
	* pfinet/ethernet.c (ethernet_close): Call mach_port_deallocate on
	device port.

2014-01-28  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Also re-open Ethernet device on EMIG_SERVER_DIED
	* pfinet/ethernet.c (ethernet_xmit): Also call ethernet_close then
	ethernet_open on EMIG_SERVER_DIED error.

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

	Make pfinet re-open ethernet device on transmission error
	* pfinet/ethernet.c (ethernet_close): New function.
	(ethernet_xmit): On EMACH_SEND_INVALID_DEST error, call ethernet_close
	and ethernet_open again to re-open ethernet device.

2014-01-26  Richard Braun  <rbraun@sceen.net>

	libnetfs: fix file locking on peropen release
	* libnetfs/release-peropen.c (netfs_release_peropen): Release the lock on
	the underlying node if the peropen status indicates it's not unlocked.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: fix the receiver lookup in S_proc_exception_raise
	* proc/mgt.c (S_proc_exception_raise): Update accordingly.
	* proc/mig-decls.h: New file.
	* proc/proc_exc.defs: Add translation functions.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils: include the mig-generated server headers in fakeauth.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* utils/fakeauth.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	auth: include the mig-generated server headers in auth.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* auth/auth.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pflocal: include the mig-generated server headers
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* pflocal/demuxer.c: Include the mig-generated server headers.
	* pflocal/sserver.c: Likewise.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: include the mig-generated server headers in main.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* pfinet/main.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: include the mig-generated server headers in main.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* proc/main.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: include the mig-generated server headers in main.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* exec/main.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libtrivfs: include the mig-generated server headers in demuxer.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* libtrivfs/demuxer.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libnetfs: include the mig-generated server headers in demuxer.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* libnetfs/demuxer.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: include the mig-generated server headers in demuxer.c
	GNU MIG recently gained support for emitting x_server_routine
	declarations in the generated server header file.  Using this
	declaration, the x_server_routine functions can be inlined into the
	demuxer function.

	* libdiskfs/demuxer.c: Include the mig-generated server headers.

2014-01-20  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix the receiver lookup in password
	Use translation functions instead of doing the lookup manually.

	* trans/Makefile (password-MIGSFLAGS): Add mutators.
	* trans/password.c (S_password_check_user): Update accordingly.
	(S_password_check_group): Likewise.

2014-01-19  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Rename variables with the name "error" to "err".
	The canonical name for variables of the type error_t is err.  There
	are, however, places where the variable is called error instead.  This
	is unfortunate, as this shadows the error function.  Rename such
	variables to err.

	For reference, this is accomplished using the following semantic
	patch:

	@@
	expression E;
	@@
	-error_t error = E;
	+error_t err = E;
	<...
	-error
	+err
	...>

	@@
	@@
	-error_t error;
	+error_t err;
	<...
	-error
	+err
	...>

	* libdiskfs/dir-link.c: Rename error to err.
	* libdiskfs/dir-unlink.c: Likewise.
	* libdiskfs/file-get-trans.c: Likewise.
	* libdiskfs/file-get-transcntl.c: Likewise.
	* libdiskfs/file-set-trans.c: Likewise.
	* libdiskfs/fsys-getroot.c: Likewise.
	* libshouldbeinlibc/wire.c: Likewise.

2014-01-16  Richard Braun  <rbraun@sceen.net>

	libps: fix task/thread times fetching
	Introduce PSTAT_TIMES to force the retrieval of both PSTAT_TASK_BASIC
	and PSTAT_THREAD_BASIC. Task basic info contain the user and system
	times of terminated threads which the code wrongly assumes is always
	present along with process info.

	* libps/procstat.c (add_preconditions): Set both PSTAT_TASK_BASIC and
	PSTAT_THREAD_BASIC as preconditions for PSTAT_TIMES.
	(summarize_thread_basic_info): Add terminated threads times only if
	task basic info are available.
	(set_procinfo_flags): Provide summarize_thread_basic_info with flags of
	available info.
	(proc_stat_set_flags): Set PSTAT_TIMES as available if it was needed and
	any of PSTAT_TASK_BASIC or PSTAT_THREAD_BASIC could be fetched.
	* libps/ps.h (PSTAT_TIMES): New macro.
	* libps/spec.c (ps_get_usr_time): Indicate the getter needs PSTAT_TIMES
	instead of PSTAT_THREAD_BASIC.
	(ps_sys_time_getter): Likewise.
	(ps_tot_time_getter): Likewise.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libnetfs: register passive translator startups
	Detect passive translator startup and add the resulting active
	translator to the list of active translators.

	* libnetfs/dir-lookup.c (netfs_S_dir_lookup): Detect and register
	  passive translator startup.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: register passive translator startups
	Detect passive translator startup and add the resulting active
	translator to the list of active translators.

	Note that newpi is properly deallocated in the function epilogue.

	* libdiskfs/dir-lookup.c (diskfs_S_dir_lookup): Detect and register
	  passive translator startup.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libfshelp: fix the api of fshelp_set_active_translator
	To detect if an active translator goes away, we need to register for
	dead name notifications. Those notifications have to be sent to a port
	known to the ports library, as the ports library handles the dead name
	notifications. The most straight forward way is to use the port to the
	underlying node for that. To that end, a reference to the port_info
	struct is handed in and kept in the list of active translators.

	This commit also moves the registration of dead name notifications to
	libfshelp.

	* libfshelp/fshelp.h (fshelp_set_active_translator): Add port_info argument.
	* libfshelp/translator-list.c (struct translator): Add port_info pointer.
	(translator_ihash_cleanup): Dereference port_info object.
	(fshelp_set_active_translator): Register dead name notifications.
	* libdiskfs/file-set-trans.c (diskfs_S_file_set_translator): Update
	  accordingly.
	* libnetfs/file-set-translator.c (netfs_S_file_set_translator): Likewise.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/mtab: do not include non-filesystem translators by default
	Traditionally, /proc/mounts includes only filesystem mount points.
	Previously though, the mtab translator included any kind of
	translator, like all /hurd/storeio translators.  This causes problems
	with umount --all as this would remove the passive translator records
	from nodes in /dev.

	Fix this by only listing filesystem-like translators by default.
	Filesystem-like translators are identified by their response to
	dir_readdir messages sent to their root node.

	* trans/mtab.c (all_translators): New variable.
	(options): Add flag to preserve the old behavior.
	(parse_opt): Handle the new flag.
	(is_filesystem_translator): New function.
	(mtab_populate): Skip non-filesystem translators by default.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/mtab: make the translator multithreaded
	* trans/mtab.c (main): Use ports_manage_port_operations_multithread.

	trans/mtab: properly lock mtab objects
	* trans/mtab.c (struct mtab): Add lock.
	(open_hook): Initialize lock.
	(close_hook): Destroy lock.
	(trivfs_S_io_read): Lock mtab object, adjust error handling accordingly.
	(trivfs_S_io_seek): Likewise.
	(trivfs_S_io_readable): Likewise.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/mtab: remove the loop detection logic
	Previously the mtab detector tried to detect whether it talks to
	itself by comparing the control port of the translator it currently
	visits with its own. This was done to prevent deadlocks. However, this
	did not detect non-trivial loops, i.e. two mtab translators would
	still dead-lock each other.

	Now that it is safe to actually file_name_lookup the root node of a
	mtab translator without triggering the generation of content, this
	logic can just be omitted.

	* trans/mtab.c (mtab_populate): Remove the loop detection logic.

2014-01-12  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/mtab: populate mtab objects on demand
	Previously the mtab content was generated in the open hook. Delay this
	until the data is needed. A follow up patch will take advantage of
	this to both simplify the logic in mtab_populate and make it more
	robust at the same time.

	* trans/mtab.c (open_hook): Do not eagerly populate the mtab.
	(trivfs_S_io_read): Populate the mtab struct on demand.
	(trivfs_S_io_seek): Likewise.
	(trivfs_S_io_readable): Likewise.

2013-12-30  Richard Braun  <rbraun@sceen.net>

	libps: fix process user and system times
	Include the run time of terminated threads in the user and system times
	of processes.

2013-12-28  Richard Braun  <rbraun@sceen.net>

	libports: remove the threadvars stack size hack
	Setting the stack size should now correctly be supported by libpthread.

	* libports/manage-multithread.c (__pthread_stack_default_size): Remove
	global variable.

2013-12-19  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: shutdown the translator if the last client is gone
	Previously, fakeroot would not exit if a process outlived the original
	process started by settrans.  This caused bugs like this:

	% fakeroot-hurd /bin/sh -c 'sleep 1&' 2>&1 | tee
	<hangs>

	Fix this by exiting if the last client of fakeroot goes away.

	If noone has a right to any control or protid port, noone can ever
	reacquire any such right. So it is safe to shutdown the fakeroot
	translator in that case.

	* trans/fakeroot.c (fakeroot_netfs_release_protid): Shutdown the
	translator if the last protid object is destroyed and no control port
	is around either.

2013-12-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: fix output so that replies can be attributed to requests
	Currently, it is impossible to properly attribute response messages to
	requests.  Even though rpctrace is single-threaded, its tracee may
	not.  Or there might be more than one tracee.  In any such case it is
	not guaranteed that the reply message we just processed is for the
	request we just printed.  Fix this by printing ellipsis with the port
	name, so that reply messages can be properly attributed:

	task129(pid3312)->mach_port_allocate (3) ...134
	task129(pid3312)->mach_port_deallocate (pn{  1}) ...160
	134... = 0 pn{ 30}
	160... = 0

	* utils/rpctrace.c (last_reply_port): New variable.
	(print_ellipsis): New function.
	(print_request_header): Optionally print ellipsis and update
	last_reply_port.
	(print_reply_header): Likewise.

2013-12-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: escape non-printable characters in strings
	* utils/rpctrace.c (escape_sequences): New char array mapping
	characters to their escape sequence.
	(print_data): Escape non-printable characters when printing strings.

2013-12-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: handle MACH_MSG_TYPE_PORT_SEND rights in trace_and_forward
	This allows one to rpctrace processes doing select(2).

	* utils/rpctrace.c (trace_and_forward): Handle MACH_MSG_TYPE_PORT_SEND
	rights.

2013-12-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: generalize tracing code
	Currently, rpctrace dies if a tracee uses select(2) because it asserts
	that reply_type is a MACH_MSG_TYPE_PORT_SEND_ONCE right.  Generalize
	the code surrounding the failing assertion.

	* utils/rpctrace.c (trace_and_forward): Generalize code by switching
	over reply_type.

2013-12-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/rpctrace: generalize code in rewrite_right
	* utils/rpctrace.c (rewrite_right): Generalize the code so we can use
	rewrite_right to rewrite MACH_MSG_TYPE_PORT_SEND rights for non-rpc ports.

2013-12-13  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/mount: fix autodetection of fat file systems
	mount uses libblkid (if available) to detect the file system type when
	using mount -t auto.  libblkid calls fat file systems "vfat", our fat
	translator is called "fatfs".  Fix this discrepancy in mount.

	* utils/mount.c (do_mount): Fix autodetection of fat file systems.

2013-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: remove dead code
	* trans/fakeroot.c (netfs_S_dir_lookup): Remove dead code.

	trans/fakeroot: remove dead code
	* trans/fakeroot.c (netfs_S_dir_lookup): Remove dead code.

	trans/fakeroot: drop else
	* trans/fakeroot.c (netfs_S_dir_lookup): Drop else.

2013-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans/fakeroot: fix ownership of newly created files
	Previously, files created in the fakeroot environment were created
	with the uid and gid of the user running fakeroot:

	% fakeroot-hurd /bin/sh -c 'touch /tmp/$$; stat --format=%u:%g /tmp/$$'
	1000:1000

	* trans/fakeroot.c (netfs_S_dir_lookup): Fix ownership of newly
	created files.

2013-12-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils/settrans: fix the teardown of chrooted environments
	Previously, settrans --chroot would just exec the target.  Create a
	new process for that purpose.  Wait for its completion, then ask the
	translator (nicely by default) to go away.  If it refuses with EBUSY,
	it might be because some process has daemonized inside the chrooted
	environment.

	This fixes the following bug when settrans is used with fakeroot:

	% fakeroot-hurd /bin/true 2>&1 | tee
	<hangs>

	Here, fakeroot-hurd execs settrans with --chroot, settrans execs
	/hurd/fakeauth which will eventually exec the target /bin/true.  When
	true terminates, it will close its stdout and stderr.  But
	/hurd/fakeroot's stderr is also connected to tee's stdin, preventing
	tee from exiting.

	* utils/settrans.c (main): Fix the teardown of chrooted environments.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	console-client: remove spurious pthread_spin_unlocks
	* console-client/trans.c (netfs_attempt_mkfile): Remove spurious
	  pthread_spin_unlock.
	(netfs_node_norefs): Likewise.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: unlock nodes with faked attributes in fakeroot
	When a node has faked attributes, we cannot drop our node.
	Reinitialize the lock box as if the node was dropped.  This fixes the
	following bug:

	% fakeroot-hurd /bin/sh -c 'touch /tmp/$$.lock
	                            chown 0 /tmp/$$.lock
	                            l(){ flock /tmp/$$.lock true; }; l; l'
	<hangs>

	* trans/fakeroot.c (fake_node_dropweak): Unlock the node if the last
	  real reference is dropped but we keep a fake one.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: improve the error handling in fakeauth
	Previously the node was not correctly torn down if adding the newly
	created netnode to the hash table failed.  Fix this by rearranging the
	code, doing the hash table modification first because it is easier to
	undo.

	* trans/fakeroot.c (new_node): Fix the error handling.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix reference counting bug in fakeroot
	The function new_node creates virtual nodes using netfs_make_node.
	Nodes created with netfs_make_node already have a reference count of
	one.  Currently another reference is added in new_node.  This prevents
	the destruction of the node causing bugs like this:

	% fakeroot-hurd sh -c 'l(){ flock /tmp/$$.lock true; }; l; l'
	<hangs>

	* trans/fakeroot.c (new_node): Fix reference count of newly created
	  nodes.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix locking in fakeroot's netfs_S_dir_lookup
	* trans/fakeroot.c (netfs_S_dir_lookup): Fix locking.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix reference counting and destruction of fake nodes
	Previously, fakeroot tried to do too much in netfs_node_norefs.  This
	function is meant to deallocate nodes.  Fakeroot however also tries to
	remove the node from the hash table and to prolong the lifetime of the
	node object by re-referencing it.

	Removing the object from the hash table is highly problematic, because
	at this point we already have the node locked.  With proper locking in
	netfs_S_dir_lookup, acquiring the hash table lock while we hold the
	node locked results in dead-locks, releasing the node lock before
	acquiring the hash table lock results in a race condition.

	Prolonging the lifetime of the node by re-acquiring a reference is
	clearly a hack that surprisingly works to some degree.  The nodes
	transbox, however, is already gone at this point.

	This code was never actually run because of a reference-counting bug
	in fakeroot.

	Fix this by installing our own clean routine in the
	netfs_protid_class.  This function is called without the associated
	node being locked, allowing us to acquire the locks in the proper
	order and to keep the hash table locked while the node is being
	destroyed.

	* trans/fakeroot.c (netfs_node_norefs): Just free the associated
	resources.
	(fakeroot_netfs_release_protid): New function doing cleanly what
	netfs_node_norefs did before.
	(netfs_S_dir_lookup): Reuse the fake reference.
	(main): Install fakeroot_netfs_release_protid as clean routine.

	fixup_fix_refc_destruction

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: return nodes locked when creating fake nodes in fakeroot
	* trans/fakeroot.c (new_node): Acquire the nodes lock before releasing
	  the idport_ihash_lock.  Return nodes locked.
	(netfs_S_dir_lookup): Drop lock.
	(netfs_attempt_mkfile): Likewise.
	(main): Likewise.

	trans: fix locking issue in fakeroot
	* trans/fakeroot.c (netfs_attempt_mkfile): Keep dir locked until the
	  new node is created.

	trans: handle invalid responses to dir_lookup requests in fakeroot
	* trans/fakeroot.c (netfs_S_dir_lookup): Handle invalid responses to
	  dir_lookup requests.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: improve the performance of dir_lookup in fakeroot
	Previously any FS_RETRY_NORMAL requests were handed back to the
	client.  Redo the lookup ourself instead.  This saves us the burden to
	create a fake node for the intermediate step, hand it back to the
	client and handle another request from the client.

	With this change there is no need to fiddle with the permission bits
	as it was previously done.

	* trans/fakeroot.c (netfs_S_dir_lookup): Redo the lookup transparently
	  for the user if FS_RETRY_NORMAL is requested.

	fixup_improve_perf

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix the use of the hash table in fakeroot.c
	Previously a pointer to the node was stored in the hash table. This
	writes the locp pointer into the node object overwriting the next
	pointer there. Store the pointer to the netnode instead.

	* trans/fakeroot.c (struct netnode): Add field np.
	(new_node): Initialize field np.
	(new_node): Store nn instead of np into the hash table.
	(netfs_S_dir_lookup): Adjust accordingly.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libihash: remove dead code
	* libihash/ihash.c (hurd_ihash_add): Remove dead code.

2013-12-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libfshelp: use a hash table in get-identity.c
	Currently fshelp_get_identity uses ports_class_iterate to de-duplicate
	the identity ports. Use a hash table instead.

	* libfshelp/get-identity.c (struct idspec): Remove field fileno.
	(struct idspec): Add field id_hashloc.
	(id_clean): New function.
	(id_initialize): Use id_clean as cleanup function for idclass.
	(fshelp_get_identity): Use a hash table to de-duplicate the identity
	ports.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: make the fakeroot environment more transparent
	Previously fakeroot did not explicitly proxy io_identity requests, so
	the default implementation from libnetfs handled them. But as the fsys
	identity port returned was always netfs_fsys_identity, this broke the
	getcwd logic (assuming /media/scratch is a translator):

	% cd /media/scratch/foo && fakeroot-hurd pwd
	/foo

	Fix this by proxying io_identity requests. Since then no-one is
	handing out our netfs_fsys_identity port anymore, an optimization in
	netfs_fsys_identity is made obsolete by this change.

	* trans/fakeroot.c (netfs_S_dir_lookup): Adjust code accordingly.
	(netfs_S_io_identity): New function.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix transparent reauthentication in fakeroot
	When looking up files, fakeroot intercepts reauthentication requests
	and executes io_reauthenticate and auth_user_authenticate
	transparently for the client. This, however, makes the client
	incorrectly assume that the lookup is finished (assuming
	/media/scratch is a translator):

	% cd /media/scratch && fakeroot-hurd pwd
	pwd: reading directory `..': Bad file descriptor

	Make the reauthentication completely transparent to the client by
	re-doing the lookup ourselves.

	* trans/fakeroot.c (netfs_S_dir_lookup): Fix transparent reauthentication.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: fix the creation of files in fakeroot
	Previously, fakeroot failed to create files in certain circumstances,
	e. g. assuming /tmp is a tmpfs and /tmp/some_file does not exist:

	% cd /tmp && fakeroot-hurd /bin/sh -c ':>/tmp/some_file'
	/bin/sh: 1: cannot create /tmp/some_file: Is a directory

	Fix this by sanitizing the flags value not to contain O_WRITE if we're
	not at the last path component.

	* trans/fakeroot.c (netfs_S_dir_lookup): Strip O_WRITE from flags when
	  looking up all but the last path component.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: improve the netfs_demuxer function in fakeroot.c
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* trans/fakeroot.c (netfs_demuxer): Improve the demuxer function.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	trans: remove unused declaration from fakeroot.c
	Any messages we do not intercept are forwarded to the underlying file.

	* trans/fakeroot.c (netfs_demuxer): Remove unused declaration of
	  function netfs_ifsock_server.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils: improve the auth_demuxer function in fakeauth.c
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* utils/fakeauth.c (auth_demuxer): Improve the demuxer function.

2013-12-04  Justus Winter  <4winter@informatik.uni-hamburg.de>

	auth: improve the auth_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* auth/auth.c (auth_demuxer): Improve the demuxer function.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pflocal: improve the demuxer functions
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* pflocal/pflocal.c (pf_demuxer): Improve the demuxer function.
	* pflocal/sserver.c (sock_demuxer): Likewise.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	pfinet: improve the pfinet_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* pfinet/main.c (pfinet_demuxer): Improve the demuxer function.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: improve the message_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* proc/main.c (message_demuxer): Improve the demuxer function.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	exec: improve the exec_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	Furthermore, move the exec_startup_server_routine to the end of the
	chain, as the startup related functions are only needed at system
	bootstrap time.

	* exec/main.c (exec_demuxer): Improve the demuxer function.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libtrivfs: improve the trivfs_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* libtriv/demuxer.c (trivfs_demuxer): Improve the demuxer function.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libnetfs: improve the netfs_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	* libnetfs/demuxer.c (netfs_demuxer): Improve the demuxer function.

2013-12-02  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: improve the diskfs_demuxer function
	Handle multiple request types as recommended by the Mach Server
	Writer's Guide section 4, subsection "Handling Multiple Request
	Types".  This avoids initializing the reply message in every X_server
	function.  The reply message has already been properly initialized in
	libports, so there is no need to call mig_reply_setup.

	Furthermore, move diskfs_exec_startup_server_routine to the end of the
	chain, as the startup related functions are only needed at system
	bootstrap time in the root filesystem.

	* libdiskfs/demuxer.c (diskfs_demuxer): Improve the demuxer function.

2013-11-30  Richard Braun  <rbraun@sceen.net>

	libports: another right leak fix
	* libports/manage-multithread.c (adjust_priority): Deallocate host
	right before returning.

2013-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libfshelp: improve error handling in fshelp_start_translator_long
	Properly deallocate all ports and terminate the started translator if
	an error occurs.

	* libfshelp/start-translator-long.c (fshelp_start_translator_long):
	  Improve error handling.

2013-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: store the device master port in _hurd_device_master
	* proc/host.c (S_proc_getprivports): Adapt accordingly.
	* proc/main.c (main): Store the device master port in _hurd_device_master.
	* proc/proc.h (master_device_port): Remove unused variable.

2013-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: store the privileged host port in _hurd_host_priv
	Store the privileged host port in _hurd_host_priv like it is done in
	the root filesystem. This fixes the thread priority adjustment in the
	proc server. Prior to this fix, a warning message "unable to adjust
	libports thread priority" sometimes appeared early in the boot
	process.

	* proc/host.c (S_proc_getprivports): Adapt accordingly.
	(S_proc_register_version): Likewise.
	* proc/mgt.c (add_tasks): Likewise.
	* proc/msg.c (tickle_init): Likewise.
	* proc/main.c (main): Store the privileged host port in _hurd_host_priv.
	* proc/proc.h: Remove unused variable master_host_port.

	fixup_store_priv_port

2013-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: improve error reporting in adjust_priority
	By using error instead of perror, the warning can be proprely
	attributed to the process.

	* libports/manage-multithread.c (adjust_priority): Use error instead
	  of perror to print the warning.

2013-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: improve error reporting in diskfs_start_disk_pager
	* libdiskfs/disk-pager.c (diskfs_start_disk_pager): Improve error reporting.

	libports: improve error handling in ports_transfer_right
	* libports/transfer-right.c (ports_transfer_right): Improve error handling.

	libports: improve error handling in ports_reallocate_from_external
	* libports/reallocate-from-external.c (ports_reallocate_from_external):
	  Improve error handling.

	libports: improve error handling in ports_reallocate_port
	* libports/reallocate-port.c (ports_reallocate_port): Improve error
	  handling.

	proc: update comments
	* proc/main.c (main): Update comment. The proc server is no longer PID 0.
	* proc/proc.h: Likewise.

	init: fix port leak
	* init/init.c (S_startup_essential_task): Fix port leak.

2013-11-28  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: fix minor port leak in maptime_map
	Deallocate the device port after creating the mapping. The mapping is
	independent of the device port.

	* libshouldbeinlibc/maptime.c (maptime_map): Deallocate device port.

2013-11-26  Richard Braun  <rbraun@sceen.net>

	libports: fix right leaks when adjusting priorities
	* libports/manage-multithread.c (adjust_priority): Deallocate processor set
	rights before returning.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: fix error handling in maptime_map
	Found using the Clang Static Analyzer.

	* libshouldbeinlibc/maptime.c (maptime_map): Fix error handling.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: drop all register qualifiers
	* mach-defpager/default_pager.c: Drop register qualifiers.
	* mach-defpager/kalloc.c: Likewise.
	* mach-defpager/queue.h: Likewise.
	* mach-defpager/wiring.c: Likewise.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	usermux: actually use the computed flags value in netfs_attempt_utimes
	If either atime or mtime is NULL, the respective time should be set to
	the current time.

	Found using the Clang Static Analyzer.

	* usermux/node.c (netfs_attempt_utimes): Use flags in call to
	  fshelp_touch.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	nfsd: fix error handling in op_remove
	Found using the Clang Static Analyzer.

	* nfsd/ops.c (op_remove): Fix error handling.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: fix error handling in diskfs_get_directs
	Found using the Clang Static Analyzer.

	* fatfs/dir.c (diskfs_get_directs): Fix error handling.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	fatfs: fix error handling in diskfs_lookup_hard
	Found using the Clang Static Analyzer.

	* fatfs/dir.c (diskfs_lookup_hard): Fix error handling.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libps: fix the length computation in fprint_frac_value
	Found using the Clang Static Analyzer.

	* libps/spec.c (fprint_frac_value): Fix computation of value_len.

2013-11-21  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils: fix dead initialization
	Found using the Clang Static Analyzer.

	* utils/frobauth.c (posix_parse_opt): Fix dead initialization.
	(no_ugids_parse_opt): Likewise.

2013-11-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Merge branch 'master' of git.savannah.gnu.org:/srv/git/hurd/hurd

2013-11-19  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	Make sure created netfs nodes have stat validated
	Just like it always is in libnetfs' normal netfs_S_dir_lookup.

	* trans/fakeroot.c (netfs_S_dir_lookup): Call netfs_validate_stat after
	calling new_node.

2013-11-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: implement lockless management of threads
	ports_manage_port_operations_multithread uses two values, totalthreads
	and nreqthreads, to manage the threads it creates.  Previously a lock
	was used to synchronize the access to them. Use atomic operations
	instead.

	* libports/manage-multithread.c (ports_manage_port_operations_multithread):
	  Use atomic operations instead of a lock to synchronize the access to
	  totalthreads and nreqthreads.

2013-11-16  Justus Winter  <4winter@informatik.uni-hamburg.de>

	Clean up the included header files
	* libihash/ihash.c: Clean up the included header files.
	* libshouldbeinlibc/cacheq.c: Likewise.
	* libshouldbeinlibc/canon-host.c: Likewise.
	* libshouldbeinlibc/fsysops.c: Likewise.
	* libshouldbeinlibc/idvec-auth.c: Likewise.
	* libshouldbeinlibc/idvec.c: Likewise.
	* libshouldbeinlibc/idvec.h: Likewise.
	* libshouldbeinlibc/localhost.c: Likewise.
	* libshouldbeinlibc/maptime.c: Likewise.
	* libshouldbeinlibc/nullauth.c: Likewise.
	* libshouldbeinlibc/portxlate.c: Likewise.
	* libshouldbeinlibc/shared-dom.c: Likewise.
	* libshouldbeinlibc/ugids-argp.c: Likewise.
	* libshouldbeinlibc/ugids-auth.c: Likewise.
	* libshouldbeinlibc/ugids-imply.c: Likewise.
	* libshouldbeinlibc/ugids-merge.c: Likewise.
	* libshouldbeinlibc/ugids-subtract.c: Likewise.
	* libshouldbeinlibc/ugids-verify-auth.c: Likewise.
	* libshouldbeinlibc/ugids-verify.c: Likewise.
	* libshouldbeinlibc/ugids.c: Likewise.
	* libshouldbeinlibc/ugids.h: Likewise.
	* libshouldbeinlibc/wire.c: Likewise.

2013-11-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: do not remove -Wall from CFLAGS
	Bother, said Pooh.

	* Makefile: Do not remove -Wall from CFLAGS.

2013-11-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: fix the page offsets returned by pager_pages
	Previously the increment was outside the loop body, turning it into a
	dead increment.

	Move the increment into the loop body as it is done in the true branch
	above. This fixes the offsets recorded in the default_pager_page_t
	objects.

	Found using the Clang Static Analyzer.

	* mach-defpager/default_pager.c (pager_pages): Fix returned page offsets.

2013-11-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: fix dead assignment
	Found using the Clang Static Analyzer.

	* libshouldbeinlibc/timefmt.c (fmt_past_time): Fix dead assignment,
	  normalize adjacent white space.

2013-11-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	ext2fs: fix error handling
	Found using the Clang Static Analyzer.

	* ext2fs/dir.c (diskfs_lookup_hard): Fix error handling.

2013-11-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: fix error handling
	Found using the Clang Static Analyzer.

	* libdiskfs/dir-renamed.c (diskfs_rename_dir): Fix error handling.

2013-11-15  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libdiskfs: remove dead assignment
	Found using the Clang Static Analyzer.

	* libdiskfs/io-write.c (diskfs_S_io_write): Remove dead assignment.

2013-11-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils: implement portinfo --search
	Implement the --search switch of portinfo. The feature was suggested
	in the source code and partly implemented. portinfo --search locates
	the target ports (or all ports) in any other process and prints the
	port mapping and information about the port in the remote process.

	* utils/Makefile: Link portinfo against libps.
	* utils/portinfo.c (options): Enable --search option.
	(search_for_port): New function.
	(search_for_ports): Likewise.
	(main): Call search_for_port{,s} as appropiate.

2013-11-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libshouldbeinlibc: fix reference counting in port_name_xlator_create
	Both task ports are deallocated in the destructor, so they must be
	referenced in the constructor.

	* libshouldbeinlibc/portxlate.c (port_name_xlator_create): Fix
	  reference counting.

2013-11-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: include errno.h
	* mach-defpager/default_pager.c: Include errno.h.

2013-11-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: turn count_up and store_pid into normal functions
	Previously count_up and store_pid were defined inside
	S_proc_getallpids. Move them out of that function and declare them
	static.

	* proc/mgt.c: Turn count_up and store_pid into normal functions.

2013-11-10  Justus Winter  <4winter@informatik.uni-hamburg.de>

	term: fix error handling in hurdio_mdmctl
	hurdio_mdmctl allows one to set and clear bits from the modem control
	bit vector. However, plausible code paths exist that leave oldbits
	uninitialized. Fix this by returning an error instead if retrieving
	the oldbits failed and the bit set or clear operation was selected.

	Found using the Clang Static Analyzer.

	* term/hurdio.c (hurdio_mdmctl): Fix error handling.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: remove unused variables
	Found using the Clang Static Analyzer.

	* mach-defpager/default_pager.c (seqnos_memory_object_terminate):
	  Remove unused variables request_refs and name_refs.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	mach-defpager: turn dealloc_direct into a normal function
	* mach-defpager/default_pager.c (dealloc_direct): Move function
	  definition outside of pager_truncate.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	auth: fix use of uninitialized variable err
	Previously a plausible execution path existed so the value of err was
	undefined at the end of the function, making the function return
	arbitrary error values. Fix this by initializing it to 0.

	Found using the Clang Static Analyzer.

	* auth/auth.c (S_auth_server_authenticate): Initialize err to 0.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	init: fix memory leak
	Found using the Clang Static Analyzer.

	* init/init.c (process_signal): Fix memory leak.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: fix error handling in S_proc_exception_raise
	Found using the Clang Static Analyzer.

	* proc/mgt.c (S_proc_exception_raise): Fix error propagation.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: fix a use-after-free error
	If we have to create a new process group, we have to do this before
	leaving the current one. The current process group is deallocated if
	the process is the last process in that group. Likewise, if the
	current group was the last group in the current groups session, the
	session is deallocated.

	Found using the Clang Static Analyzer.

	* proc/pgrp.c (S_proc_setpgrp): Fix use-after-free error.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: fix the declaraton of genpid
	* proc/proc.h (genpid): Fix declaration.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	proc: remove declaration of nested functions from proc.h
	Remove the declaration of count_up and strore_pid from proc.h. The
	functions are defined as nested functions in S_proc_getallpids, there
	is no need to declare them. Furthermore, the declaration does not
	match the definition.

	* proc/proc.h: Remove declaration of count_up and strore_pid.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	utils: implement settrans --pid-file
	This switch makes settrans write the pid file of the active translator
	it starts to a file. This makes the pid easily retrievable for test
	suites.

	* utils/settrans.c (options): Add --pid-file.
	(main): Add variable pid_file.
	(parse_opt): Handle --pid-file switch.
	(open_node): Write pid file.

2013-11-09  Justus Winter  <4winter@informatik.uni-hamburg.de>

	libports: fix the thread counts in case the thread creation fails
	Previously the number of total threads and the number of unused
	threads was wrong if at one point the creation of a thread failed. Fix
	this by decrementing both counters that were previously optimistically
	incremented. Adjust the comment accordingly.

